Sat Jul 25  11:03:24 BST 2020 Alan Buckley <alan_baa@hotmail.com>
     
	* recipe/files/gcc/libunixlib/kernel/kosbget.s: Fix osbget
	as it was always returning an error

Fri Jul 24 16:46:05 BST  2020  Lee Noar  <lee.noar@sky.com>

	* include/pthread.h(PTHREAD_COND_INITIALIZER): Swap order
	to match struct __pthread_cond.

Thu Jul 23 17:47:04 BST  2020  Lee Noar  <lee.noar@sky.com>

	* ctype/isblank.c: New file. Implement isblank function.
	* Makefile.am: Add above file to build.
	* include/ctype.h(isblank): The isblank() macro should return
	TRUE if the given character is a space or a tab. The other
	macros use the territory module to determine their values,
	but this doesn't seem possible for isblank(). Instead, test
	for the characters directly. It seems unlikely that different
	territories would interpret space and tab differently to what
	we would expect.
	Note that I did consider the fact that the macro argument
	appears twice and may be an issue for side effects, but
	isprint() also uses its argument twice.

Thu Jul 23 16:46:03 BST  2020  Lee Noar  <lee.noar@sky.com>

	* include/pthread.h(struct __pthread_cond): Swap "waiting" and
	"clock_id" positions in an attempt to retain compatibility with
	older versions of Unixlib. The GCCSDK release 3 version of Unixlib
	(and other libraries built against it) expect "waiting" to be at
	offset 0 of the struct and future releases should ensure that it
	remains so.

Wed Jul 22 16:23:02 BST  2020  Lee Noar  <lee.noar@sky.com>

	* pthread/cond.c(pthread_cond_init): Fix bug introduced
	in r7252. The attr parameter can be NULL, which means
	use default values. Fixes pthread_cond_init failure in
	python3.

Sat Jun 20 21:08:10 BST  2020  Lee Noar  <lee.noar@sky.com>

	* unix/ul_select.c(select): Additional fix to time calculation
	to round up to the next clock update frequency.
	Submitted by Alan Buckley.

Wed Jun 10 13:49:10 BST  2020  Lee Noar  <lee.noar@sky.com>

	* gcccompat/atomics.c(__cmpxchg): Provide a non-ARMv7 version for
	GCC 4.

Sun May 31 20:03:19 BST  2020  Lee Noar  <lee.noar@sky.com>

	* signal/_signal.s(__h_event): Fix use of wrong register.

Thu May  7 20:35:36 BST  2020  Lee Noar  <lee.noar@sky.com>

	* unix/ul_select.c(select): Fix time calculation so that the tv_usec
	part of the timeout is not ignored.
	Submitted by Chris Johns.

Wed Apr  8 18:23:09 BST  2020  Lee Noar  <lee.noar@sky.com>

	* module/sul.s: Bump version number to 1.16.
	More changes to the way we clean up on exit from GCC 8.2 programs.
	When using fork/exec, don't call SWI XARMEABISupport_Cleanup until
	all children have returned, otherwise we delete all the parent stacks
	and cause the machine to lock up. Instead, if a process has a
	parent, just delete the stack of the returning child.
	* incl-local/internal/asm_dec.s: Make ARMEABISupport symbols names
	consistent.
	(SULPROC_STACK): Add.
	* incl-local/internal/unix.h(__sul_process.stack_handle): Add to
	record handle of main stack so that SUL can delete it.
	* sys/_syslib.s: For ARMEABI, create a fake 4 byte stack in application
	space so that sul_fork can correctly move the process up if necessary.
	Record the handle of the main stack in the process structure so that if
	we are a child process, SUL can delete it.
	* unix/unix.c: Remove riscos_abi_version definition now that we have
	the --riscos-abi command line option for GCC 4.

Mon Mar 16 16:20:20 GMT  2020  Lee Noar  <lee.noar@sky.com>

	* include/fcntl.h(O_CLOEXEC): Alternative version of O_EXECCL.
	* include/unistd.h(_SC_NPROCESSORS_ONLN): Add symbol.
	* unix/sysconf.c(sysconf): Handle _SC_NPROCESSORS_ONLN. Simply
	returns 1 as the number of online processors.
	* Makefile.am: Add new files eventfd.{c/h}.
	* incl-local/internal/dev.h: Add EventFD as a new device.
	* include/sys/eventfd.h: New file.
	* unix/dev.c: Add EventFD to device array.
	* unix/eventfd.c: New file to implement eventfd(), etc.

	EventFD can be used as an event wait/notify mechanism instead of using
	pipes. Unlike pipes, EventFD does not use files in its implementation
	and should therefor be more efficient.
	Where eventfd() is available, libglib (GWakeup) will make use of it
	instead of using pipes.

Mon Nov 25 21:27:10 GMT  2019  Lee Noar  <lee.noar@sky.com>

	* signal/_signal.s(__h_error): Fix backtrace originating from error
	handler for ARMEABI.

Tue Oct 15 17:13:48 BST  2019  Lee Noar  <lee.noar@sky.com>

	* crt/{g}crt0.s: Only support .init_array/.fini_array in ARMEABI build.
	* sys/_syslib.s: Only process .init_array for ARMEABI, abi-2.0
	programs will not have entries in crt0.s for this.

Tue Oct 15 14:51:16 BST  2019  Lee Noar  <lee.noar@sky.com>

	* incl-local/internal/asm_dec.s(SULPROC_STATUS_FLAG_IS_FORKED,
	SULPROC_STATUS_FLAG_IS_EXECED): Define.
	* module/sul.s(sul_exit): Rewrite logic of when to call
	XSOM_DeregisterClient and XARMEABISupport_Cleanup. TST instruction
	can be difficult to understand!
	* pthread/context.c: Silence compiler warning.

Tue Oct 15 14:42:01 BST  2019  Lee Noar  <lee.noar@sky.com>

	* string/_memset-v7l.s: Remove rogue #include.

Sun Sep 29 20:45:45 BST  2019  Lee Noar  <lee.noar@sky.com>

	* sys/exec.c(execve): For a non-chunked stack, don't call __stackalloc_trim.

Sun Sep 29 20:41:24 BST  2019  Lee Noar  <lee.noar@sky.com>

	Main highlights:
	Add support for GCC 8 (ARMEABI).
	Improve pthread performance/reliability

	* configure.ac: Check if the compiler sets __ARM_EABI__ and
	set a variable accordingly so that we can check in the makefile.
	* Makefile.am: For ARM_EABI, add NEON optimised versions of memcpy,
	memmove, memset and strlen written by RISC OS Open.
	Add wmissing.c.
	For ARM_EABI, compile without a chunked stack.
	* common/_exist.s: Load PIC register via macro.
	* common/_riscosify.s: Likewise.
	* common/_taskhandle.s: Likewise.
	* pthread/_exit.s: Likewise.
	* sys/_cpucaps.s: Likewise.
	* crt/crt0.s: Add support for .init_array/.fini_array.
	* crt/gcrt0.s: Likewise.
	* gen-auto.pl: Don't generate misc/abi.c. For GCC 8,
	binutils will set this on the command line. This will be
	the case for GCC 4 in the future.
	* gmon/gmon-start.c: Not currently supported in ARM_EABI/GCC 8.
	* incl-local/internal/asm_dec.s: Add symbols for ARMEABISupport module.
	Add symbols for init_array/fini_array support.
	Add symbols for a pthread fast access structure.
	* incl-local/internal/elf-macros.s(macro __set_errno): Alter to take PIC
	register as argument instead assuming a specific register.
	(macro CHGMODE): For ARM_EABI, assume always 32 bit.
	New macro, PIC_LOAD, to load the PIC register in asm code. This
	is a slightly optimised version that makes an assumption about
	the location of the runtime workspace (at 0x8038).
	* incl-local/internal/os.h: Add inline SWI functions for
	SWI SOM_DeregisterClient and SWI ARMEABISupport_Cleanup.
	* incl-local/internal/swiparams.h: Add symbols for ARMEABISupport_StackOp
	reason codes.
	* incl-local/internal/unix.h(struct __process): Add flags indicating
	whether process in dynamically linked and whether it is ARMEABI.
	(struct ul_global): pthread_worksemaphore, pthread_callback_semaphore):
	Move to the fast access RMA block. Rather than delete them from here,
	poison them so that we know they are not used.
	* incl-local/pthread.h: Definition of stack_t type is dependent
	on whether chunked stacks are in use.
	(struct __pthread_thread): Add flag to support thread suspension.
	(struct __pthread_callevery_block): Extend fast access RMA block to
	callback registers and semaphore variables (poisoned above in
	struct ul_global).
	include/ctype.h: Add definition for isblank().
	* include/locale.h: Additional locale symbols/declarations.
	* include/pthread.h(struct __pthread_lock_attr): Add clock_id member.
	(struct __pthread_cond): Likewise.
	(PTHREAD_COND_INITIALIZER): Add clock type to default initialiser.
	(pthread_condattr_getclock,pthread_condattr_setclock): Add declarations.
	(PTHREAD_STACK_MIN): Add alternative value for non chunked stack.
	Add RISC OS specific function declarations to suspend/resume a thread and
	retrieve its registers.
	* include/swis.h: Add ARMEABISupport SWIs.
	* include/sys/elf.h: Add init_array/fini_array symbols.
	* include/ucontext.h: Add structs mcontext_t and ucontext_t and other
	symbols.
	* include/unistd.h: Add symbols _SC_PAGE_SIZE and _SC_PHYS_PAGES.
	* locale/newlocale.c: Add functions uselocale, freelocale and newlocale.
	* module/sul.s: Increase module version to 1.15.
	(sul_exit): Call clean up SWIs for SOManager and ARMEABISupport as appropriate.
	This should lead to more reliable program exits (after errors) than if it was
	left to Unixlib to call these SWIs.
	* pthread/_context.s(__pthread_start_ticker): Preserve register v5 for ARMEABI.
	Use PIC_LOAD macro throughout.
	(start_call_every,stop_call_every): Access ticker_started variable via fast access
	RMA block; removes need to use GOT.
	(pthread_call_every): Use fast access RMA block, removing the need to use the GOT.
	(__pthread_callback): Update to use fast access RMA block where necessary.
	(__pthread_init_save_area): Use malloc_unlocked rather than malloc.
	(ticker_started): Remove from data segment; no longer required.
	* pthread/_ints.s(__pthread_disable_ints,__pthread_protect_unsafe): For ARMEABI,
	assume SWP instruction is never available. Use fast access RMA block.
	(__pthread_enable_ints,__pthread_unprotect_unsafe): Use fast access RMA block.
	* pthread/_yield.s(pthread_yield): For ARMEABI, use appropriate prologue/epilogue.
	Use PIC_LOAD macro. Use fast access RMA block.
	* pthread/attr.c(pthread_attr_init): For a non chunked stack, set the maximum stack size.
	* pthread/cond.c(pthread_cond_init): Record the clock ID.
	(pthread_cond_timedwait): It seems that the timeout isn't always absolute;
	it can be relative depending on the clock type associated with the condition.
	* pthread/condattr.c(pthread_condattr_getclock,pthread_condattr_setclock):
	New functions.
	* pthread/context.c(__pthread_cleanup_idle): For a non-chunked stack (e.g, ARMEABI),
	use ARMEABISupport to free the pthread stack.
	(__pthread_context_switch): Ignore suspended threads.
	* pthread/create.c(__pthread_create): For a non-chunked stack (e.g, ARMEABI),
	take stack size from the attr argument if given or use default maximum size.
	Also use ARMEABISupport module for stack management.
	* pthread/newnode.c(__pthread_new_stack): For a non-chunked stack (e.g, ARMEABI),
	use ARMEABISupport module for stack management.
	(__pthread_new_node): Initialise "suspended" struct member.
	* libunixlib/pthread/np.c(pthread_getattr_np): For a non-chunked stack (e.g, ARMEABI),
	use ARMEABISupport module to query the thread's stack.
	(pthread_suspend_thread, pthread_resume_thread, pthread_get_thread_registers): Add
	functions.
	* pthread/pthinit.c: For a non-chunked stack (e.g, ARMEABI), use ARMEABISupport
	module for stack management.
	* pthread/testcancel.c(pthread_testcancel): pthread semaphore is in fast access
	RMA block now.
	* signal/_demangle.s: For ARMEABI, preserve v5.
	* signal/_signal.s: Use fast access RMA block throughout.
	Use PIC_LOAD macro throughout.
	For ARMEABI, simplify by assuming 32 bit code execution throughout.
	(__h_error): For ARMEABI, set up appropriate stack frame.
	(__h_cback_common): Likewise.
	(__cbreg, __cbflg, __cba1): Moved to fast access RMA block.
	* signal/post.c(__write_backtrace_thread): For ARMEABI and PIC, print
	the library name and offset for each entry in the stack backtrace.
	(__write_backtrace): Write appropriate fake stack frame depending on compiler
	used.
	* string/_memcpymove-v7l.s: New file. NEON enhanced version written by RISC OS Open
	(GCC 8 (ARMEABI) only).
	* string/_memset-v7l.s: Likewise.
	* string/_strlen-v7l.s: Likewise.
	* string/arm-mem.h: Header used by the above NEON source, written by RISC OS Open.
	* sys/_jmp.s: Use PIC_LOAD macro. Use fast access RMA block.
	* sys/_syslib.s: Use PIC_LOAD macro throughout.
	For ARMEABI, use ARMEABISupport module to allocate main stack and signal stack.
	Record in SULPROC_STATUS if we are dynamically linked and if we are ARMEABI.
	Add support for .init_array.
	* sys/_vfork.s: Use PIC_LOAD macro.
	* unix/ul_select.c(__convert_fd_set): In webkit, I noticed some sockets were
	not being polled for data. It seems to have something to do with this function
	not checking all fd bits. For ARMEABI, check all bits. For GCC 4, leave code
	untouched as I'm not sure.
	* unix/unix.c: Profiling not supported for ARMEABI.
	(_exit): Move clean up code to SUL.
	* vscript: Remove __cbreg.
	* wchar/wcsnrtombs.c(__wcsnrtombs): Rename to wcsnrtombs.
	* wchar/wmissing.c: A number of wide character functions that we don't have
	implementations of and may never need, but configure scripts look for.

Sun Aug  7 11:18:10 BST  2016  Lee Noar  <leenoar@sky.com>

	* common/__stat.c(__stat): Set the character flag for /dev/dsp
	so that libraries like libSDL2 can detect it correctly.

Thu May  5 19:37:26 BST  2016  Lee Noar  <leenoar@sky.com>

	* pthread/_ints.s(__pthread_protect_unsafe): Make the LDREX/STREX
	code a closer match in functionality to the SWP code. Hopefully,
	this will fix stability issues when using pthreads on the RPi3.

Fri Mar 11 14:51:54 GMT  2016  Lee Noar  <leenoar@sky.com>

	* sys/_cpucaps.s: New file. Provide functions to probe the
	OS for details of the CPU (currently SWP, LDREX/STREX
	availability).
	* Makefile.am: Add above file.
	* include/unixlib/local.h: Add declarations for user facing
	functions provided above.
	* incl-local/internal/asm_dec.s(__ul_global): Add entry to
	record CPU flags.
	* incl-local/internal/unix.h: Likewise.
	* pthread/_ints.s(__pthread_disable_ints,__pthread_protect_unsafe):
	Use CPU flags to determine whether to use the SWP instruction or
	LRDEX/STREX.
	* sys/_syslib.s(__main): Add call to __probe_cpu_caps.
	(__unixlib_fatal): Use CPU flags to determine whether to use the
	SWP instruction or LRDEX/STREX.

Mon Feb  7 15:06:02 GMT  2016  Lee Noar  <leenoar@sky.com>

	* incl-local/internal/asm_dec.s(XSOM_DeregisterClient): Add
	to list of SWIs.
	* sys/_syslib.s: Make sure that if a custom stack size is used,
	that the wimpslot is big enough. The main test uses unsigned
	integers because we are dealing with 32bit addresses, but this
	doesn't catch the problem of a large stack chunk in a small
	wimpslot producing an address below 0. Add an additional check
	on a subtraction where we know that a negative result is a bogus
	address.
	(__exit_with_error_num): In the event of a serious error early
	on in the initialisation stage, deregister the client from the
	Shared Object Manager.

Mon Nov 23 17:12:58 GMT  2015  Lee Noar  <leenoar@sky.com>

	* include/setjmp.h: Fix for memory corruption when mixing
	VFP and non-VFP shared libraries at runtime. If a VFP program
	uses a non-VFP library that calls setjmp, the setjmp buffer
	will be too small and setjmp() will overwrite anything that
	follows it.
	Fix by making the buffer for setjmp the same size for both.

Sat Sep 12 17:55:18 BST  2015  Lee Noar  <leenoar@sky.com>

	* stdlib/atexit.c: Make SCL friendly when building for SCL.
	For UnixLib nothing has changed. For SCL, don't compile
	anything related to pthreads. Don't compile atexit as SCL
	already provides that. Maintain our own destructor list
	separate from atexit and use the SCL atexit to ensure all
	destructors are called on program exit.
	* Makefile.am: Add stdlib/atexit.c to the SCL build.

Sat Sep 05 14:08:48 BST  2015  Lee Noar  <leenoar@sky.com>

	Fix for bug 246 - memory leak in RMA.

	* module/sul.s(sul_exit): Free the CLI memory regardless of
	whether there is a parent.
	Bump version number to 1.14.

Sun Jun 28 15:12:13 BST  2015  Lee Noar  <leenoar@sky.com>

	Submitted by Jeffrey Lee <me@phlamethrower.co.uk>

	* signal/_signal.s: Change VFP exception error base to match
	the value that's now being used by RISC OS (changed in OS
	to avoid potential clash with ROL allocation).

Sat May 16 21:07:57 BST  2015  Lee Noar  <leenoar@sky.com>

	* unix/ul_select.c(select): Only report a file descriptor
	as bad if it was given in one of the sets.

Sun Apr 19 17:57:09 BST  2015  Lee Noar  <leenoar@sky.com>

	* include/features.h(__stack_size): Declare new weak symbol.
	* sys/_syslib.s: Allow the size of the initial stack chunk
	to be set by defining the variable __stack_size in the client
	program. This can be used to mimic a flat stack when a chunked
	stack may be a problem, for example, in javascript interpreters.
	If __stack_size is not defined, then the initial stack chunk
	size is 4096 bytes as normal.

Sun Apr 19 17:40:12 BST  2015  Lee Noar  <leenoar@sky.com>

	* stdlib/atexit.c: It seems that __cxa_finalize can be called
	recursively, so removing entries from the list as we step
	through it is not a good idea. When returning from a recursive
	call, our next entry may no longer exist. Instead, just mark
	the entries as finished without removing them. As __cxa_finalize
	is usually called at program exit, the loss of memory shouldn't
	be an issue.

Thu Mar 26 18:33:45 GMT  2015  Lee Noar  <leenoar@sky.com>

	Submitted by Jeffrey Lee <me@phlamethrower.co.uk>

	* fenv/fclrexcpt.c(feclearexcept): Add support for VFP.
	* incl-local/pthread.h(__pthread_saved_context): Likewise.
	* incl-local/errno.h(__ul_fp_registers): Add alternative
	definition for VFP.
	* incl-local/internal/asm_dec.s: Add VFP error and
	SWI numbers. Add definition for GBL_VFP_REGCOUNT.
	* incl-local/internal/unix.h(struct ul_global): Add
	member to record number of double word registers that
	should be requested for VFP contexts.
	* include/swis.h: Add VFP module SWI numbers.
	* module/sul.s: Ensure any active VFP context is disabled
	when a client exits.
	* pthread/_context.s: Give each thread its own VFP context.
	* pthread/context.c(__pthread_cleanup_idle): Clean up the
	VFP context.
	* pthread/pthinit.c(__pthread_prog_init): Register the VFP
	context of the main thread.
	* signal/_signal.s(__h_error): Fix bug whereby serious errors
	were not being detected.
	(unrecoverable_error): Store the VFP registers in the event of
	an FP exception.
	* signal/post.c(__write_backtrace): Updated to produce a VFP/NEON
	register dump if a VFP exception has been caught (only a hex dump,
	since we don't know what data types are in the registers).
	* sys/_getcpuarch.s: Use the cache type register to work out whether
	a CPU with architecture field of 15 is ARMv6 or ARMv7 (e.g.
	Raspberry Pi 1 was previously being detected as ARMv7).
	* sys/_syslib.s: Update SUL version checks to require SUL 1.13 if
	the code was built for VFP/NEON. Add some logic to check for
	required VFP/NEON features - or at least as many features as we can
	assume the program might require (GCC doesn't seem to be very good
	at letting code know what VFP/NEON variant is being targeted).
	Add logic to set up the initial VFP context and to make a note of
	how many registers are available (for creating future contexts).
	* sys/_vfork.s: Deactivate & reactivate VFP context over the fork
	to make sure the state is duplicated correctly.

Wed Mar 18 14:27:11 GMT  2015  Lee Noar  <leenoar@sky.com>

	* pthread/np.c: New file.
	(pthread_getattr_np): Read the stack attributes of the
	given thread.
	(pthread_setname_np): Set the name of the given thread.
	(pthread_getname_np): Retrieve the name of the given thread.
	Note: The standard indicates that names are limited to
	16 chars, but some libraries use longer names, so I've
	set the limit at 32.
	* Makefile.am: Add above file to list of Unixlib source.
	* include/pthread.h: Add new function declarations.
	* incl-local/pthread.h(struct __pthread_thread): Add member
	to record thread name.
	* pthread/newnode.c(__pthread_new_node): Set the default
	thread name.
	* pthread/attr.c(pthread_attr_getstack): Read stack details
	from attributes.
	* signal/post.c(__write_backtrace): Output the name of the
	thread when printing the backtrace.
	* pthread/pthinit.c(__pthread_prog_init): Record the stack
	base of the main thread.

Thu Feb 26 20:09:05 GMT  2015  Lee Noar  <leenoar@sky.com>

	* incl-local/internal/linklist.h: Simple linked list
	implementation.
	* misc/linklist.c: Likewise.
	* Makefile.am: Add above file.
	* stdlib/atexit.c(__cxa_atexit): Use a linked list instead
	of an array so that atexit handlers can be removed when a
	shared library is dlclose'd. Also removes the maximum limit
	of 33 handlers.
	Add __cxa_finalize implementation.
	* incl-local/stdlib.h: Remove atexit array. Add declaration
	for __cxa_finalize.
	* unix/unix.c(exit): Replace atexit array processing with
	call to __cxa_finalize.

Sat Feb  7 12:28:58 GMT  2015  Lee Noar  <leenoar@sky.com>

	* sys/mman.c(mmap): If a mapped file is not a multiple of
	the page size, zero the remaining memory.

Thu Feb  5 19:53:47 GMT  2015  Lee Noar  <leenoar@sky.com>

	* include/sys/mman.h: Replace use of __caddr_t with void *.
	A number of autobuilder projects require changes due to the
	use of __caddr_t in relation to the mmap family of functions
	(especially when they're written in C++). Some research shows
	that in this context the use of __caddr_t is "old fashioned"
	and that void * is now standard.
	* sys/mman.c: Follow above change.

Thu Feb  5 19:33:01 GMT  2015  Lee Noar  <leenoar@sky.com>

	* gcccompat/atomics.c: Implement various atomic/sync functions.
	I've disabled the pthread interrupt around these operations,
	but I'm not sure if that's the correct thing to do, or if it's
	even necessary. These operations are purely arithmetic with no
	system calls. As I understand it, a pthread context switch only
	occurs when exiting operating system code.
	* Makefile.am: Add above file to list of Unixlib source.

Wed Jan 21 13:51:23 GMT  2015  Lee Noar  <leenoar@sky.com>

	* gcccompat/galloca.c(__llvm_alloca_save): Create strong
	alias to __gcc_alloca_save.
	(__llvm_alloca): Create strong alias to __gcc_alloca.
	(__llvm_alloca_restore): Wrapper for __gcc_alloca_restore.
	llvm generates code that only passes the block id, whereas
	__gcc_alloca_restore also requires a frame pointer.

Tue Jan 20 20:46:45 GMT  2015  Lee Noar  <leenoar@sky.com>

	* incl-local/stdlib.h(__atexit_function_array): Convert
	to array of __atexit_function_entry so that we can support
	__cxa_atexit.
	* stdlib/atexit.c(__cxa_atexit): Add.
	(atexit): Implement using __cxa_atexit.
	* unix/unix.c(exit): Follow changes above.

Sun Nov 23 14:53:00 GMT  2014  Lee Noar  <leenoar@sky.com>

	* pthread/cancel.c(__pthread_pull_gthr_weak): Remove. We
	now disable weak pthread symbols when building libstdc++
	as static.

Mon Jul  7 19:33:00 BST  2014  Lee Noar  <leenoar@sky.com>

	* signal/post.c(extract_name): Return whether the function name
	was demangled.
	(__write_backtrace_thread): Don't output empty brackets for a
	demangled function name.

Fri Jul  4 18:36:11 BST  2014  Lee Noar  <leenoar@sky.com>

	* include/dlfcn.h: Define RTLD_DEFAULT to be 0.

Sat Apr 26 16:55:28 CEST 2014  John Tytgat  <John.Tytgat@aaug.net>

	* include/unixlib/local.h (__unixlib_write_coredump): Constify return
	pointer.
	* sys/mman.c (__unixlib_write_coredump): Likewise.
	* signal/post.c (post_signal): Follow.

Tue Apr 22 00:07:32 CEST 2014  John Tytgat  <John.Tytgat@aaug.net>

	* signal/_signal.s (__h_sigill): Undo lr correction.
	(__h_sigbus): Likewise.
	(__h_sigsegv0): Likewise.
	(__h_sigsegv1): Likewise.
	* signal/post.c (extract_name): Use __valid_address to check incoming
	pc value. Don't return NULL but pointer to "?" when failing.
	(__write_backtrace_thread): More accurate __valid_address checking.
	Simplify extract_name calling.  Fix pc adjusting.
	* test/sys/handlers.c: Add.

Sun Mar  9 15:22:24 CET 2014  John Tytgat  <John.Tytgat@aaug.net>

	* time/localtime_r.c (localtime_r): Reduce ordinals entries from 15 to
	9.
	(SWI_Territory_ConvertTimeToOrdinals): Move to...
	* incl-local/internal/os.h: ...here.
	* time/mktime.c (mktime): Drop __os_swi usage and use
	SWI_Territory_ConvertTimeToOrdinals instead.
	* unittest/test-utimes.c: Fix comment.

Sun Mar  9 02:24:41 CET 2014  John Tytgat  <John.Tytgat@aaug.net>

	* common/cvttime.c (__cvt_riscos_time): Take only low byte of high
	parameter into account.  Fixes bug #249.
	* include/time.h (struct tm): Change type tm_gmtoff into long.
	* time/time.c (time): Drop byte mask for __cvt_riscos_time.

Sat Mar  8 16:11:39 CET 2014  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/errno.h (mask_fs_num): Add.
	* stdio/rename.c (rename): Use mask_fs_num.
	* unix/mkdir.c (mkdir): Likewise.  Remove ADFS specific error number
	check and language dependent error string check.

Fri Jan  3 17:09:59 CET 2014  John Tytgat  <John.Tytgat@aaug.net>

	* include/wchar.h: Don't include bits/wchar2.h nor bits/wchar-ldbl.h.
	Reported by Ron <beeb@woosh.co.nz>.
	* include/features.h, include/sys/socket.h: Uniform local changes.

Sun Aug  4 22:03:30 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/realpath (realpath): Return ENOENT if object does not exist.
	* incl-local/internal/symlinks.h: Move features.h include in
	__UNIXLIB_SYMLINKS test.
	* incl-local/internal/unix.h: Drop internal/symlinks.h include.
	* common/exist.c: Add internal/symlinks.h include.
	* common/objattr.c: Likewise.
	* sys/exec.c: Likewise.
	* unittest/test-realpath.c: Add.
	* unittest/include/expect-realpath.c: Add.
	* unittest/include/expect-symlink.c: Rename Create_SymLink to SymLink.
	* unittest/test-utimes.c: Follow Create_SymLink to SymLink rename.
	* unittest/test-utime.c: Likewise.
	* unittest/test-fopen.c: Likewise.
	* unittest/test-rename.c: Likewise.
	* unittest/test-symlink.c: Likewise.
	* unittest/test-readlink.c: Likewise.
	* unittest/test-stat.c: Likewise.
	(IsLink): Build conditionally.
	* unittest/include/check.c: Make functions global.
	* unittest/include/main.c: Add --stop option.

Tue May  7 23:27:42 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (stdlib_src): Build realpath for SCL as well.
	* include/stdlib.h (realpath): Declare for SCL.
	* stdlib/realpath.c (realpath): Support NULL output buffer.  Support
	symlinks.  Return ENOENT when canonicalisation fails.  Support SCL.

Wed May  1 15:27:44 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* include/limits.h (PATH_MAX): Increased to 1024.

Mon Apr 15 23:10:21 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unistd/readlink.c (readlink): Remove free call for NULL ptr.

Sun Apr 14 02:36:45 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c (__fswrite): Fix return value.
	(__nullstat): Don't reset S_IF* flags.
	* common/__stat.c (__stat): Add support for DEV_NULL, DEV_ZERO and
	DEV_RANDOM.
	* unittest/test-stat.c (Test_001_BasicStat): Add S_IFCHR sub-test.

Sun Apr 14 01:37:22 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	Based on bug analysis and readlink implementation work by Dave
	<buzby@kdmsc.plus.com>:
	* common/symlinks.c (__resolve_symlinks): Add one_step_only parameter.
	Return ELOOP instead of EMLINK.
	* incl-local/internal/symlinks.h (__resolve_symlinks): Add
	one_step_only parameter.
	(SYMLINK_ID_STR): Add.
	* common/exist.c (__object_exists_ux): Follow __resolve_symlinks API
	change.
	* sys/exec.c (execve): Likewise.
	* unix/dev.c (__fsopen): Likewise.
	(__fsfstat): Fix compiler warning.
	(__fslstat): Fix stat::st_mode value.
	* common/objattr.c (get_attrs): Add.  When following symlinks, return
	the destination, not the first symlink.
	(__object_get_attrs, __object_get_lattrs): Use get_attrs.
	(__object_set_attrs): Follow __resolve_symlinks API change.
	* common/unixify.c (add_filetype): Don't add filetype for symlink files.
	(add_directory_name): Remove "@" case.
	(__unixify): Support "@", "^" and "%" on its own.
	* unix/dirent.c (readdir_r): Don't add filetype for symlink files.
	* unix/unlink.c (unlink): Don't follow symlinks.
	* unistd/symlink.c (symlink): Add more parameter checks.
	Fix error checking of symlink file writing.
	* unistd/readlink.c (readlink): Add real implementation.
	* incl-local/internal/os.h (SWI_OS_GBPB_WriteBytes): Constify buf
	parameter.

	unittest:
	* test-utime.c: Add filetype, symlink, ENAMETOOLONG sub-tests.
	* test-utimes.c: Likewise.
	* test-rename.c: Add symlink sub-test.
	* test-fopen.c: Add symlink, ELOOP, ENAMETOOLONG sub-tests.
	* include/check.c (DirContents_Get): Use lstat instead of stat.
	* test-readlink.c, test-stat.c, test-lstat.c, test-symlink.c,
	include/expect-lstat.c, include/expect-readlink.c,
	include/expect-symlink.c, include/expect-stat.c: Add.

Tue Apr  2 16:31:46 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/os.h (__os_fopen, __os_fclose, __os_fread,
	__os_fwrite): Remove.
	(SWI_OS_Find_Open, SWI_OS_Find_Close, SWI_OS_GBPB_ReadBytes,
	SWI_OS_GBPB_WriteBytes): Add.
	(SWI_OS_Args_GetFilePtr, SWI_OS_Args_SetFilePtr, SWI_OS_Args_GetExtent,
	SWI_OS_Args_SetExtent, SWI_OS_Args_GetFileHandleStatus,
	SWI_OS_Args_Flush): Use __off_t for file offset type, use unsigned
	for RISC OS file handle type.
	Add unixlib/types.h include.
	* sys/_os.s (__os_fopen, __os_fclose, __os_fread, __os_fwrite): Remove.
	* incl-local/internal/unix.h (struct ul_global): Use __off_t as type
	for rewindpipeoffset.
	* incl-local/internal/swiparams.h (OSFILE_READCATINFO): Remove.
	(OSFILE_OPENIN, OSFILE_OPENOUT, OSFILE_OPENUP): Use OSFIND_ prefix
	instead.
	* unix/dev.c (__fsopen, __fsclose, __fsread, __fswrite): Follow
	incl-local/internal/os.h and sys/_os.s changes.
	* unistd/symlink.c (symlink): Likewise.
	* common/symlinks.c: Likewise.
	* sys/exec.c: Likewise.
	* sys/vfork.c: Likewise.
	* unix/truncate.c (ftruncate, truncate): Support __TARGET_SCL__.
	* Makefile.am (unix/truncate.c): Add to SCL build.

Mon Apr  1 17:27:38 CEST 2013  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/os.h (SWI_OS_File_ReadCatInfo): Don't call
	__get_feature_imagefs_is_file for __TARGET_SCL__ builds.

Thu Mar 14 23:08:55 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unistd/readlink.c (readlink): Changed return value from int to
	ssize_t.
	* include/unistd.h (readlink): Likewise.

Sun Mar 10 21:45:56 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	Based on contribution from buzby@kdmsc.plus.com.
	* common/objattr.c (__object_get_attrs): Add check on empty filename.
	* common/riscosify.c (translate_or_null): Add fixme question.
	* incl-local/internal/local.h (__cvt_riscos_time_csec): Add.
	(__cvt_unix_time_csec): Add.
	* include/sys/stat.h (struct stat, struct stat64): Add st_atim, st_mtim,
	st_ctim members.  Redefine st_atime, st_mtime and st_ctime.  Rename
	st_atime_usec, st_ctime_usec, st_mtime_usec to st_atimensec,
	st_mtimensec and st_ctimensec.
	* incl-local/sys/stat.h (__stat): Use unsigned parameters.
	* common/__stat.c (__stat): Fill in st_atim, st_mtim and st_ctim
	instead of st_atime, st_mtime, st_ctime, st_atime_usec, st_mtime_usec,
	st_ctime_usec.
	* include/bits/posix_opt.h (_POSIX_MONOTONIC_CLOCK): Define.
	* unix/utime.c (utime): Reimplement using utimes.
	* time/utims.c (utimes): Reimplement with csec accuracy.
	* time/clk_getres.c (clock_getres): Fix resolution value.
	* time/gettod.c (gettimeofday): Do signed time calculation and use
	__cvt_riscos_time_csec.
	* time/clk_gettime.c (clock_gettime): Likewise.  Add check on NULL
	timespec parameter.
	* common/cvttime.c (__cvt_riscos_time, __cvt_unix_time): Use signed
	time calculation based on __cvt_riscos_time_csec and
	__cvt_unix_time_csec.
	* unittest/include/check.c (Check_FileModDate): Add.
	* unittest/Makefile, unittest/test-utime.c, unittest/test-utimes.c
	unittest/include/expect-utime.c, unittest/include/expect-utimes.c: Add.
	* unittest/include/expect-rename.c (Call_Rename): Fix comment.
	* unittest/test-rename.c: Trim comment.
	* unittest/include/main.c: Mention the test's name when it was
	successful.

Sun Mar 10 20:55:07 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c (__fsopen): Fix warning.

Thu Mar  7 02:53:14 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (AM_CFLAGS): Add __UNIXLIB_NO_NONNULL define.
	* include/sys/cdefs.h (__nonnull): Disable when __UNIXLIB_NO_NONNULL
	is defined.
	* sys/vfork.c (__fork_post): Add FIXME.
	* stdio/newstream.c (__stream_init): Don't seek.
	(__getmode): Tighten checks.
	* stdio/fgetpos.c (fgetpos): Switch order o_base and i_base test.
	* stdio/flsbuf.c (__flsbuf): Don't check on stream being writable
	(will happen at write() time).  Don't check on stream error state.
	Don't check on zero byte writes (happens at write() time).  For append
	streams, write() will have seeked to EOF so update FILE::__offset
	differently.
	* stdio/filbuf.c (check_stream): Drop check on stream being readable
	and not in error state. Merge remaining part into __filbuf and
	__peekchar.
	* stdio/ul_fopen.c (fopen): Drop tests on input parameters.
	* unix/ul_open.c (open): Fix input parameter test.

	unittest/include:
	* expect-fseek.c, expect-feof.c, expect-fputc.c, expect-fopen.c,
	expect-fgetc.c, expect-fclose.c: Add.

	* unittest/test-rename.c (Call_Rename, ExpectCall_Rename): Move to...
	* unittest/include/expect-rename.c: ...here.
	* unittest/test-fopen.c: Add.

Wed Mar  6 02:51:45 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* include/unixlib/types.h (__ssize_t): Change type from int to long int.
	Avoids the printf %zd warning for ssize_t.

Mon Mar  4 02:00:04 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unittest/include/check.c (DirContents_Get): Fix reallocation.
	(Check_FileSize): Add.
	* unittest/test-rename.c (main): Move to...
	* unittest/include/main.c: ...here.

Mon Mar  4 01:56:43 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fclose.c (fclose): Minor reformat.
	* stdio/freopen.c (freopen): Likewise.
	* unix/fstat.c (fstat): Likewise.

Mon Mar  4 01:50:53 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/ul_fdopen.c (fdopen): Set errno to EINVAL for invalid mode.
	Properly check on file descriptor validness.

Mon Mar  4 01:44:36 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unix/custom.c (__unixlib_getdev): Merge into...
	(__set_customselect): ...this.  Change return type into int and return
	-1 with errno BADF when bad file descriptor is passed.
	* include/unixlib/local.h (__set_customselect): Change return type into
	int.

Mon Mar  4 01:39:12 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/ferror.c (ferror): Don't set errno for an invalid stream.
	* stdio/feof.c (feof): Likewise.
	* stdio/clearerr.c (clearerr.c): Likewise.

Sat Mar  2 16:50:10 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/rename.c (rename): Better determination of errno values.
	Allow case-only rename on case insensitve RISC OS FS. Use
	SWI_OS_FSControl_Rename instead of __os_swi.
	* common/objattr.c: Fix comment.
	* common/_exists.s (__isdir_raw, __object_exists_raw): Remove.
	* common/exist.c (__isdir, __object_exists): Remove.
	(__object_exists_ux, __object_exists_ro): Add.
	* incl-local/internal/local.h: Follow above changes.
	* incl-local/internal/os.h (SWI_OS_File_ReadCatInfo): Take
	__get_feature_imagefs_is_file into account.
	(SWI_OS_FSControl_Rename): Add.
	* unix/dev.c (__fsopen): Follow __isdir_raw to __object_exists_ro
	rename.
	* unix/dirent.c (opendir): Follow __object_exists_raw to
	__object_exists_ro rename.
	* unistd/symlink.c (symlink): Likewise.
	* stdio/tmpfile.c (generate_temporary_filename): Follow rename
	__object_exists to __object_exists_ux.
	(isdir): Follow rename __isdir_raw/__isdir to __object_exists_ro/
	__objet_exists_ux.
	* vscript (__isdir_raw, __isdir): Remove.
	(__object_exists_ro, __object_exissts_ux): Add.
	* unittest/test-rename.c, unittest/include/check.c: Add.

Sat Feb 23 19:06:13 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c (__fsopen): Don't use a pointer to a buffer going
	out-of-scope.

Sat Feb 23 17:47:28 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* doc/UnixLib/README: Update __feature_imagefs_is_file description.
	* include/features (__feature_imagefs_is_file): Make weak as expected.

Wed Feb 20 01:40:08 CET 2013  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/rename.c (rename): Set errno to ENOENT when old filename or
	directory path of new filename does not exist.

Thu Dec  6 18:39:21 GMT 2012  Lee Noar <leenoar@sky.com>

	* Makefile.am: Compile files sys/brk.c, sys/stackalloc.c and
	debug/dvsprintf.c with -fno-optimize-sibling-calls to suppress
	tail call optimisations. Although the compiler has been altered
	to prevent such optimisations, this is only when stack checking
	is enabled. These files must be compiled with stack checking
	disabled, which means that tail call optimisations are still
	being applied. Fixes a crash in Mono when compiled with 4.1.2.

Sun Dec  2 02:41:21 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/pthread.h (struct __pthread_thread): Move warning.
	* incl-local/internal/asm_dec.s (__PTHREAD_ERRBUF_VALID_OFFSET): Add.
	* incl-local/errno.h (__set_errno): Remove __UNIXLIB_ERRNO_THREADED
	test.
	(__ul_errbuf): Remove valid field.
	* unix/seterr.c (errno): Remove __UNIXLIB_ERRNO_THREADED test.
	* signal/_signal.s (__h_error): Set
	__pthread_running_thread->errbuf_valid i.s.o. __ul_errbuf.valid.
	(__ul_errbuf_valid): Remove.
	* signal/post.c (post_signal): Don't reset __ul_errbuf.valid.  Test
	on signo being SIGOSERROR and __pthread_running_thread->errbuf_valid
	before outputing RISC OS error buffer.
	* pthread/exit.c: Fix header comments.
	* pthread/cond.c: Likewise.
	* pthread/cleanupcall.c: Likewise.
	* pthread/context.c: Likewise.
	* pthread/_yield.s: Likewise.
	* pthread/testcancel.c: Likewise.
	* pthread/cleanup.c: Likewise.
	* pthread/lock.c: Likewise.
	* pthread/detach.c: Likewise.
	* pthread/key.c: Likewise.
	* pthread/self.c: Likewise.
	* pthread/pthsignal.c: Likewise.
	* pthread/rwlockattr.c: Likewise.
	* pthread/join.c: Likewise.
	* pthread/mutex.c: Likewise.
	* pthread/keydest.c: Likewise.
	* pthread/attr.c: Likewise.
	* pthread/condattr.c: Likewise.
	* pthread/pthinit.c: Likewise.
	* pthread/once.c: Likewise.
	* pthread/cancel.c: Likewise.
	* pthread/atfork.c: Likewise.
	* pthread/error.c: Likewise.
	* pthread/_ints.s: Likewise.
	* pthread/mutexattr.c: Likewise.
	* pthread/newnode.c: Likewise.
	* pthread/rwlock.c: Likewise.
	* pthread/create.c: Likewise.
	* pthread/_context.s: Likewise.

Sat Dec  1 18:57:12 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* signal/post.c (__unixlib_raise_signal): Simplify test.

Sat Dec  1 18:52:54 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* signal/sigexec.s (__unixlib_exec_sig): Fix passing sighandler_t
	arguments.

Sun Nov 18 14:51:35 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* include/string/byteswap.h: Upgrade to glibc 2.16.0 copy. Fixes
	_BYTESWAP_H vs __BYTESWAP_H confusion.

Sat Nov 10 17:51:15 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* scl/chunkid02.s (strtod,strtol,strtoul): Add comments.
	* scl/chunkid05.s (strtof): Enable.

Sat Sep 29 18:02:53 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (common_src): Add common/attrib.c,
	common/canonicalise_handle.c and common/__stat.c to SCL build.
	(unix_src): Add unix/scl_fstat.c.
	* sys/_os.s (__os_file, __os_fsctrl, __os_setfiletype): Remove.
	* incl-local/internal/os.h (__os_file, __os_fsctrl,
	__os_setfiletype): Remove.
	(SWI_OS_File_SaveBlockLoadExec, SWI_OS_FSControl_SetCurDir,
	SWI_OS_File_WriteCatInfoAttr, SWI_OS_File_DeleteObject,
	SWI_OS_File_CreateDirectory, SWI_OS_File_CreateFileWithFileType,
	SWI_OS_File_WriteCatInfoFileType): Add.
	* incl-local/internal/swiparams.h (OSFILE_SAVEBLOCK_LOADNEXEC,
	OSFILE_SAVEBLOCK_FILETYPE, OSFILE_READCATINFO_FILEPATH,
	OSFILE_READCATINFO_PATH, OSFILE_READCATINFO_PATHVAR,
	OSFILE_WRITECATINFO_ATTR, OSFILE_WRITECATINFO_FILETYPE,
	OSFILE_DELETENAMEDOBJECT, OSFILE_CREATEDIRECTORY,
	OSFILE_CREATEEMPTYFILE_FILETYPE): Add.
	* stdio/rename.c (rename): Use SWI_OS_File_DeleteObject instead of
	__os_swi, __os_file.  Use SWI_OS_File_WriteCatInfoFileType instead of
	__os_swi.
	* unix/unlink.c (__unlinksuffix, unlink): Use SWI_OS_File_DeleteObject
	instead of __os_file.
	* unix/chmod.c (chmod): Use SWI_OS_File_WriteCatIntoAttr instead of
	__os_file.
	* unix/fchmod.c (fchmod): Likewise.
	* unix/unix.c (convert_command_line): Use SWI_OS_File_ReadCatInfo
	instead of __os_file.
	* unix/mkdir.c (mkdir): Use SWI_OS_File_CreateDirectory,
	SWI_OS_File_WriteCatInfoAttr instead of __os_file.
	* unix/dev.c (__fsopen): Use SWI_OS_File_ReadCatInfo,
	SWI_OS_File_CreateFileWithFileType, SWI_OS_File_WriteCatInfoAttr,
	SWI_OS_Args_GetFileHandleStatus and SWI_OS_File_DeleteObject instead
	of __os_file and __os_swi.
	(__fsstat): Make use of __stat return value.
	(__fsfstat): Use SWI_OS_File_ReadCatInfo instead of __os_file.
	Make use of __stat return value.
	(__fslstat, __nullfstate): Minor change.
	* unix/chdir.c (chdir): Use SWI_OS_FSControl_SetCurDir instead of
	__os_fsctrl.
	* unistd/symlink.c (symlink): Use SWI_OS_File_WriteCatInfoFileType
	instead of __os_file.
	* sys/mman.c (__unixlib_write_coredump): Use
	SWI_OS_File_CreateDirectory, SWI_OS_File_SaveBlockLoadExec instead of
	__os_file.
	* incl-local/sys/stat.h (__stat): Change return type from void to int.
	* common/__stat.c: Change return type from void to int.  Tune it to be
	used for SCL build.
	* unix/scl_fstat.c: Add.
	* unix/scl_open.c (open): Make IO unbuffered.

Tue Sep 25 00:28:45 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (time_src): Build utimes.c for SCL.
	(unix_src): Build utime.c for SCL.
	* incl-local/internal/os.h (SWI_OS_File_WriteCatLoadExecAttr): Add.
	* unix/utime.c (utime): Add support for SCL build.
	* time/utimes.c (utimes): Likewise.
	* common/objattr.c (__object_get_attrs, __object_get_lattrs): Use
	SWI_OS_File_ReadCatInfo iso __os_file OSFILE_READCATINFO_NOPATH.
	* common/riscosify.c (OSFILE_READCATINFO_NOPATH): Drop define.
	(translate_or_null): Use SWI_OS_File_ReadCatInfo iso __os_file
	OSFILE_READCATINFO_NOPATH.
	* incl-local/internal/swiparams.h (OSFILE_READCATINFO_NOPATH): Drop
	define.
	(OSFILE_WRITECATINFO_ALL): Likewise.

Tue Sep 18 22:49:50 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* locale/iconv.c (iconv_mod_checked_ok): Add.
	(iconv_open): Do at most one successful RMEnsure Iconv.

Thu Aug 16 01:29:21 CEST 2012  Theo Markettos  <theo@markettos.org.uk>

	* include/sys/socket.h: Avoid include bits/socket2.h when in
	FORTIFY mode.

Fri Aug  3 04:01:08 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* netlib/accept.c (accept): Fix return value for SCL targets.

Fri Jul 27 23:21:36 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (libc_headers): Add err.h.
	(nobase_noinst_HEADERS): Add incl-local/fcntl.h.

Fri Jul 27 18:04:01 BST  2012  Lee Noar  <leenoar@sky.com>

	* locale/setlocale.c(territory_name): Fix comparison.
	(locale_to_territory): Fix double initialisation of variable.
	(territory_to_locale): Likewise.

Thu Jul 26 20:04:29 BST  2012  Lee Noar  <leenoar@sky.com>

	* locale/setlocale.c: Add support for standard locale names
	in the form of language-territory[.codeset] where language
	is an ISO 639 language code and territory is an ISO 3166 country
	code. For example, the United Kingdom is "en-GB". The codeset is
	ignored, but accepted. A lookup table is used to convert the
	locale to a RISC OS territory and back. The table was constructed
	using the list of territories from here:

	<http://www.riscosopen.org/wiki/documentation/show/Territory%20Numbers>

	The table lookup is not case sensitive, however, the territory module
	for the current locale must be loaded in order for strnicmp to work
	correctly (the territory manager can convert between territory numbers
	and names on its own, but the tolower function requires the ctype tables
	to be filled in by the territory module for the current locale).
	The old style country names will still work for backwards compatibility
	as long as they don't clash with a locale name, for example, calling
	setlocale (LC_ALL, "France") will work as expected, however,
	setlocale (LC_ALL, "UK") will set the locale to the Ukraine rather than
	the United Kingdom.

Mon Jul 23 21:36:19 CEST 2012  Jeffrey Lee  <me@phlamethrower.co.uk>
                               John Tytgat  <John.Tytgat@aaug.net>

	* gdtoa/arith.h: Add support VFP.
	* sys/_jmp.s: Likewise.
	* include/setjmp.h: Likewise.
	* fenv/fraiseexcpt.c: Likewise.
	* fenv/fesetround.c: Likewise.
	* fenv/fsetexcptflg.c: Likewise.
	* fenv/fesetenv.c: Likewise.
	* fenv/fegetround.c: Likewise.
	* fenv/feholdexcpt.c: Likewise.
	* include/fpu_control.h: Likewise.
	* include/endian.h: Likewise.
	* include/bits/huge_val.h: Likewise.
	* include/bits/fenv.h: Likewise.
	* signal/_signal.s: Add preliminary support for VFP.
	* pthread/_context.s: Likewise.
	* incl-local/internal/scl-macros.s (DefSCLFltFnc, DefSCLFltFncS,
	DefSCLFltFncAlias): Add.
	* scl/scl_fabsf.s: Disable function export when arguments or return
	value are float value types.
	* scl/scl_logf.s: Likewise.
	* scl/chunkid04.s: Likewise.
	* scl/chunkid05.s: Likewise.
	* scl/scl_atanf.s: Likewise.
	* scl/scl_copysign.s: Likewise.
	* scl/scl_acosf.s: Likewise.
	* scl/scl_sinf.s: Likewise.
	* scl/scl_expf.s: Likewise.
	* scl/scl_fpclassify.s: Likewise.
	* scl/scl_hypotf.s: Likewise.
	* scl/scl_powf.s: Likewise.
	* scl/scl_ceilf.s: Likewise.
	* scl/scl_ldexpf.s: Likewise.
	* scl/scl_floorf.s: Likewise.
	* scl/scl_log10f.s: Likewise.
	* scl/scl_tanf.s: Likewise.
	* scl/scl_cosf.s: Likewise.
	* scl/scl_modff.s: Likewise.
	* scl/scl_signbit.s: Likewise.
	* scl/scl_tanhf.s: Likewise.
	* scl/scl_asinf.s: Likewise.
	* scl/scl_copysignf.s: Likewise.
	* scl/scl_coshf.s: Likewise.
	* scl/scl_sinhf.s: Likewise.
	* scl/scl_fpclassifyf.s: Likewise.
	* scl/scl_atan2f.s: Likewise.

Fri Jul 13 16:16:27 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* common/prefix.c (__get_dde_prefix): Avoid reading from NULL when
	SWI DDEUtils_ReadPrefix is not defined, nor Prefix$Dir is set.
	Fixes bug #241.

Sun Jun 17 17:44:12 BST  2012  Lee Noar  <leenoar@sky.com>

	* pwd/getpwuid_r.c(getpwuid_r): If the default values are used
	because the password file does't exist, then fill the user buffer
	with these values.

Wed Jun  6 02:33:37 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* include/errno.h (program_invocation_name,
	program_invocation_short_name): Add.
	* unix/unix.c (program_invocation_name, program_invocation_short_name):
	Define.
	(__unixinit): Setup program_invocation_name and
	program_invocation_short_name.
	* incl-local/internal/unix.h (__get_program_name): Remove.
	* unix/features.c (__get_program_name): Make static and rename to
	get_program_name.  Simplify in case __program_name is defined.
	No longer check on Unix directory separators.
	(__runtime_features): Follow __get_program_name rename.
	* sys/mman.c (mmap): Use program_invocation_short_name instead of
	__get_program_name.
	* stdio/err.c (output): Likewise.
	(vwarnx): Call output with do_code set to 0.
	* unix/dirent.c (newstream, closedir): Avoid compiler warning.
	* include/sys/param.h (howmany,rounddown,roundup,roundup2,powerof2,MIN,
	MAX): Add.

Wed Jun  6 00:58:55 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* include/err.h: Add.
	* stdio/err.c: Add.
	* Makefile.am (stdio_src): Add stdio/err.c.
	* include/kernel.h: Fix whitespace.
	* unix/features.c (__get_program_name): Shuffle local variables.

Fri Jun  1 00:29:28 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* include/fcntl.h (O_BINARY, O_TEXT): Assign value 0 as UnixLib won't
	do anything when set.
	(O_PIPE, O_UNLINKED): Move too...
	* incl-local/fcntl.h: ...here.  New file.
	* sys/_vfork.s: Tuned some comments.

Wed May 16 02:38:43 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/mkstemp.c (mkstemp): Change O_TRUNC into O_EXCL.
	(mkstemp64): Add.
	* include/stdlib.h (mkstemp64): Add.
	* stdio/tmpfile.c (generate_temporary_filename): Simplify. Improve
	template checking.  Add offset to start index.
	(get_tmpdir, isdir): Add.
	(__tmpbuf): Adjust length to L_tmpnam.
	(tmpnam, tmpnam_r): Support __RISCOSIFY_NO_PROCESS case.  Fixes bug
	#238.
	(tempnam): Remove strategy 4, was the same as 3.  Support
	__RISCOSIFY_NO_PROCESS case.

Mon May 14 03:08:50 CST 2012  Christopher Martin  <belles@internode.on.net>

	* sound/DRender.h: Added. Having made improvements to
	DigitalRenderer, imported and adapted the DRender interface
	included in the DigitalRenderer sources. Substantial use of
	inline assembly functions to optimise calls to most
	DigitalRenderer SWIs.
	* sound/DRender.s (DRender_SetDefaults): Likewise. A function to
	call SWI DigitalRenderer_SetDefaults is provided here because it
	uses so many registers that it is not practical to implement in
	inline assembly.
	* sound/DRender.s (DRender_LoadModule): Likewise. This function
	uses SWI OS_Module to load System:Modules.DRenderer which is
	preferable to using *RMLoad through SWI OS_CLI.
	* sound/dsp.c: Extensive changes allowed by the new DRender
	interface allowing /dev/dsp emulation to be made simpler and
	more efficient.

Wed Apr  4 11:55:56 BST 2012  Lee Noar  <leenoar@sky.com>

	* unix/ul_select.c(select): Set errno to EBADF and return
	-1 if one of the sets contains an invalid file descriptor
	(as defined by the Linux standard).
	This can occur if a file is closed whilst being polled by
	select. Fixes a problem in Mono whereby a pipe controlling
	a socket is closed, leaving select stuck in an infinite
	loop and preventing the program from exiting.

Tue Apr  3 19:53:12 BST 2012  Lee Noar  <leenoar@sky.com>

	* unix/dev.c(__pipewrite): Always restore the file pointer.
	The second (fileptr==extent) test can prevent the file
	pointer from being correctly restored causing a read of the
	pipe to fail. This fixes a problem in Mono where reading
	a socket controlled by a pipe would fail with a timeout.

Tue Mar 20 19:29:47 GMT 2012  Lee Noar  <leenoar@sky.com>

	* include/sys/elf.h(DT_RISCOS_GCC_DIR): Rename to
	DT_RISCOS_ABI_VERSION.
	* gen-auto.pl: Generate file misc/abi.c.
	* Makefile.am: Add misc/abi.c to list of file to compile.

Mon Mar 12 19:36:19 GMT 2012  Lee Noar  <leenoar@sky.com>

	* include/sys/elf.h: Define DT_RISCOS_GCC_DIR.

Sun Mar 04 17:47:47 GMT 2012  Lee Noar  <leenoar@sky.com>

	* Makefile.am: Compile libm-dbl64/s_sincos.c(__sincos) with
	flags -fno-builtin-cos and -fno-builtin-sin to prevent GCC
	from optimising calls to sin() and cos() into a call to
	__cexp(). __cexp() already calls __sincos() and this would
	create an infinite loop.

Sun Feb 12 14:33:56 GMT 2012  Lee Noar  <leenoar@sky.com>

	* signal/post.c: Remove debug code.

Sun Feb 12 14:16:14 GMT 2012  Lee Noar  <leenoar@sky.com>

	Add basic support for three argument signal handlers.

	* include/ucontext.h: New file. Declare sigcontext structure.
	* include/signal.h: Add siginfo_t structure.
	(struct sigaction): Add sa_sigaction member as alternative to
	sa_handler.
	Define SA_SIGINFO.
	* incl-local/internal/sigstate.h (unixlib_sigstate): Add
	member siginfo to record state of signal (not all members
	of siginfo are used. Currently only si_signo and si_pid are
	set, si_addr is set for hardware exceptions). Add member
	ucontext to record register values at time of signal (only
	valid for hardware exceptions).
	(__unixlib_exec_sig): Change signature to include extra
	arguments.
	* signal/sigexec.s (__unixlib_exec_sig): Pass siginfo
	and ucontext pointers to signal handler as extra arguments. A
	one argument signal handler will ignore the extra arguments.
	* signal/post.c (sigsetup): Call the handler with the additional
	arguments.
	(post_signal): For a supported hardware exception, copy the
	registers to the ucontext object and setup the siginfo object.
	If after returning from the signal handler, the stored PC is
	not the same as the address of the instruction that faulted,
	then reload all registers passing control to the new PC. Can
	be used by language interpreters to catch hardware exceptions.
	* Makefile.am: Add ucontext.h.
	* pthread/_context.s: Fix comment.

Fri Dec 30 02:25:34 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (stdio/fpos.c): Remove.
	(stdio/fgetpos.c): Add.
	(stdio/fseek.c): Likewise.
	(stdio/fseeko.c): Likewise.
	(stdio/fsetpos.c): Likewise.
	(stdio/ftell.c): Likewise.
	(stdio/ftello.c): Likewise.
	(stdio/rewind.c): Likewise.
	(stdio/lockfile): Likewise.
	(stdio/getchar.c): Likewise.
	* stdio/fpos.c (fgetpos, fgetpos64, fsetpos, fsetpos64, fseek,
	fseeko, fseeko64, ftell, ftello, ftello64, rewind): Split into
	stdio/fgetpos.c (fgetpos, fgetpos64), stdio/fseek.c (fseek),
	stdio/fseeko.c (fseeko, fseeko64), stdio/fsetpos.c (fsetpos,
	fsetpos64), stdio/ftell.c (ftell), stdio/ftello.c (ftello,
	ftello64), stdio/rewind.c (rewind).
	* stdio/fgetpos.c (fgetpos): Reimplement based on previous ftell
	implementation.
	* stdio/ftell.c (ftell): Reimplement using fgetpos.
	* stdio/ftello.c (ftello): Reimplement using fgetpos.
	* stdio/fsetpos.c (fsetpos): Reimplement based on previous fseek
	implementation.
	(fsetpos64): Fix offset sanity check.
	* stdio/fseek.c (fseek): Reimplement using fsetpos.
	* stdio/fseeko.c (fseeko): Reimplement using fsetpos.
	(fseeko64): Fix offset sanity check.  Use fseeko iso fseek.
	* stdio/rewind.c (rewind): Previous implementation from
	stdio/fpos.c.
	* stdio/putc (fputc): Don't check on writabel streams (is now done
	at __flsbuf). Trim value to be written to 8 bits.
	(putchar): Move to...
	* stdio/putchar.c: ...here (new file).
	(putchar_unlocked): Add.
	* stdio/getc.c (fgetc): Don't check on readable streams (is now
	done at checkstream).
	(fgetc_unlocked): Add.
	(getchar):  Move to...
	* stdio/getchar.c: ...here (new file).
	(getchar_unlocked): Add.
	* stdio/ul_fileno (fileno_unlocked): Add.
	* stdio/fwrite.c (fwrite): Writing to non-writeable streams should
	result in stream error.  Minor cleanup.
	(fwrite_unlocked): Add.
	* stdio/fread.c (fread): Reading from non-readable streams should
	result in stream error.  Minor cleanup.  String based stream
	should never result in calling read.  Avoid division when all
	data can be read.
	(fread_unlocked): Add.
	* stdio/fflush.c (fflush_unlocked): Add.
	* stdio/lockfile.c (flockfile, ftrylockfile, funlockfile): Add
	dummy implementation.
	* include/stdio.h (feof_unlocked, ferror_unlocked): Add.
	(fflush_unlocked): Add.
	(fread_unlocked, fwrite_unlocked): Add.
	(putchar_unlocked): Add.
	(fgetc_unlocked): Add.
	(fileno_unlocked): Add.
	(fread, popen): Add __wur.
	(getc_unlocked): Removed for SCL.
	(fputc_unlocked, putc_unlocked, fgets_unlocked): Was wrongly
	defined for SCL iso UnixLib.
	(flockfile, ftrylockfile, funlockfile): Add.

Tue Nov 29 16:34:27 GMT 2011  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s(__pthread_callback): Be more consistent with
	which register is used for PIC. This is to fix a bug whereby after
	a jump to skip_contextswitch was made, the wrong register was used
	to address the GOT.
	* pthread/pthinit.c(__get_GOT_ptr): Small piece of assembler code
	to retrieve the GOT pointer. Used by __pthread_prog_init because
	we don't know which register GCC has used for PIC.
	* signal/_signal.s(__setup_signalhandler_stack): Load PIC register
	rather than depend on caller for it.

Sun Nov 27 16:04:02 GMT 2011  Lee Noar  <leenoar@sky.com>

	* pthread/_exit.s(__pthread_exit:): As GCC can now use any register
	for the PIC register, we have to load it ourselves rather than assume
	the caller has done it for us.

Wed Sep  7 01:43:43 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (brk.lo,stackalloc.lo,dvsprintf.lo): Update custom
	targets based on automake 1.11.1 so that parallel builds are
	again reliable.

Thu Aug 11 23:06:47 2011  Lee Noar <leenoar@sky.com>

	* sys/_syslib.s(__env_riscos,__env_read,__env_unixlib):
	Avoid having to save the PIC register by using r12.
	Simplifies the source code because the same stack
	save/load instructions can be used for both PIC and
	non PIC versions.

Sat Aug 06 18:23:01 2011  Lee Noar <leenoar@sky.com>

	* pthread/_context.s: Convert to new PIC scheme.
	* pthread/_yield.s: Likewise.
	* pthread/_ints.s: Likewise.
	* signal/_demangle.s: Likewise.
	* signal/_signal.s: Likewise.
	* common/_exist.s: Likewise.
	* common/_riscosify.s: Likewise.
	* common/_taskhandle.s: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* gcccompat/_eh_support.s: Likewise.
	* sys/_jmp.s: Likewise.
	* sys/_vfork.s: Likewise.
	* sys/_syslib.s: Likewise.
	* include/sys/elf.h: Define DT_RISCOS_PIC.

Sun May 15 19:58:43 2011  Lee Noar <leenoar@sky.com>

	* gcccompat/_eh_support.s(__ehs_unwind_stack_chunk):
	Calls to alloca() makes things awkward in that the alloca
	implementation uses the frame pointer of the callee of the
	callee of alloca as a key (note that there are two callees
	and that this is not a typing error). This means that by
	the time __gcc_alloca_free has been detected, the frame
	pointer that would be used as the key to find the correct
	return address has already passed. To overcome this, the
	stack unwinder tracks two frame pointers - the current one
	and the alloca one (the alloca fp actually lags one frame
	behind the current fp).
	Use both frame pointers in __ehs_unwind_stack_chunk
	as required; for UnixLib, the current fp is used only
	to validate. For SCL, due to the way return addresses are
	recorded, it may be necessary to return a different fp as
	the current one.

Sat Feb  5 20:20:02 2011  Lee Noar <leenoar@sky.com>

	* gcccompat/_eh_support.s(__ehs_unwind_stack_chunk): Add
	implementation for SCL.
	(UnixLib version): Fix return register list in the case
	of fp == 0. Change 1st arg to void ** (so the SCL version
	can return a different frame pointer) and alter code
	accordingly.

Fri Jan 21 20:40:11 2011  Lee Noar <leenoar@sky.com>

	* gcccompat/_eh_support.s(__ehs_unwind_stack_chunk): New
	function. Used by the ARM stack unwinder to track the
	current stack chunk and stack limit. UnixLib version only
	to begin with.

Sat Aug 21 16:55:44 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c (exit): Revert previous workaround. gcc bug
	44974 is solved.

Wed Jul 21 14:46:21 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c (exit): Add temporary workaround for gcc bug
	http://gcc.gnu.org/bugzilla/show_bug.cgi?id=44974

Sat Jul 17 03:33:14 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* libtool.m4.p: Move away as gcc patch for its common libtool.m4.
	* libtool-org.m4: Remove.
	* configure.ac: No longer expect to find a local libtool.m4.

Wed Jun 23 01:08:51 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* configure.ac (AC_PREREQ): Require at least Autotools 2.64 (like
	gcc 4.6); m4_rename -> m4_rename_force

// ------------------------------------ ^^^ gcc4.6trunk ^^^ port -----------------

Sat May  5 00:30:08 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/fd.h (BADF): Simplify expression.
	* debug/debug.c (debug_printf): Dump more info on file handles.
	* unix/dev.c (__fsclose): Detach OS_ChangeRedirection handle we're
	about to close.  Fixes bug 236.
	* test/sys/bug236.c: Added.
	* test/sys/test236.c: Likewise.

Tue May  1 21:33:26 CEST 2012  Chris Gransden  <chrisg@care4free.net>

	* incl-local/sys/socket.h (_sendto): Fix return value.  Fixes bug 233.

Tue May  1 17:28:14 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* unix/glob.c (glob, glob3): Avoid the use of mbrtowc.  Fixes bug 231.

Tue May  1 16:03:56 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* sys/exec.c (execve): Add checks for alias-disabling prefix. Fixes bug
	232.
	Fix DEBUG build.  Add missing test for __riscosify_std failure.
	* test/stdlib/system-alias.c: Added.

Sat Apr 28 19:02:48 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/dirent.h (struct __dir_stream): Made dd_name_can const
	pointer.
	* common/serial.c (__get_file_ino): Fix the directory + filename case.
	Simplified code.  Made inode calculation unsigned.
	* test/dirent/tst-dirent-ino.c: Added.

Sat Apr 28 15:37:26 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* unix/glob.c (g_Ctoc): Reimplement and avoid the wcrtomb call.  Fixes
	bug 229.

Thu Apr 26 03:32:38 CEST 2012  John Tytgat  <John.Tytgat@aaug.net>

	* unix/getcwd.c (getcwd): Support buffer being NULL.  Fixes bug 227.
	* test/unix/getcwd.c: Enhance test case.

Wed Apr 25 20:57:01 BST 2012  Lee Noar  <leenoar@sky.com>

	* time/broken.c(SWI_Territory_ConvertOrdinalsToTime): Add
	missing return statement. Fix for bug 226.

Thu Mar 22 19:56:15 GMT 2012  Lee Noar  <leenoar@sky.com>

	* include/sys/elf.h(DT_RISCOS_PIC,DT_RISCOS_ABI_VERSION):
	Define.
	* gen-auto.pl: Generate file misc/abi.c.
	* Makefile.am: Add misc/abi.c to list of files to compile.

Sun Mar 11 18:59:09 GMT 2012  Lee Noar  <leenoar@sky.com>

	* include/stdio.h: Fix build in 4.1.2 branch. fgets.c
	defines a strong alias for fgets_unlocked, so this define
	is no longer required.

Sat Mar  3 17:37:27 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* netlib/get_ro_socket.c: Add.
	* include/unixlib/local.h (__get_ro_socket): Add.
	* Makefile.am (netlib_src): Add netlib/get_ro_socket.c.

Fri Mar  2 22:51:55 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* unix/features.c (__sfix_default): Remove "a".
	* common/riscosify.c (__sfix_default): Likewise.

Thu Mar 01 14:51:32 GMT 2012  Lee Noar  <leenoar@sky.com>

	* stdio/fpos.c(fseeko64): Fix offset sanity check. This fixes
	the "Value too large for defined data type" errors in GAS.
	Already fixed on trunk in r5495.

Sat Feb 18 11:44:27 GMT 2012  Lee Noar  <leenoar@sky.com>

	* unistd/symlink.c(symlink): More compact code and better
	error handling.

Fri Feb 17 20:36:11 GMT 2012  Lee Noar  <leenoar@sky.com>

	* unistd/symlink.c(symlink): Implement writing of symlink
	files.

Sat Feb  4 12:04:02 GMT 2012  Lee Noar  <leenoar@sky.com>

	* include/sys/mman.h: Define MADV_FREE (even though we
	don't support madvise).
	* pthread/sem.c (sem_timedwait): Dummy function to prevent
	linker errors in programs that reference it.

Thu Feb  2 22:54:49 GMT 2012  Lee Noar  <leenoar@sky.com>

	* unix/dev.c (__fslseek): File pointer should be set based
	on the old value of lpos not being 0.

Thu Feb  2 20:39:37 GMT 2012  Lee Noar  <leenoar@sky.com>

	* unix/dev.c (__fslseek): For SEEK_CUR, return the current
	file pointer even if lpos is 0.

Sat Jan 21 17:39:02 GMT 2012  Lee Noar  <leenoar@sky.com>

	* include/dlfcn.h: Define RTLD_LOCAL.

Tue Jan 10 23:24:55 CET 2012  John Tytgat  <John.Tytgat@aaug.net>

	* include/stdlib.h (realloc): Drop malloc attribute.

Thu Dec 29 22:01:36 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* debug/dvsprintf.c (UNIXLIB_STDERR): Remove support (causes more
	trouble than it is able to pinpoint).

Thu Dec 29 21:50:41 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/printf.c: Minor cleanup.
	* stdio/newstream.c: Likewise.
	* string/mempcpy.c: White space change.
	* string/strdup.c: Likewise.
	* wchar/wmempcpy.c
	* stdio/fgets.c (fgets): Remove test on input parameters.
	Simplify (remove test on ferror).
	* stdio/gets.c (gets): Likewise.
	* stdio/flsbuf.c (__flslbbuf): Minor cleanup.
	(__flsbuf): Add check on writable streams. Use size_t instead of
	int as type for number of bytes to write. Fix return value check
	of write.
	* stdio/filbuf.c (check_stream): A non-readable stream should
	set stream in error state.  Move EOF check to...
	(__filbuf): ...here. Use ssize_t instead of int.
	(fill_buffer): Minor cleanup.  Use ssize_t instead of int.
	(__peek_char): Add check on EOF.  Use ssize_t instead of int.
	* unix/scl_lseek.c (lseek): Fix fseeko return value check.
	* unix/dev.c (__fsopen): Minor cleanup.
	* locale/localeconv.c (xfree): Remove.
	(localeconv): Use free directly.

Mon Dec 26 16:06:13 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fpurge.c (__fpurge): Define as strong alias of fpurge.
	(fpurge): Drop unused variable.

Mon Dec 26 16:04:12 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* include/stdio.h (struct __iobuf): Change type of __offset from
	fpos_t to __off_t.

Fri Dec  9 20:01:02 GMT 2011  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s (__pthread_callback): After a jump to
	skip_contextswitch, ip is the PIC register, not v4.

Wed Dec  7 00:40:14 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/scl_fdopen.c (fdopen): Use __FD_SOCKET_OFFSET instead of
	_SYS_OPEN.
	* stdio/scl_fileno.c (fileno): Simplify implementation.
	* unix/ul_readv.c (readv): Count being 0 is not an error.  Check
	for ssize_t overflow.
	* unix/ul_writev.c (writev): Likewise.
	* unix/scl_readv.c (readv): Support file based fd (based on
	unix/ul_readv.c).
	* unix/scl_writev.c (writev): Support file based fd (based on
	unix/ul_writev.c).
	* unix/scl_write.c (write): Support file based fd.
	* unix/scl_read.c (read): Likewise.
	* unix/open.c: Renamed to...
	* unix/ul_open.c: ...this.
	* unix/isatty.c: Renamed to...
	* unix/ul_isatty.c: ...this.
	* unix/scl_open.c: Add (migrated from libscl's riscos/riscos.c).
	Reworked implementation.
	* unix/scl_isatty.c: Likewise.
	* unix/scl_lseek.c (lseek, lseek64): Add support for file based fd.
	* unix/scl_close.c (close): Likewise.
	* unix/scl_ioctl.c (ioctl): Likewise.
	* doc/SCL/COPYING: Add (migrated from libscl's COPYING).
	* COPYING: Moved to...
	* doc/UnixLib/COPYING: ...here.
	* COPYING: Add (refering to doc/SCL/COPYING and
	doc/UnixLib/COPYING).
	* include/unixlib/types.h (__FD_SOCKET_OFFSET): Add.
	* include/sys/select.h (FD_SETSIZE): Define as __FD_SETSIZE.
	(__FDELT, __FDMASK): Take __FD_SOCKET_OFFSET into account.
	* netlib/setsockopt.c (setsockopt): Add check on non-socket fd
	values.  Take __FD_SOCKET_OFFSET into account.
	* include/stdio.h (FOPEN_MAX): Change from 8 to _SYS_OPEN.
	(_SYS_OPEN): Define as __FD_SOCKET_OFFSET.
	* include/unistd.h (isatty, unlink): Define for SCL.
	* netlib/accept.c (accept): Likewise.
	* netlib/sendmsg.c (sendmsg): Likewise.
	* netlib/recvmsg.c (recvmsg): Likewise.
	* netlib/getpeernam.c (getpeername): Likewise.
	* netlib/send.c (send): Likewise.
	* netlib/listen.c (listen): Likewise.
	* netlib/recv.c (recv): Likewise.
	* netlib/shutdown.c (shutdown): Likewise.
	* netlib/bind.c (bind): Likewise.
	* netlib/getsockopt.c (getsockopt): Likewise.
	* netlib/recvfrom.c (recvfrom): Likewise.
	* netlib/connect.c (connect): Likewise.
	* netlib/getsocknam.c (getsockname): Likewise.
	* netlib/sendto.c (sendto): Likewise.
	* netlib/socket.c (socket): Add __FD_SOCKET_OFFSET.
	* scl/chunkid02.s (unlink): Add as alias to remove.
	* Makefile.am: Follow rename unix/isatty.c to unix/ul_isatty.c,
	unix/open.c to unix/ul_open.c.
	(unix/scl_isatty, unix/scl_open): Add.
	* incl-local/internal/os.h (SWI_OS_File_ReadCatInfo): Add.
	(SWI_OS_Args_GetFileHandleStatus): Add.

Sun Dec  4 16:21:58 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* contrib/Help: Moved to...
	* doc/UnixLib/Help: ...here.
	* README: Moved to...
	* doc/UnixLib/README: ...here.
	* doc/SCL/README: Add.  Updated libscl's README.

Tue Nov 22 02:15:11 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/freopen.c (freopen64): Add dummy implementation.
	* stdio/tmpfile.c (tmpfile64): Likewise.
	* stdio/ul_fopen.c (fopen64): Likewise.
	* stdio/fpos.c (fgetpos64, fsetpos64, fseeko64, ftello64): Likewise.
	* unix/creat.c (creat64): Likewise.
	* unix/open.c (open64): Likewise.
	* unistd/lockf.c (lockf64): Likewise.
	* include/fcntl.h (open64, creat64, lockf64): Add prototypes.

Sat Nov 12 00:19:57 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* include/fenv.h (feenableexcept, fedisableexcept, fegetexcept):
	Add.
	* include/time.h, include/time.h, include/sys/select.h,
	include/getopt.h, include/string.h, include/wchar.h,
	include/search.h, include/unistd.h: Disable function prototypes for
	non-supported functions in SCL build.

Thu Nov  3 11:04:12 GMT 2011  Lee Noar  <leenoar@sky.com>

	* unix/getcwd.c (getcwd): Fix potential buffer overflow.
	getcwd() should set errno to ERANGE and return NULL if the size
	of the buffer supplied is too small for the path. It would
	appear that it relies on unixify() to do this, however, unixify()
	only checks for buffer overflow when the path does not require
	any processing. As RISC OS itself is supplying the path, then by
	default it will always require processing to unix format, so buffer
	overflow is never detected. Fix by adding an explicit check before
	calling unixify().

Tue Nov  1 21:42:53 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* unix/ul_lseek.c (lseek): Change off_t into __off_t.
	(lseek64): Change off_t into __off64_t.  Add check on __off64_t
	into __off_t overflow.
	* scl/chunkid05.s: Remove wrong entry after scalbln.  Add entries
	from isblank to tmpfile64.
	* include/unixlib/buildoptions.h (__UNIXLIB_LFS64_SUPPORT): Add.
	* include/unixlib/types.h (__off_t): Fix for UnixLib case.
	(__off64_t): Define as __quad_t, not __loff_t.
	* include/sys/types.h (__loff_t): Remove.
	* include/sys/stat.h (off_t): Support __USE_FILE_OFFSET64 and
	__USE_LARGEFILE64.
	* include/stdio.h (off_t, fpos_t): Support __USE_FILE_OFFSET64 and
	__USE_LARGEFILE64.
	(fopen, freopen): Likewise.
	(fgetpos, fsetpos): Likewise.
	(ftell, fseek): Likewise.
	(tmpfile): Likewise.
	(TEMP_FAILURE_RETRY): Move to unistd.h.
	(fopen64, freopen64, fgetpos64, fsetpos64, ftello, fseeko,
	ftello64, fseeko64, tmpfile64): Add.
	* include/unistd.h (off_t): Support __USE_FILE_OFFSET64 and
	__USE_LARGEFILE64.
	(TEMP_FAILURE_RETRY): Add (changed version from stdio.h).

Sun Oct 30 20:34:23 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* include/errno.h (EILSEQ, EOVERFLOW, EFBIG): Reassigned values for
	SCL configuration to match recent ROOL CLib changes.
	(EPERM, ENOENT, ESRCH, EINTR, EIO, ENXIO): Reassigned values for
	SCL configuration to avoid aliasing other error values.
	* sys/errlist.c: Follow errno.h changes.
	* Makefile.am (time/adjtime): Removed from SCL build.

Fri Oct 28 04:04:12 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am: Workaround for automake conditionals limitation.

Thu Oct 27 01:36:00 BST 2011  John-Mark Bell  <jmb@netsurf-browser.org>

	* sys/_syslib.s: Prevent stack extension trampling the signal handler
	stack chunk. This is achieved by inserting an 8 byte gap between the
	signal handler stack and the initial stack chunk which is then used
	by the stack allocator for its heap metadata.
	* sys/stackalloc.c (__stackalloc_init): Reflect above change, and
	ensure that the signal handler block size/startofcon fields are
	initialised to sane values such that the block is left alone when
	stack extension takes place. The initial location of dummytopblock
	is now above the signal handler stack.
	* test/sys/stackextension.c: Test for above issue.

Mon Sep 26 00:41:39 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* time/stdtime.c (SWI_Territory_ConvertDateAndTime): Add missing
	buffer specification.  Bug #223.

Thu Sep  8 00:10:25 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c (find_terminator): Remove.
	(check_io_redir): Support for double quoted redirection filenames.
	(get_io_redir): Simplify calls to check_io_redir.
	Bug #221.

Wed Sep  7 00:08:02 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fread.c (fread): Set EOF when last byte is read.
	Fix returned number of objects read when there is a partial one read.

Sat Aug 27 20:34:12 2011  Lee Noar <leenoar@sky.com>

	* unix/getcwd.c(getcwd): Only free ro_path if it was
	allocated with malloc in the first place.

Sat Jul  2 15:14:30 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* include/glob.h: Copy from FreeBSD 8.0.0 with a couple of
	UnixLib changes.  Solves bug #220.
	* unix/glob.c: Likewise.

Sun May 29 18:32:56 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* include/sys/stat.h (S_IFBLK, S_IFLNK): Renumber.
	(S_IFMT): Trim bits.
	(S_ISREG, S_ISFIFO, S_ISLNK): Use S_IFMT mask so that
	result is 0 or 1.

Sun May 29 17:21:43 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c (__fsopen): Return ENOENT iso EAGAIN when non-existing
	file is opened without O_CREAT set.

Sun Apr 24 13:16:13 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* string/strdup.c (strdup): Don't check on NULL parameter.
	It's nowhere documented we should.

Wed Apr  6 03:27:25 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c (convert_command_line): Use __canonicalise_path
	instead of __os_swi.
	* unix/dirent.c (newstream): Likewise.
	* unix/truncate.c (ftruncate, truncate): Use SWI_OS_Args_* instead
	of __os_args.
	* unix/sync.c (sync, fsync): Likewise.
	* unix/open.c (__open_fh): Follow rename __fd_to_name to
	__canonicalise_handle.
	* unix/pathconf.c (fpathconf): Use SWI_OS_Args_Canonicalise instead
	of __fd_to_name.
	* unix/fchmod.c (fchmod): Likewise.
	* debug/debug.c (__debug): Likewise. Print filename for DEV_PIPE
	handles as well.
	* stdlib/realpath.c (realpath): Use SWI_OS_FSControl_Canonicalise
	instead of __os_swi.
	* unix/chdir.c (chdir): Likewise.
	* common/serial.c (__get_file_ino): Likewise.
	* unix/getcwd.c (getcwd): Likewise.
	(getwd): Move to...
	* unix/getwd.c: ...here.
	* unix/dev.c (__fsopen): Use SWI_OS_FSControl_Canonicalise instead of
	__os_swi.
	(__fsclose, __fsfstat): Follow rename __fd_to_name to
	__canonicalise_handle.
	(__fslseek,__fsfstat,__pipewrite,__pipeselect): Use SWI_OS_Args_*
	instead of __os_args.
	* unix/tty.c (__tty_console_gterm): Fix compiler warning.
	* sound/dsp.c (__dspopen): Likewise.
	* time/gmtime_r.c (SWI_Territory_ConvertTimeToUTCOrdinals): Likewise.
	* time/broken.c (SWI_Territory_ConvertOrdinalsToTime): Likewise.
	* time/localtime_r.c (SWI_Territory_ConvertTimeToOrdinals): Likewise.
	* sys/_syslib.s (__ul_global): Move to...
	* common/global.c: ...here.
	* common/canonicalise_path.c (__canonicalise_path): Add.
	* common/fdname.c (__fd_to_name): Removed and reimplemented same in...
	* common/canonicalise_handle.c (__canonicalise_handle): ...here.
	* Makefile.am (common/canonicalise_handle.c,common/canonicalise_path.c,
	common/global.c,unix/getwd.c): Add.
	common/fdname.c: Remove.
	* incl-local/internal/local.h (__fd_to_name): Remove.
	(__canonicalise_path,__canonicalise_handle): Add.
	* incl-local/internal/asm_dec.s (GBL_*): Update for GBL_UL_OUT_PATHNAME
	entry.
	* incl-local/internal/os.h (__os_args): Remove.
	(SWI_OS_FSControl_Canonicalise,SWI_OS_Args_GetFilePtr,
	SWI_OS_Args_SetFilePtr,SWI_OS_Args_GetExtent,SWI_OS_Args_SetExtent,
	SWI_OS_Args_Canonicalise,SWI_OS_Args_Flush): Add.
	* sys/_os.s (__os_args): Remove.
	* incl-local/internal/unix.h (ul_global::ul_out_pathname): Add.
	Add comments.
	* sys/exec.c (execve): Use SWI_OS_FSControl_Canonicalise instead of
	__os_swi.  Fill in __ul_global.ul_out_pathname.  Use SWI_OS_Args_*
	instead of __os_args.
	* sys/vfork.c (__fork_post): Fix stdout redirection when non-UL
	processes are exec'd by reopening output handle.

Sun Apr  3 20:27:41 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/os.h (SWI_OS_Byte): Renamed from __os_byte. Only
	write output registers when no error happened.  Mark as always to
	inline.
	(SWI_OS_CLI): Renamed from __os_cli.  Mark as always to inline.
	(SWI_OS_ChangeRedirection,SWI_DDEUtils_SetCLSize,SWI_DDEUtils_SetCL,
	SWI_DDEUtils_GetCLSize,SWI_DDEUtils_GetCL,SWI_DDEUtils_Prefix,
	SWI_DDEUtils_ReadPrefix): Add.
	* unix/unix.c (__unixinit,initialise_unix_io): Make use of new SWI_*
	calls.
	* unix/gethostnam.c (fakehostname): Likewise.
	* unix/dev.c (__randomopen): Likewise.
	* unix/tty.c (__tty_console_gterm, __tty_console_sterm, __ttyicanon):
	Likewise.
	* unix/chdir.c (chdir): Likewise.
	* sound/dsp (__dspopen): Likewise.
	* common/prefix.c (__get_dde_prefix): Likewise.
	* gmon/machine-gmon.c (load_hal26_module): Likewise.
	* sys/exec.c (set_dde_cli, execve): Likewise.
	* sys/vfork.c (__fork_post): Likewise.
	* time/gmtime_r.c, time/stdtime.c, time/broken.c, time/localtime_r.c,
	time/clock.c, locale/iconv.c, common/env.c, incl-local/sys/socket.h:
	Mark inline assembler as always to inline.

Sun Apr  3 15:10:40 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* sys/errlist.c (sys_errlist): Change entry 0 from "Error 0"
	to "Success".

Sat Apr  2 02:17:17 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* time/_clock.s (clock): Removed.
	* time/clock.c (clock): Add.
	* Makefile.am: Follow changes.

Tue Mar 29 23:14:41 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am (common/cvttime.c): Add to SCL build.
	(time/utimes.c): Remove from SCL build.
	(time/calendconv.c): Remove.
	* time/calendconv.c: Remove after merging its contents as inline
	assembler with...
	* time/gmtime_r.c (gmtime_r): ...this and...
	(SWI_Territory_ConvertTimeToUTCOrdinals): Add.
	* time/localtime_r.c (localtime_r): ...this.
	(SWI_Territory_ConvertTimeToOrdinals): Add.
	* incl-local/time.h (__cvt_broken_time): Change return type from void
	to const _kernel_oserror.
	* time/asctime_r.c (asctime_r): Check return value __cvt_broken_time.
	* time/mktime.c (mktime): Likewise.
	* time/strftime.c (strftime): Likewise.
	* time/stdtime.c (__standard_time): Use inline assembler.
	(SWI_Territory_ConvertDateAndTime): Add.
	* time/broken.c (__cvt_broken_time): Use inline assembler.
	(SWI_Territory_ConvertOrdinalsToTime): Add.
	(__cvt_broken_time): Return error if there was one.
	* incl-local/locale.h (__locale_territory, __setlocale_called,
	__build_ctype_tables): Don't prototype these for SCL build.
	* incl-local/internal/os.h (__ul_seterr): Fix outdated comment.

Tue Mar 29 00:52:27 CEST 2011  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/os.h (__os_cli, __os_byte): Change into inline
	assembler versions.
	* sys/_os.s (__os_cli,__os_bytes): Remove.
	* unix/unix.c (__unixinit, _exit): Follow __os_byte API change.
	* unix/gethostnam.c (fakehostname): Likewise.
	* sys/vfork.c (__fork_post): Likewise.
	* unix/tty.c (__tty_console_gterm, __tty_console_sterm, __ttyicanon):
	Likewise.
	* locale/iconv.c (iconv_open, iconv, iconv_close): Don't use __os_swi
	but use SWI_Iconv_Open, SWI_Iconv_Iconv and SWI_Iconv_Close.
	(SWI_Iconv_Open, SWI_Iconv_Iconv, SWI_Iconv_Close): Add.
	* configure.ac (AC_OUTPUT): Add test/iconv/Makefile.
	* test/iconv/{test-iconv-h.c,signature.h,test-iconv-utf.c,
	test-iconv-h-c++.cc,macros.h,test-iconv.c
	* test/iconv/config.h: Add.
	* string/strnicmp.c (strncasecmp): Add strong alias for SCL case as
	well.

Tue Mar 22 01:04:59 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* include/netinet/in.h: Sync with glibc 2.11.
	* include/bits/sockaddr.h: Likewise.
	* include/bits/byteswap.h: Likewise.
	* include/bits/in.h: Likewise.
	* include/sys/socket.h: Likewise.
	* include/bits/socket.h: Likewise (i.e. use 4.4 BSD version instead
	of 4.3 BSD).
	* incl-local/sys/socket.h (__SYS_SOCKET_H): Trim one leading
	underscore.
	* include/endian.h (__ENDIAN_H): Trim one leading underscore.
	* include/sys/byteorder.h: Likewise.

Sat Mar 12 15:04:27 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/perror.c (perror): Add check on empty string.

Wed Mar  2 23:43:45 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* signal/killpg.c: Add.
	* Makefile.am (killpg): Add.
	* include/signal.h (kill, killpg): Conditionalize declarations.

Tue Mar  1 23:29:38 CET 2011  Jeffrey Lee  <me@phlamethrower.co.uk>

	* sys/_getcpuarch.s (__get_cpu_arch): Support ARM arch 7.

Tue Feb  8 03:17:42 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am: Revert previous change.  This wrongly results in PIC
	enabled libunixlib.a archives.

Sat Feb  5 10:55:00 UTC 2011  John-Mark Bell  <jmb@netsurf-browser.org>

	* module/sul.s: Test the existence of the canonicalised	filename on
	program initialisation, rather than the original sul_exec() argument.
	Fixes detection of child application that lives on Run$Path.
	Additionally, fix stripping of FS name in process structure search to
	accept the program name provided by OS_GetEnv having no colons in it
	(e.g. when it resides on RPCEmu's HostFS). Otherwise, it will skip over
	the first entry in the process list without considering it.
	Bump version number and update copyright years.

Wed Feb  2 00:29:05 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* Makefile.am: Avoid overruling targets needing custom CFLAGS by
	splitting libunixlib in two libraries.

Tue Jan 25 19:59:02 2011  Lee Noar  <leenoar@sky.com>

	* scl/chunkid01.s: Make sure bss section has word alignment.
	* scl/chunkid02.s: Likewise.

Sun Jan 23 19:02:26 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* kernel/kosfile.s (_kernel_osfile): Fix based on the fact that 2nd
	parameter can not be NULL.

Mon Jan 17 23:11:28 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* COPYING: Update copyright year.
	* crypt/crypt-entry.c: Poison for SCL build.
	* crypt/md5.c,crypt/md5-crypt.c,fenv/fclrexcpt.c,fenv/fedisblxcpt.c,
	fenv/feenablxcpt.c,fenv/fegetenv.c,fenv/fegetexcept.c,
	fenv/fegetround.c,fenv/feholdexcpt.c,fenv/fesetenv.c,fenv/fesetround.c,
	fenv/fraiseexcpt.c,fenv/fsetexcptflg.c,fenv/ftestexcept.c,
	gmon/gmon-start.c,gmon/profil.c,misc/dirname.c,netlib/ul_in6_addr.c,
	resolv/ul_opensock.c,resolv/ul_res_hconf.c,search/hsearch.c,
	search/insremque.c,search/lsearch.c,search/tsearch.c,signal/sleep.c,
	stdlib/msort.c,stdlib/xpg_basename.c,string/basename.c,string/memrchr.c,
	string/rawmemchr.c,string/strchrnul.c,string/strndup.c,string/strnlen.c,
	string/swab.c,sys/alarm.c,unistd/getpass.c,unistd/lockf.c,unix/getopt1.c,
	unix/getopt.c,unix/pselect.c,wchar/btowc.c,wchar/mbrlen.c,wchar/mbrtowc.c,
	wchar/mbsinit.c,wchar/mbsnrtowcs.c,wchar/mbsrtowcs.c,wchar/wcpcpy.c,
	wchar/wcpncpy.c,wchar/wcrtomb.c,wchar/wcscat.c,wchar/wcschr.c,
	wchar/wcscmp.c,,wchar/wcscoll.c,wchar/wcscpy.c,wchar/wcscspn.c,
	wchar/wcsdup.c,wchar/wcslen.c,wchar/wcsncat.c,wchar/wcsncmp.c,
	wchar/wcsncpy.c,wchar/wcsnrtombs.c,wchar/wcspbrk.c,wchar/wcsrchr.c,
	wchar/wcsrtombs.c,wchar/wcsspn.c,wchar/wcsstr.c,wchar/wcstok.c,
	wchar/wcswidth.c,wchar/wctob.c,wchar/wcwidth.c,wchar/wmemchr.c,
	wchar/wmemcmp.c,wchar/wmemcpy.c,wchar/wmemmove.c,wchar/wmemset.c:
	Likewise.
	* Makefile.am: Add comment libm-complex, libm-dbl64, lib-m-flt32 and
	libm-generic sources should not be used in SCL build.

Sun Jan 16 19:24:04 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* string/stricmp.c (strcasecmp): Enable as strong alias for stricmp
	in SCL build.
	* string/strdup.c (strdup, __strdup): Minor cleanup.

Sat Jan 15 22:33:33 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/elf-macros.s (CHGMODE): Fix bug exposed by
	binutils 2.21.

Mon Jan 10 03:24:52 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* resource/getrlimit.c (getrlimit): Follow prototype change.
	* resource/setrlimit.c (setrlimit): Likewise.
	* resource/getrusage.c (getrusage): Likewise.
	* resource/getprior.c (getpriority): Likewise.
	* resource/setprior.c (setpriority): Likewise.
	* include/sys/resource.h: Split off types to...
	* include/bits/resource.h: ...this new file.
	* include/sys/resource.h (__rlimit_resource_t, __rusage_who_t,
	__priority_which_t): New types which are either int or enum.
	* include/sys/wait.h: Hard include sys/resource.h.
	(wait3, wait4): Conditional declaration.
	* Makefile.am (bits/resource.h): Add.

Mon Jan 10 02:31:26 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* string/mempcpy.c (mempcpy): New.
	* include/string.h (mempcpy): Declare.
	* wchar/wmempcpy.c (wmempcpy): New.
	* include/wchar.h (wmempcpy): Declare.
	* Makefile.am (string/mempcpy.c, wchar/wmempcpy): Add.
	* stdlib/msort.c (msort_with_tmp): Use __mempcpy.

Wed Jan  5 00:42:46 CET 2011  John Tytgat  <John.Tytgat@aaug.net>

	* README: Latest iconv version is 0.11.

Mon Nov 29 23:23:47 CET 2010  Jeffrey Lee  <me@phlamethrower.co.uk>
			      John Tytgat  <John.Tytgat@aaug.net>

	* include/sys/mman.h (msync): Update comment.
	* sys/mman.c (mmap_info): Add flags, fd and offset.
	(mmap): Remove check DA being enabled for heap usage.
	(msync): Add basic implementation.
	(munmap): Flush changes.
	(mremap): Add check on unsupported case of remapping mapped files.

Sun Oct  3 17:08:22 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* signal/post.c: Minor cleanups.
	* gdtoa/arith.h: Add ARM/VFP case.

Sun Oct  3 14:28:27 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* include/math.h: Only include bits/huge_vall.h when
	__NO_LONG_DOUBLE_MATH is not defined.
	* include/bits/huge_val.h(HUGE_VAL): Fix ARM/FPA case when explicit
	values were used.  Implement ARM/VFP case.
	* include/bits/huge_vall.h: Removed.
	* Makefile.am(bits/huge_vall.h): Removed.

Sun Oct  3 11:42:13 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/defines.h(__ARM_ARCH__,__ARM_ARCH_STR__): Added
	tests on __ARM_ARCH_6T2__,__ARM_ARCH_6M__ and __ARM_ARCH_7EM__.

Sun Oct  3 01:49:42 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/strtoul.c, stdlib/strtoull.c, stdlib/strtoll.c,
	stdlib/random.c, dlib/strtol.c, stdio/floatio.h, gdtoa/dmisc.c,
	gdtoa/dtoa.c, gdtoa/fpmath.h, gdtoa/g_ddfmt.c, gdtoa/g_dfmt.c,
	gdtoa/gdtoa.c, gdtoa/gdtoa.h, gdtoa/gdtoaimp.h, gdtoa/gethex.c,
	gdtoa/g_ffmt.c, gdtoa/g__fmt.c, gdtoa/glue.c, gdtoa/gmisc.c,
	gdtoa/g_Qfmt.c, gdtoa/g_xfmt.c, gdtoa/g_xLfmt.c, gdtoa/hd_init.c,
	gdtoa/_hdtoa.c, gdtoa/hexnan.c, gdtoa/misc.c, gdtoa/README,
	gdtoa/smisc.c, gdtoa/strtod.c, gdtoa/strtodg.c, gdtoa/strtodI.c,
	gdtoa/strtof.c, gdtoa/strtoId.c, gdtoa/strtoIdd.c, gdtoa/strtoIf.c,
	gdtoa/strtoIg.c, gdtoa/strtoIQ.c, gdtoa/strtoIx.c, gdtoa/strtoIxL.c,
	gdtoa/strtopd.c, gdtoa/strtopdd.c, gdtoa/strtopf.c, gdtoa/strtopQ.c,
	gdtoa/strtopx.c, gdtoa/strtopxL.c, gdtoa/strtord.c, gdtoa/strtordd.c,
	gdtoa/strtorf.c, gdtoa/strtorQ.c, gdtoa/strtorx.c, gdtoa/strtorxL.c,
	gdtoa/sum.c, gdtoa/ulp.c: Updated with FreeBSD trunk.
	* gdtoa/gd_qnan.h: Added.
	* gdtoa/fpmath.h: Update comments.
	(union IEEEl2bits,mask_nbit_l,LDBL_MANH_SIZE,LDBL_MANL_SIZE,
	LDBL_TO_ARRAY32): Removed.
	* gdtoa/_ldtoa.c: Removed.
	* stdio/vfprintf.c (__vfprintf): Enable call to wcsrtombs.  Disable
	calls to __hldtoa and __ldtoa.
	* wchar/wcsrtombs.c (__wcsrtombs): Rename to wcsrtombs.
	* include/endian.h: Softfloat (non VFP) build means __FLOAT_BIT_ORDER
	being __LITTLE_ENDIAN.  Add case for VFP mode.
	* include/ieee754.h: Update comments.
	(union ieee854_long_double): Remove.
	* Makefile.am (gdtoa/_ldtoa.c): Removed.

Sun Sep 26 20:50:20 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* gcccompat/_b_return.s: Remove __ARM_EABI__ check.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/galloca.c: Likewise.
	* gcccompat/_eh_support.s: Likewise.
	* gcccompat/_b_frame.s: Likewise.
	* Makefile.am: Don't build gcccompat/* sources for non chunked stack
	builds.
	* include/unixlib/buildoptions.h: Add check on EABI and chunked stack
	combination.  Moved related chunk build options inside a
	__UNIXLIB_CHUNKED_STACK check.

Sun Sep 26 18:59:59 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* include/bits/sched.h: Fix check on include guard for features.h.
	* include/sys/resource.h: Likewise.
	* include/pwd.h: Likewise.
	* include/sched.h: Likewise.
	* include/pthread.h: Likewise.

Sun Sep 26 18:16:46 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* kernel/kcurskch.s ( _kernel_current_stack_chunk): Return NULL for
	non chunked stack builds.
	* pthread/create.c (__pthread_create): Hacks for non chunked stack
	builds.
	* pthread/newnode.c (__pthread_new_stack): Likewise.
	* pthread/context.c (__pthread_cleanup_idle): Likewise.
	* configure.ac (UNIXLIB_CHUNKED_STACK): New conditional which gets
	set for non arm-unknown-riscos targets.
	(BUILDING_SCL): Rename to UNIXLIB_BUILDING_SCL.
	* include/unixlib/buildoptions.h: Allow _UNIXLIB_* buidoptions to
	be set from the top Makefile.
	(__UNIXLIB_CHUNKED_STACK): Added.
	* Makefile.am: Add __UNIXLIB_CHUNKED_STACK to CFLAGS and CCASFLAGS.
	Follow BUILDING_SCL to UNIXLIB_BUILDING_SCL rename.
	* README-DEV: Add 'Development' section.
	* incl-local/internal/asm_dec.s: Don't define CHUNK_* for non
	chunked stack builds.
	* incl-local/internal/unix.h: Disable sys/stackalloc.c prototypes
	which are not available in non chunked stack builds.
	* sys/stackalloc.c: Have only the __stackalloc_incr_wimpslot
	function for non chunked stack builds.
	* sys/_syslib.s: First attempt at non chunked stack setup.

Sat Sep 11 18:37:46 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fwrite.c (fwrite): Do not call __flsbuf when fd is -1 as this
	is a magic value.

Thu Sep  9 00:21:32 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c (__fsopen): Give error EISDIR when directory is opened
	for O_RDWR.  Reported by John-Mark Bell.
	* Makefile.am: Removed non-existing sys/netdb.h for install.  Avoid
	creating empty resolv include subdirectory.

Thu Aug 26 03:36:17 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/getenv (__intenv): Move to...
	* unix/pipe.c: ...here.  Changed return type to unsigned int.
	(pipe): Follow return type change.
	* incl-local/internal/unix.h (__intenv): Remove prototype.
	* vscript (__intenv): Remove.
	* unix/getenv.c: Moved remaining part to...
	* unix/ul_getenv.c: ...here.
	* unix/setenv.c (__addenv_to_os): Moved to common/env.c as new file.
	(__remenv_from_os): Likewise.
	(unsetenv): Moved to unix/ul_unsetenv.c.  Tail call __remenv_from_os.
	(clearenv): Moved to unix/ul_clearenv.c.
	Moved remaining part to...
	* unix/ul_setenv.c: ...here.
	* unix/putenv.c: Move to...
	* unix/ul_putenv.c: ...here. Minor cleanup.
	* unix/scl_setenv.c: Added.
	* unix/scl_unsetenv.c: Likewise.
	* unix/scl_putenv.c: Likewise.
	* test/env/basicenvtest.c: Added.

Sun Aug  1 22:43:42 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* include/sys/time.h (__itimer_which_t): Added for C++ support.
	(getitimer, setitimer): enum __itimer_which -> __itimer_which_t.
	(setitimer): Add __restrict.
	(utimes): Add __nonnull.
	* time/getitmr.c (getitimer): enum __itimer_which -> __itimer_which_t.
	* time/setitmr.c (setitimer): Likewise.

Thu Jul 22 16:16:53 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/custom.c (__unixlib_getdev): Made static.
	(__customstat,__customfstat,__customlstat): Remove.
	Source cleanup.
	* unix/ul_select.c (select): Unconstify.
	* unix/scl_select.c: Add include sys/socket.h.
	* unix/ttyname_r.c: Add include string.h.
	* unix/dev.c: Directly route __customstat/__customfstat/__customlstat
	to __nullstat/__nullfstat/__nullstat.
	* time.time.c: Add include internal/local.h.
	* time/calendconv.c: Likewise.
	* time/ctime_r.c: Likewise.
	* netlib/scl_getservbyport.c (getservbyport): Add cast.
	* scl/scl_fpclassify.s (__fpclassify): Remove S from TEQEQS.
	* common/cvttime.c: Reformat.
	* incl-local/internal/local.h: Remove include internal/fd.h.
	(__open_fn,__open_fh,__close,__reopen): Move prototypes to...
	* incl-local/internal/fd.h: ...here.
	* incl-local/internal/dev.h (__customstat,__customfstat,
	__customlstat): Remove prototypes.
	* incl-local/pthread.h: Add include kernel.h.
	(struct __pthread_thread): Use _kernel_oserror type.
	* sys/errlist.c: Add include stdio.h.

Sat Jul  3 19:20:39 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* include/sys/socket.h (__SOCKADDR_ARG, __CONST_SOCKADDR_ARG): Add
	temporary workaround for llvm-gcc bug
	(http://llvm.org/bugs/show_bug.cgi?id=7422).

Wed Jun 16 15:17:11 2010  Lee Noar  <leenoar@sky.com>

	* crt/(g)crt0.s(_start): Store pointers to shared library static
	object initialisation/finalisation routines.
	* sys/_syslib.s: Remove the reference to _dl_call_ctors by allowing
	the dynamic loader to pass in the address of a suitable function.
	Call/register dynamic loader supplied shared library init/fini
	functions (if not NULL).
	(__check_stack): Don't rely on caller for PIC register. In the
	shared library, the stack chunk dealloc function and return address
	can and will be higher than application address space so don't use
	them for stack validation.
	* incl-local/internal/asm_dec.s: Rename CRT1_RESERVED1 and
	CRT1_RESERVED2 as CRT1_LIB_INIT and CRT1_LIB_FINI respectively.

Wed Jun  9 00:05:06 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/putenv.c(__addenv_to_env): No need to call __set_errno(ENOMEM)
	after a failed malloc/realloc call.
	* grp/getgroups.c(setgroups): Likewise.
	* common/objattr.c(__object_get_attrs,__object_set_attrs): Likewise.
	* common/symlinks.c(__resolve_symlinks): Likewise.
	* include/unistd.h(lseek64): Consistent declaration like other 64-bit
	variants.
	* unix/reopen.c(__reopen): Minor code cleanup.
	* unix/pipe.c(pipe): Likewise.
	* unix/dup2.c(dup2): Likewise.
	* unix/fchmod.c(fchmod): Likewise.
	* unix/ul_lseek.c(lseek64): Likewise.
	* unix/gethostnam.c(gethostname): Likewise.
	* unix/sync.c(fsync): Likewise.
	* grp/getgroups.c(initgroups): Likewise.
	* grp/getgrnam_r.c(getgrnam_r): Likewise.
	* grp/getgrgid_r.c(getgrgid_r): Likewise.
	* unistd/fchdir.c(fchdir):  Likewise.
	* unistd/fchown.c(fchown): Likewise.
	* pwd/getpwnam_r.c(getpwnam_r): Likewise.

Tue Jun  8 23:26:50 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* configure.ac(AC_OUTPUT): Add test/errno.  Solves bug 207.
	* README-DEV: Added section Testcases.

Sun Jun  6 23:04:35 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* unix/seterr.c(__ul_seterr): Allow to set non-EOPSYS error value
	(helps to eliminate an additional __set_errno call obscuring the
	recorded RISC OS error).
	* kernel/ksetenv.s(_kernel_setenv): Follow __ul_seterr API change.
	* kernel/kswi_c.s(_kernel_swi_c): Likewise.
	* kernel/kosbyte.s(_kernel_osbyte): Likewise.
	* kernel/koscli.s(_kernel_oscli): Likewise.
	* kernel/kosgbpb.s(_kernel_osgbpb): Likewise.
	* kernel/kosbput.s(_kernel_osbput): Likewise.
	* kernel/kosword.s(_kernel_osword): Likewise.
	* kernel/kosfile.s(_kernel_osfile): Likewise.
	* kernel/kosrdch.s(_kernel_osrdch): Likewise.
	* kernel/kosfind.s(_kernel_osfind): Likewise.
	* kernel/kosbget.s(_kernel_osbget): Likewise.
	* kernel/kgetenv.s(_kernel_getenv): Likewise.
	* kernel/kosargs.s(_kernel_osargs): Likewise.
	* kernel/kswi.s(_kernel_swi): Likewise.
	* stdio/rename.c(rename): Likewise.
	* unix/getenv.c(getenv): Likewise.
	* unix/setenv.c(setenv): Likewise.
	* unix/unix.c(convert_command_line): Likewise.
	* unix/dirent.c(newstream,readdir_r): Likewise.
	* unix/truncate.c(truncate): Likewise.
	* unix/chmod.c(chmod): Likewise.
	* unix/unlink.c(unlink): Likewise.
	* unix/getcwd.c(getcwd): Likewise.
	* unix/utime.c(utime): Likewise.
	* unix/fchmod.c(fchmod): Likewise.
	* unix/mkdir.c(mkdir): Likewise.
	* unix/gethostnam.c(gethostname): Likewise.
	* unix/sync.c(sync): Likewise.
	* unix/rmdir.c(rmdir): Likewise.
	* unix/chdir.c(chdir): Likewise.
	* unix/dev.c(__fsopen,__fsclose,__fsread,__fswrite,__fslseek,
	__fsfstat): Likewise.
	* sound/dsp.c(__dspopen,__dspclose,__dspwrite): Likewise.
	* locale/iconv.c(iconv_error,iconv_open): Likewise.
	* netlib/net_error.c(__net_error): Likewise.
	* common/objattr.c(__object_get_attrs,__object_get_lattrs,
	__object_set_attrs): Likewise.
	* common/symlinks.c(read_link_file_info,__resolve_symlinks): Likewise.
	* resolv/scl_gethostbyname.c(gethostbyname): Likewise.
	* sys/exec.c(execve): Likewise.
	* sys/mman.c(munmap,mremap): Likewise.
	* incl-local/errno.h(__set_errno): Reset RISC OS error copy we might
	have.
	* sys/errlist.c(sys_errlist): Fixed typo (last 2 sys_errlist entries
	were wrong).
	(strerror): Only return RISC OS error copy when it is
	marked as valid.
	(strerror_r): Add copy of RISC OS error in given buffer when it is
	valid.
	* scl/chunkid02.s(strerror,__strerror): Rename to __scl_org_strerror
	(as we have our own strerror implementation).
	* stdlib/errno.c(errno): Don't define when __UNIXLIB_ERRNO_THREADED
	is defined.
	* resolv/scl_gethostbyname.c(gethostbyname): Don't assign R0 to ulerrno.
	* unix/unix.c: Minor cleanups.
	* unix/dev.c: Likewise.
	* common/symlinks.c(read_link_file_info,__resolve_symlinks): Likewise.
	* common/sockvalid.c(__socket_valid): Likewise.
	* common/attrib.c(__set_protection,__get_protection): Likewise.
	* pwd/getpw.c(getpw): Likewise.
	* pwd/getpwuid_r.c(getpwduid_r): Likewise.
	* common/fdname.c(__fd_to_name): Don't call __ul_seterr.
	* test/errno/errno.c: Added.

Fri May 28 21:00:46 2010  Lee Noar  <leenoar@sky.com>

	* gcccompat/_eh_support.s(__ehs_return_address,__ehs_stack_limit,
	__ehs_trim_stack): Make sure a processor flag is set for the
	32bit test just in case the module is running a USR mode section
	of code.
	* gcccompat/_b_frame.s(__builtin_frame_address): Likewise.

Fri May 28 20:28:12 2010  Lee Noar  <leenoar@sky.com>

	Fixes for C++ exception handling in SCL module code:

	* gcccompat/_eh_support.s(__ehs_return_address,__ehs_stack_limit,
	__ehs_trim_stack):  A module usually runs in SVC mode which has a
	flat stack (i.e. no chunks), however, some sections of code, for
	example, module start code can run in USR mode. Check the processor
	mode to determine which type of stack we have and process accordingly.
	* gcccompat/_b_frame.s(__builtin_frame_address): Likewise.

Thu May 27 01:03:22 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/asm_dec.s: Make the SUL SWI details available
	for both SCL and UnixLib target builds.

Tue May 25 03:34:56 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* scl/scl_acosf.s(acosf): Added (moved from libscl and converted
	assembler from ObjAsm to GAS syntax).
	* scl/scl_atan2f.s(atan2f): Likewise.
	* scl/scl_atanf.s(atanf): Likewise.
	* scl/scl_ceilf.s(ceilf): Likewise.
	* scl/scl_copysign.s(copysign,copysignl): Likewise.
	* scl/scl_copysignf.s(copysignf): Likewise.
	* scl/scl_cosf.s(cosf): Likewise.
	* scl/scl_coshf.s(coshf): Likewise.
	* scl/scl_expf.s(expf): Likewise.
	* scl/scl_fabsf.s(fabsf): Likewise.
	* scl/scl_floorf.s(floorf): Likewise.
	* scl/scl_hypotf.s(hypotf): Likewise.
	* scl/scl_ldexpf.s(ldexpf): Likewise.
	* scl/scl_log10f.s(log10f): Likewise.
	* scl/scl_logf.s(logf): Likewise.
	* scl/scl_modff.s(modff): Likewise.
	* scl/scl_powf.s(powf): Likewise.
	* scl/scl_signbit.s(__signbit,__signbitf,__signbitl): Likewise.
	* scl/scl_sinf.s(sinf): Likewise.
	* scl/scl_sinhf.s(sinhf): Likewise.
	* scl/scl_tanf.s(tanf): Likewise.
	* scl/scl_tanhf.s(tanhf): Likewise.
	* scl/scl_fpclassify.s(__fpclassify): Added.
	* scl/scl_fpclassifyf.s(__fpclassifyf): Likewise.
	* scl/redirect_setjmp.s(setjmp,longjmp): Type as function.
	* scl/chunkid01.s: Significant cleanup.
	* scl/chunkid02.s: Likewise.
	* scl/chunkid04.s: Likewise.
	* scl/chunkid05.s: Likewise.
	* include/math.h(FP_ZERO,FP_SUBNORMAL,FP_NORMAL,FP_INFINITE,FP_NAN):
	For the SCL target, have the same values as SCL assumes.
	* README: Move 'Building' paragraph to...
	* README-DEV: ...here.  Also added APCS-32 calling conventions section.
	* incl-local/internal/elf-macros.s: Disable errno related macros for
	SCL target.
	* incl-local/internal/scl-macros.s: Add non-SCL target test.  Add FP_*
	SCL values.
	(DefSCLGbl): Removed.
	(DefSCLFncB,DefSCLFncE,DefSCLFncS): Added.
	* sys/_syslib.s(__unixlib_get_fpstatus,__unixlib_set_fpstatus): Remove.
	* include/fpu_control.h: Sync with glibc 2.11 version and adapt it for
	softfloat builds.

Mon May 24 03:28:14 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* scl/chunkid02.s(acosl,asinl,atan2l,atanl,ceill,cosl,expl,floorl,
	log10l,logl,modfl,powl,sinl,tanl,coshl,sinhl,tanhl,frexpl,sqrtl,fabsl,
	fmodl,bcmp): Added.

Sun May 23 23:46:28 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* scl/redirect_setjmp.s: libscl -> scl
	* include/setjmp.h: Likewise.
	* gcccompat/galloca.c: Likewise.
	* incl-local/internal/scl-macros.s: Likewise.

Sun May 23 20:02:32 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	Fix & test case supplied by Jeffrey Lee <me@phlamethrower.co.uk>:
	* gcccompat/galloca.c (__gcc_alloca_restore): Don't restore chunk
	belonging to parent frame.  Solves bug 205.
	* test/alloca: Added test case.

Sun May  2 00:58:38 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* common/riscosify.c: Fix the __TARGET_SOLOADER__ case when build
	option __UNIX_PARANOID is set.

Thu May 13 16:20:41 CEST 2010  John Tytgat  <John.Tytgat@aaug.net>

	* recipe/files/gcc/libunixlib/crt/crt0-scl.s(_start): Merge into __main
	eliminating the latter symbol.
	Removed unnecessary .text lines.
	(c_run): Renamed to __c_run.
	( ___main): Renamed to __main; Register _fini with atexit() after the
	call to _init instead of before so when we have an exit called in
	_init, the _fini is not called.
	(_start,__c_run): Add size info.
	(__gccmain): Added for the module case (being the the equivalent of
	__main for absolute files.

Sun May  9 17:02:23 2010   Lee Noar  <leenoar@sky.com>

	* crt/crt0-scl.s: Fix .type parameter to match function it
	belongs to.

	Fixes for C++ exception handling in SCL (not module code):

	* gcccompat/_b_return.s: Add separate implementation of
	__builtin_return_address for SCL. This differs from the UnixLib
	version in that an SCL stack chunk does not contain a return
	address for when a stack chunk is freed. Instead it creates a
	dummy stack frame to store it.
	* gcccompat/_b_frame.s: Add separate implementation of
	__builtin_frame_address for SCL to help simplify the code.
	* gcccompat/_eh_support.s(__ehs_return_address): The SCL presents
	a problem for __ehs_return_address because it can't know what the
	address of the stack chunk freeing routine is as we do for
	__free_stack_chunk in UnixLib. It needs to be able to test for it
	so that it can substitute the real return address. To overcome this
	a new function, __ehs_init, is called to determine the start and end
	addresses of the SCL. This only needs to be done once - the results
	are saved for future use. If a return address is found to lie within
	the SCL, then it is assumed to be the stack chunk freeing routine.
	Where UnixLib stores the real return address in the stack chunk, the
	SCL creates a dummy frame to store it instead. Because of these
	differences, __ehs_return_address is divided into two separate
	implementations to simplify the code.
	(__ehs_trim_stack): In UnixLib, there is already a __trim_stack function
	we can use to clean up after C++ exception handling. It only requires
	a wrapper to save any registers it may use. For the SCL, we have to
	do the work ourselves, i.e., terminating the stack chain at the current
	chunk and freeing any unused chunks using the SCL supplied routine.
	* incl-local/internal/asm_dec.s: Make CHUNK_OVERHEAD 48 for SCL so that
	512 + CHUNK_OVERHEAD adds up to 560. Remove redundant CHUNK_DEALLOC
	definition.

Tue Apr 20 02:46:32 2010 John Tytgat  <John.Tytgat@aaug.net>

	Merge libscl into libunixlib:
	* configure.ac: Added (generated from gen-auto.pl + added
	BUILDING_SCL conditional); don't enable shared library building when
	configured for SCL building via multilib.
	* {,test/*/}Makefile.am: Added.
	* configure.template: Removed.
	* crt/crt0-scl.s: Moved from libscl/crt to here.
	* ctype/ctypeproc.c: Split into ctype/ctype.c, ctype/isalnum.c,
	ctype/isalpha.c, ctype/isascii.c, ctype/iscntrl.c, ctype/isdigit.c,
	ctype/isgraph.c, ctype/islower., ctype/isprint.c, ctype/ispunct.c,
	ctype/isspace.c, ctype/isupper.c, ctype/isxdigit.c, ctype/toascii.c,
	ctype/_tolower.c, ctype/tolower.c, ctype/_toupper.c, ctype/toupper.c
	* ctype/ctype.c: Removed, contents is at ctypetable.c.
	* locale/ctypetable.c: Move to...
	* ctype/ctypetable.c: ...here.
	* include/ctype.h(__ctype,__ctype_lower,__ctype_upper): Made const
	pointers.
	* stdlib/div.c: Split off ldiv and lldiv into...
	* stdlib/ldiv.c, stdlib/lldiv.c: Added.
	* include/ctype.h: Support SCL.
	(isprint): Fixed.
	* test/ctype: Added test.
	* include/*.h: Merge libscl header contents.
	* ChangeLog-SCL: libscl ChangeLog just before its merge.
	* scl/chunkid02.s(__ignore_signal_handler,__error_signal_marker,
	__default_signal_handler): No longer export these symbols.
	* incl-local/internal/defines.h: Added arch 7 case.
	* scl/chunkid02.s: Define fseeko/ftello.
	* incl-local/internal/scl-macros.s(DefSCLGbl): Added.
	* string/strsignal.c,include/bits/signum.h,signal/signame.c: Enable
	for SCL usage.
	* include/stdint.h(UINT8_MAX,UINT16_MAX,UINT8_C,UINT16_C): Make signed
	instead of unsigned.
	* wchar/wctype.c: Reimplemented and added iswcntrl, iswdigit,
	iswgraph, iswpunct, iswxdigit.
	* include/errno.h,sys/errlist.c: Merge SCL/UL errno codes.
	* unix/dev.c,unix/select.c,unix/fcntl.c: Add include socket.h and
	do minor source cleanup.
	* locale/iconv.c: Enable for SCL usage.
	* stdio/getdelim.c: Likewise
	* incl-local/internal/fd.h: Poison for SCL usage.
	* incl-local/internal/dev.h: Likewise.
	* incl-local/internal/sigstate.h: Likewise.
	* wchar/wcstod.c,wchar/wcstof.c,wchar/wcstol.c,wchar/wcstold.c,
	wchar/wcsxfrm.c: Removed dummy implementations.
	* incl-local/errno.h,signal/_signal.s,signal/post.c(__ul_fp_registers):
	Disable in soft-float builds.
	* signal/_signal.s(_kernel_last_oserror): Move to...
	* kernel/koserror.c: ...here as C implementation.  Invalidate RISC OS
	error block when called.
	* kernel/ksetenv.s,kernel/kosbyte.s,kernel/koscli.s,kernel/kosbput.s,
	kernel/kosgbpb.s,kernel/kosfind.s,kernel/kosargs.s: call __ul_seterr
	with non-zero seterr parameter.
	* signal/_signal.s(__ul_seterr): Move to...
	* unix/seterr.c: ...here as C implementation.  Add support for SCL
	usage.
	* incl-local/pthread.h: Poison for SCL use.
	(pthread::errbuf_valid): Added.
	(__pthread_invalid): Better macro parameter protection.
	* pthread/newnode.c(__pthread_new_node): initialise
	pthread_t::errbuf_valid.
	* test/scl/Makefile.am,test/scl/test-kernel_oserror.c: Add test for
	_kernel_last_oserror code.
	* scl/chunkid01.s(_stub_errorBuffer,_stub_errorNumber): Export.
	* incl-local/internal/os.h(__ul_seterr): Fix parameter typo.
	* include/errno.h(EOPSYS): Added for SCL use.
	* sys/errlist.c(EOPSYS): Likewise.
	* unix/getdomain.c(setdomainname): Move implementation to...
	* unix/setdomain.c: ...here.
	* unix/gethostnam.c(sethostname): Move implementation to...
	* unix/sethostnam.c: ...here.
	* sys/_os.s(__os_word): Remove.
	(_kernel_osword): Move to...
	* kernel/kosword: ...here.  Add call to __ul_seterr when there is an
	error.
	* time/time.c(time): use _kernel_osworld instead of __os_word.
	* time/clk_gettime.c(clock_gettime): Likewise.
	* time/ctime.c(ctime): Reimplement using ctime_r.
	(ctime_r): Move to...
	* time/ctime_r.c: ...here.
	* time/asctime.c(asctime): Reimplement using asctime_r.
	(asctime_r): Move to...
	* time/asctime_r.c: ...here.
	* time/localtime.c(localtime): Reimplement using localtime_r.
	* time/gtime.c(gtime): Reimplement using gmtime_r.
	* time/gmtime_r.c(gmtime_r): Enable for SCL usage.
	* time/localtime_r.c(localtime_r): Likewise.
	* time/ftime(ftime): Likewise.
	* time/tzset(tzet): Likewise.
	* time/dysize.c: Reimplement.
	* time/mktime.c(timelocal): Made strong alias of mktime.
	* include/sys/netdb.h: Remove, was an internal header.
	* include/unistd.h(ttyname_r): Add prototype.
	* unix/open.c(ttyname): Move to...
	* unix/ttyname_r: ...here as ttyname_r.
	* unix/ttyname(ttyname): Added.
	* include/feature.h(__NO_LONG_DOUBLE_MATH): Define it here (instead of
	gen-auto.pl/Makefile.am) as it is used in our public include/math.h.
	* include/resolv.h: Move to...
	* incl-local/resolv.h: ...here and make it fetch include/resolv.h.
	* include/resolv/resolv.h: Move to...
	* include/resolv.h: ...here.
	* stdio/{fdopen.c,fileno.c,fopen.c}: Prefixed with ul_.
	* unix/{close.c,ioctl.c,lseek.c,read.c,readv.c,select.c,write.c,
	writev.c}: Likewise.
	* netlib/{getaddrinfo.c,in6_addr.c,inet_lnaof.c,inet_mkad.c,
	inet_netof.c,inet_netwo.c,inet_ntoa.c,net.c,proto.c,readline.c,
	serv.c,socketpair.c}: Likewise.
	* resolv/*.c: Likewise.
	* stdio/{scl_fdopen.c,scl_fileno}: Added.
	* unix/{scl_close.c,scl_ioctl.c,scl_lseek.c,scl_read.c,scl_readv.c,
	scl_select.c,scl_write.c,scl_writev.c}: Likewise.
	* revolv/scl_gethostbyname.c: Likewise.
	* incl-local/bits/netdb.h: Removed.
	* incl-local/internal/elf-macros.s(NetSWI,NetSWIsimple,NetSWI0,
	NetSWIsimple0): Removed, no longer needed as we're using inline
	assembler now.
	* incl-local/internal/asm_dec.s: Removed socket SWI numbers.
	* incl-local/sys/socket.h: turn socket SWI prototypes into inline
	assembler routines.
	* include/stdio.h(mktemp,mkstemp): Moved prototypes to...
	* include/stdlib.h: ...here.
	* stdio/tmpfile.c(mkstemp): Moved implementation to...
	* stdlib/mkstemp.c: ...here.

Wed Mar 17 00:19:35 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* include/stdlib.h: Replace 'extern __inline' by '__extern_inline'.
	* include/bits/cmathcalls.h: Likewise.
	* include/bits/wchar.h: Likewise.
	* stdlib/atol.c, stdlib/atoll.c, stdlib/atof.c,	stdlib/atoi.c:
	Reverted previous change (r4509).

Fri Mar 12 01:29:34 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* signal/post.c (__write_backtrace): Revert workaround as llvm bug
	#6552 has been solved.

Tue Mar  9 02:46:33 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* signal/post.c (__write_backtrace): Workaround for llvm bug #6552.

Tue Mar  9 02:42:34 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* gcccompat/_b_return.s, gcccompat/_galloca.s, gcccompat/galloca.c
	gcccompat/_eh_support.s, gcccompat/_b_frame.s: Disable code for
	EABI builds.

Tue Mar  9 02:33:58 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/atol.c(atol), stdlib/atoll.c(atoll), stdlib/atof.c(atof),
	stdlib/atoi.c(atoi): Force no-inline when including stdlib.h
	avoiding redefinition.

Sat Mar  6 15:14:41 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	Give UnixLib its own crt0.s (like other runtime libraries have).

	* crt/crt0.s, crt/gcrt0.s: Added (based on what we had in
	gcc/config/arm/(g)crt1-riscos.asm).
	* gen-auto.pl: Add crt0.s and gcrt0.s to the build.
	* sys/_syslib.s: Update comment.

Sun Feb 28 16:47:11 2010  Lee Noar  <leenoar@sky.com>

	Improve profiling support:

	* unix/unix.c(_exit): Call gmon_machine_cleanup() to perform
	any low-level cleanup, rather than have it called by atexit
	handlers.
	* include/sys/gmon.h: Declare moncontrol function.
	* include/unistd.h: Reactivate declaration of profil function.
	* gmon/_profile.s: New file. Implement low level routines such
	as IRQ handler, wimp filters and handle their installation.
	* gmon/machine-gmon.c: New file. Handle memory management, initialise
	RISC OS specific structures, set up hardware timer, find HAL routines.
	* gmon/profil.c: New file. Implement the profil function.
	* gmon/gmon.c(__moncontrol): Call __profil() as necessary to start or
	stop profiling.
	(__monstartup): Call machine specific function to initialise
	profiling system.
	(__write_profiling,_mcleanup): Write the gmon.out file even if a
	sample overflowed, the results may still be of use.
	* gmon/prof-freq.c(__profile_frequency): Return the frequency of the
	timer.
	* incl-local/internal/machine-gmon.h(_mcount): Fix bug whereby, on a
	26 bit OS, status bits were not cleared from addresses.
	Add RISC OS specific structure and function declarations required
	by the implementation.
	* incl-local/internal/asm_dec.s: Add XOS_Hardware and
	XOS_ClaimProcessorVector.

Sat Feb 27 15:52:45 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: Fix comment.

Sun Jan 31 15:57:37 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: Get rid of GCCSDK_SRCDIR.

Thu Jan 21 02:11:44 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fwrite.c(fwrite): Fix missing case of flushing line buffered
	stream when last byte equals newline.  Bug #189.

Sun Jan 10 18:29:47 2010  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s: Simplify initialisation code by observing
	that since the call to main() was inlined from unix/unix.c
	to here, __ul_global.main is no longer referenced outside of
	this file. We can eliminate it by using the original pointer
	in the crt1 data block.
	Also, do the same for __ul_global.crt1_flags.
	Remove these entries from __ul_global.
	* incl-local/internal/asm_dec.s: Remove GBL_MAIN and
	GBL_CRT1_FLAGS. Define constants to describe layout of
	crt1 data block.
	* incl-local/internal/unix.h(__ul_global): Remove members
	main and crt1_flags.

Sun Jan 10 18:42:00 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* include/wchar_t(wcscasecmp,wcsncasecmp,wcscoll,wcsxfrm,wcschrnul,
	wcswcs,wcsnlen,wmemmove,wmempcpy,wcstod,wcstof,wcstold,wcstol,wcstoul,
	wcstoll,wcstoull,wcstoq,wcstouq,open_wmemstream,all wide I/O stream
	calls): Disabled prototype as we don't have an implementation for
	those.
	* include/wctype.h(iswblank,wctype,iswctype,wctrans,iswctrans):
	Likewise.
	* wchar/mbrlen.c(__mbrlen): Define.

Sat Jan  9 20:22:18 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/system.c(system): Avoid store which is never going to be
	read.
	* stdlib/msort.c(qsort_r): Likewise.
	* stdio/fpos.c(fseek): Likewise.
	* unix/features.c(env): Likewise.
	* unix/unix.c(__unixinit): Likewise.
	* signal/post.c(post_signal): Likewise.
	* termios/termcap.c(t_tgetnam): Likewise.
	* common/unixify.c(__unixify): Likewise.
	* stdio/popen.c(__pexec): Avoid NULL dereference.
	* unix/dirent.c(scandir): Likewise.
	* pthread/key.c(pthread_key_create): Likewise.
	* common/serial.c(__get_file_ino): Likewise.
	* time/clk_gettime.c(clock_gettime): case CLOCK_REALTIME, tv_nsec is
	no longer garbage.
	* unix/putenv.c(putenv): strncpy() -> memcpy() micro-optimisation.
	* time/stdtime.c(__standard_time): Avoid pointless ptr arithmetic.
	* include/wchar.h: Upgrade with glibc 2.11 version.
	* include/wctypes.h: Likewise.
	* include/sys/cdefs.h: Likewise.
	* include/features.h: Likewise.
	* include/features.h: Likewise.
	* include/bits/wchar.h: Add glibc 2.11 version.
	* include/bits/wordsize.h: Likewise.
	* include/stdio.h(__FILE): Typedef.
	* wchar/mbsinit.c(mbsinit): Follow wchar.h/wctypes.h header changes.
	* wchar/wcwidth.c(wcwidth): Likewise.
	* wchar/wctype.c(towupper,towlower): Likewise.
	* wchar/mbrtowc.c(mbrtowc): Likewise.
	* incl-local/sys/cdefs.h: Follow sys/cdef.h changes.
	* pwd/getpwnam_r.c(getpwnam_r): Avoid 1 line if statements.
	* incl-local/internal/os.h(__ul_seterr): It is allowed to call this
	with NULL argument.

Thu Jan  7 13:47:15 PST 2010  Peter Naulls  <peter@chocky.org>

	* pwd/getpwnam_r.c(getpwnam_r): Return values weren't being properly
	  set in default case.  Rewrite to do what man page says.

Thu Jan  7 21:54:12 2010  Lee Noar  <leenoar@sky.com>

	* Generally:
	Ideally we want to remove the need for pthread_call_every to
	access the task address space in order to validate it and
	decide whether to continue setting the callback or not. Once
	pthread_call_every knows that it has the right task it is free
	to access its variables.
	Previously, the GOT pointer was passed around the interrupt
	functions in r12 and used to access __ul_global to retrieve
	the SUL upcall handler address and r12 value, however, despite
	the WimpPoll filters, this was still prone to crashes in
	pthread_call_every (especially in the shared library).
	To overcome this, a small block of RMA is allocated during
	initialisation containing the SUL upcall handler address, r12
	value and in the case of the shared library, UnixLib's GOT.
	These remain constant throughout the life of the program. A
	pointer to this RMA block is instead passed to the interrupt
	routines, in r12, allowing pthread_call_every safe access to
	the data it needs to make a decision on whether it has the right
	task.

	* Specifically:
	* pthread/_context.s(__pthread_start_ticker): Move filter name
	copy to initialisation function - we only need to do this once,
	and it will reduce RMA fragmentation.
	(pthread_call_every): Use upcall address and r12 value in RMA
	block passed in r12 to determine if we have the correct task.
	Generally ensure pointer to RMA block is passed to interrupt
	routines and change code where necessary to use GOT from RMA
	block.
	* unix/unix.c(_exit): Slightly more work to do when shutting down
	pthreads, so call a function instead.
	* pthread/pthinit.c(__pthread_prog_init): Allocate a small block
	of RMA to hold items of data that remain constant over the life of
	the program. A pointer to this block will be passed to
	pthread_call_every in r12.
	(__pthread_prog_fini): New function to close down pthreads, ie,
	stop timers and free RMA block. Called by _exit as mentioned above.
	* incl-local/internal/unix.h(ul_global): Add pthread_callevery_rma
	member.
	* incl-local/internal/asm_dec.s: Define GBL_PTH_CALLEVERY_RMA.
	* incl-local/pthread.h(__pthread_callevery_block): Declare new
	structure to define layout of RMA block as passed to
	pthread_call_every.
	* sys/_syslib.s(__ul_global): Add pthread_callevery_rma.

Wed Jan  6 00:24:46 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* vscript(__write_backtrace): Export symbol as it is public API.

Sat Jan  2 18:15:54 CET 2010  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/newstream.c(__newstream): Zero reinitialisation is not needed.
	* stdio/putc.c(fputc): Mark we have unflushed data in a line buffered
	stream.
	(putc): Make strong alias of fputc.
	(putc_unlocked): Make strong alias of fputc_unlocked.
	* stdio/flsbuf.c(__flslbbuf): Added.
	(__flsbuf): Constify.
	* stdio/getc.c(getc): Make strong alias of fgetc
	* stdio/stdio.c(__stdioinit): Simplify code by calling setvbuf (and
	have stdout's o_cnt value fixed by this).
	(__stdioexit): Reset __stdin, __stdout, __stderr as the latter can get
	tested for in debug_vsnprintf.
	* stdio/setbuf.c(do_buffer): Don't change any stream fields before
	having done all parameter checks, avoid possible double free for one
	of such cases.
	(setvbuf): Make sure FILE::o_cnt is always number of bytes free in
	buffer.
	* stdio/puts.c(puts): Call fputc() iso putchar() as shortcut.
	* stdio/fwrite.c(fwrite): Flush line buffered streams for any newline
	instead only when the last character is a newline
	* stdio/getc.c(fgetc): Flush all line buffered streams when reading
	from a stream attached to a tty.
	* stdio/filbuf.c(__filbuf, __peek_char): Likewise.
	* stdio/fread.c(fread): Likewise.
	Simplify code, only update FILE::__offset when no error has happened.
	* stdio/fflush.c(fflush): Reset line buffer flush indicator.
	* include/stdio.h(fisatty): Remove declaration, we don't have this
	implemented nor this is a reasonable standard call.
	* incl-local/stdio.h(__flslbbuf): Add declaration.
	* incl-local/internal/unix.h(ul_global::fls_lbstm_on_rd): Added.
	* incl-local/internal/asm_dec.s(GBL_FLS_LBSTM_ON_RD): Likewise.
	* sys/_syslib.s: Likewise.

Fri Jan  1 19:59:01 2010  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s(__pthread_callback): Load PIC
	register directly rather than depending on caller
	to pass it - should be more reliable/stable.
	* pthread/_yield.s(pthread_yield): Fix problem where
	PIC register may contain a GOT that doesn't belong to
	UnixLib causing registers to be dumped where they
	shouldn't be. Also, simplify by using registers for PIC
	code that don't need to be saved/restored.
	* signal/_signal.s(__h_cback): __pthread_callback loads
	the PIC register itself now, so no need to pass it in.

Tue Dec 15 18:18:11 2009  Lee Noar  <leenoar@sky.com>

	* gcccompat/galloca.c: Bug 174 Fix. If GCC determines
	that a call to __gcc_alloca can never be reached, it will
	optimise it away. However, __gcc_alloca_restore is still
	called and crashes because a block was never allocated.
	Fix by exiting if a chunk isn't found.

Thu Nov 26 10:13:45 PST 2009  Peter Naulls  <peter@chocky.org>

	* time/ctime.c, time/stdtime.c, time/asctime.c, include/time.h,
	  incl-local/time.h: Add asctime_r, ctime_r.

Sat Nov 14 10:30:39 PST 2009  Peter Naulls  <peter@chocky.org>

	* string/_strlen.s: Alignment access fix from Adrian
          Lees (Bug #173).

Wed Oct 21 17:46:48 2009  Lee Noar  <leenoar@sky.com>

	* incl-local/internal/unix.h(struct __process): Add
	2 new flags to record how this process was created.
	* sys/exec.c(execve): Set flag to show that this
	process was the result of exec().
	* sys/vfork.c(__fork_post): Set flag to show that this
	process was the result of fork().
	* unix/unix.c(_exit): Be more careful about when we
	deregister the client from the Shared Object Manager.
	A process that was forked (but not execed) is
	considered to be the same client as its parent. It
	should not be deregistered on exit, so that control can
	be successfully returned to the parent.
	A process that was execed (even if forked) is a new client
	in its own right and distinct from its parent and should
	be deregistered on exit.
	A process with no parent should always be deregistered.

Sat Sep 19 12:41:12 2009  Lee Noar  <leenoar@sky.com>

	* gmon/gmon_start.c: Don't use _init symbol to find the
	start of the text segment as this creates a bogus
	DT_INIT entry in the dynamic segment. Instead use the
	linker generated __text_start.

Mon Aug 24 10:41:22 PDT 2009  Peter Naulls  <peter@chocky.org>

	* signal/post.c: Skip over # at start of C++ symbol names
        for demangling.
	* sys/_syslib.s: Typo fix.
	* pthread/_yield.s: Register handling safety from John Tytgat.
        * debug/dvsprintf.c: Use stdio for __os_printf after stdio
        is initialised, otherwise Wimp debugging can become very
        difficult.

Thu Aug 20 00:44:36 CEST 2009  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/pthread.h(__pthread_saved_context): don't define fpregs
	and fpstatus in softfloat builds.

Sun Aug 16 12:58:06 PDT 2009   Peter Naulls  <peter@chocky.org>

	* sys/mman.c: Simplistic mmap file handling. Only supports reading
        from a zero offset, but this covers much of its use.

Sun Aug  9 01:15:13 CEST 2009  John Tytgat  <John.Tytgat@aaug.net>

	* netlib/getnameinfo.c: Removed, we have another implementation in
	netlib/getaddrinfo.c.

Sun Aug  2 07:44:06 PDT 2009  Peter Naulls  <peter@chocky.org>

	* sys/errlist.c: Add entry for EOVERFLOW.
	* libm-dbl64/s_finite.c, libm-dbl64/s_isinf.c, libm-dbl64/s_isnan.c,
          libm-flt32/s_isinff.c, libm-flt32/s_finitef.c libm-flt32/s_isnanf.c:
	Remove hidden_def, since it seems to serve no purpose, and
        causes linking errors.

Fri Jul 31 14:20:29 PDT 2009  Peter Naulls  <peter@chocky.org>

	* include/errno.h: Add EOVERFLOW.  Not used by UnixLib,
          but sometimes returned by library routines.

Thu Jul 16 17:29:12 2009  Lee Noar  <leenoar@sky.com>

	* Generally:
	Implement very simple profiling. Only function call
	counting is supported, there is no timing. Only really
	effective on statically linked code. Some of this
	code is imported and adapted from glibc.

	* Specifically:
	* include/sys/gmon.h: New file. Standard header for
	profiling support.
	* include/sys/gmon_out.h: Likewise.
	* gmon/gmon.c: New file. Support routines for profiling.
	* gmon/prof-freq.c: New file. Stub implementation of
	__profile_frequency().
	* gmon/mcount.c: New file. Simple mcount implementation
	that counts function calls and records their relationships.
	* gmon/gmon-start.c: New file. Code called at program startup
	to start profiling. Also registers function with atexit to
	write results to file.
	* incl-local/internal/machine-gmon.h: New file. mcount
	machine code stub that saves any registers that real mcount
	code would otherwise corrupt.
	* incl-local/internal/unix.h(ul_global): Add word to record
	flags passed by (g)crt1-riscos.o.
	* incl-local/internal/asm_dec.s: Add constant for above.
	* incl-local/sys/cdefs.h: Define some of the symbol attribute
	macros.
	* sys/_syslib.s(__main): Call __gmon_start__ if profiling is
	enabled.

Fri Jul 03 19:42:48 2009  Lee Noar  <leenoar@sky.com>

	* sys/exec.c(execve): Only deregister the client from the
	Shared Object Manager if we are not the parent of another
	process. If the client is a parent, then it must remain
	registered so that the child can return.
	Also don't bother about accessing global variables after
	deregistering. Examination of the compiled code shows that
	despite attempts to ensure that this doesn't happen, the
	compiler still generates accesses to global variables after
	deregistering without any ill effects. In fact, there should
	be no ill effects as the PIC register and R/W data segment are
	still valid and are not under the control of the Shared
	Object Manager.

Mon Jun 22 19:23:05 2009  Lee Noar  <leenoar@sky.com>

	* gcccompat/_eh_support.s: Add PIC instructions.
	* gcccompat/_b_return.s: Likewise.

Sun Jun 14 14:46:12 2009  Lee Noar  <leenoar@sky.com>

	* gcccompat/_eh_support.s:
	* (__ehs_stack_limit): New function.
	Given a stack pointer (which will not be the current one),
	determine which stack chunk contains it and return the stack
	limit for that chunk. Used by uw_install_context() in
	unwind-dw2.c (call frame exception handling). The stack
	unwinder steps through the call frames looking for either
	cleanup handlers or exception handlers. The context is installed
	once one of these is found, however, the frame that is jumped
	to may be within a different stack chunk so we have to restore
	the stack limit for that chunk.
	* (__ehs_trim_stack): New function.
	Wrapper for __trim_stack to preserve any registers that it may
	use/corrupt. If the stack unwinder unwinds down the call frames
	to a different stack chunk, then there will be one or more
	redundant chunks that need to be freed.

Sun Jun 7 11:10:43 2009  Lee Noar  <leenoar@sky.com>

	* General overview:
	The call frame C++ exception handling code creates a table of
	call frames that relate to the frames on the stack. This table
	allows the stack unwinder to maintain a context that stores
	the locations of all registers stored by the current function
	on entry.
	The return address of a function is used as a key to allow the
	stack unwinder to find its particular entry in the table. If the
	wrong return address is used, then exception handling will fail
	usually with a crash in the personality routine. The personality
	routine (for C++ at least) attempts to write to r0 and r1 in the
	stack frame. These registers aren't usually saved on function
	entry, only a few exception handling functions actually save
	these registers.
	Wesnoth is an example of where these crashes have been observed.

	* Specifically:
	* gcccompat/_b_frame.s(__builtin_frame_address): I have found
	that __builtin_frame_address can return the wrong result under
	certain circumstances, e.g., when the requested fp is not within
	the current stack chunk. This causes __builtin_return_address to
	give the wrong return address and crashes in C++ exception
	handling as detailed above. The problem seems to be that the
	behaviour of the SCL is slightly different to UnixLib when the
	stack is extended. UnixLib creates a new chunk and starts using
	that as the stack, but the comment in the code suggests that SCL
	copies a frame as well. I believe that this makes the chain of
	frames slightly different for UnixLib and SCL. These changes
	simplify the UnixLib code to match the stack extension code, but
	leave the SCL code as is, as I have no reason to believe that it
	is wrong in this case.
	* gcccompat/_b_return.s(__builtin_return_address): UnixLib code
	attempts to load the return address from the stack chunk which is
	addressed by a2. However, at this point, a2 will either contain a
	frame address or have been corrupted by the call to
	__gcc_alloca_return_address() leading to crashes in exception
	handling as detailed above.
	Set a2 to contain the address of the current stack chunk. Note
	that using the chunk that actually contains the requested fp
	doesn't work as far as exception handling is concerned.
	* gcccompat/_eh_support.s(__ehs_return_address): New file, new
	function. The context maintained by the exception handling code,
	as detailed above, is initialised from the call frame table using
	a return address obtained via __builtin_return_address(). This
	correctly handles the case whereby the return address may be
	__free_stack_chunk or __gcc_alloca_free. However, further updates
	to the context by the stack unwinder retrieve the return address
	directly from the stack. If the return address happens to be one
	of these functions, then exception handling will fail.
	__ehs_return_address() does a similar job to
	__builtin_return_address() in that it traps these special functions
	and returns the correct result. It differs in that we already know
	the frame address (which will not be the current one) and are able
	to pass it as an argument.

Wed May 27 20:31:18 PDT 2009  Peter Naulls  <peter@chocky.org>

	* sys/byteorder.h: Fix bogus include.  Seems to have been wrong
	for a long time.

Sat May 23 15:29:42 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* unix/getenv.c(__last_environ): Removed, is now
	__ul_global.last_environ.
	* incl-local/internal/unix.h(struct ul_global): Replaced __notused5
	by last_environ field, always have a main function pointer.
	(_main): Removed prototype, no longer exists.
	* unix/setenv.c(unsetenv): Micro optimisation.
	(clearenv): Make use of last_environ from __ul_global.
	* unix/putenv.c(__addenv_to_env): Likewise.
	* unix/unix.c(_main, main prototype): Remove, equivalent code got
	added to __main.
	* incl-local/internal/asm_dec.s(PROC_ARGC,PROC_ARGV): Added.
	(GBL_*): Fixes up some recently allocated entries.
	(GBL_LASTENVIRON): Added.
	* sys/_syslib.s(__main): Instead of calling _main, call user
	supplied main routine directly.
	(main): Have it always defined.
	* vscript(__last_environ): Removed.
	* local/ctypetable.c(__build_ctype_tables): Fix comment.
	* test/env/testenv.c: Dump environ.

Thu May 21 18:58:32 2009  Lee Noar  <leenoar@sky.com>

	* sys/exec.c(execve): Deregister the current client from the
	Shared Object Manager before passing control to the new
	process. Fix for bug 171.

Mon May 11 23:31:29 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* include/bits/posix_opt.h(_POSIX_TIMEOUTS): Disabled as we don't
	have pthread_mutex_timedlock.

Sat Mar 28 14:36:21 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* include/kernel.h: Constify _kernel_osfind name parameter;
	'unsigned' -> 'unsigned int'.
	* scl/_kosfind.s: Update comments.
	* sys/mman.c: White space change.

Sat Mar 28 11:30:10 2009  Lee Noar  <leenoar@sky.com>

	* signal/_signal.s(__h_error): Make sure a valid signal number
	is passed to __unixlib_raise_signal() when __SOFTFP__ is defined.
	Previously, for example, instead of seeing a branch through zero
	error, you would get a recursive signal because the signal handler
	itself would cause a memory violation due to a2 containing a
	pointer instead of an array index.

Sun Jan 18 19:45:02 2009  Lee Noar  <leenoar@sky.com>

	* incl-local/internal/unix.h(__funcall): In the shared library,
	function addresses can and will exist outside application space,
	so don't test against appspace_himem.
	* unixlib/buildoptions.h: Remove comment.

Sun Jan 18 16:57:12 2009  Lee Noar  <leenoar@sky.com>

	* Generally:
	Implement lstat so that symlinks can be probed. Fix for
	bug(feature request) #162 item 1.

	stat() - Always follow symlinks and return info on target object.
	lstat() - Do not follow symlinks, and return info on given
	object even if symlink. As per Linux, if a symlink is lstat()ed,
	S_IFLNK = TRUE, S_IFREG = FALSE.

	* Specifically:
	* unix/custom.c: Add __customlstat().
	* unix/lstat.c(lstat,lstat64): Call new implementation instead
	of stat().
	* unix/dev.c: Add __fslstat() and ensure all devices have a
	suitable lstat entry.
	* common/objattr.c(__object_get_lattrs): New function similar
	to __object_get_attrs() except symlinks are not followed. Allows
	the file info of the symlink itself to be found.
	* common/symlinks.c: Move macro definitions of constants...
	* incl-local/internal/symlinks.h: ...to here.
	* incl-local/internal/local.h: Add declaration of
	__object_get_lattrs().
	* incl-local/internal/dev.h: Add lstat entry to struct dev.
	Add declarations for __fslstat() and __customlstat().
	* incl-local/internal/unix.h: Instead of declaring
	__resolve_symlinks() directly, include symlinks.h.

Sat Jan 17 20:10:49 2009  Lee Noar  <leenoar@sky.com>

	* common/objattr.c(__object_set_attrs): Fix typo that would lead
	to a memory leak.

Sat Jan 17 18:22:26 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c(convert_command_line): Reverting r1904 change
	(Fri Mar 10 21:25:47 2006) and canonicalise using Run$Path; When
	result of canonicalisation is non-existing, use given argv[0] as
	input for unixify; Made	common fatal exit point; void return instead
	of unused int return.

Sat Jan 17 15:53:04 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* include/kernel.h: Add 'int' to 'unsigned'.
	* README(Building): Updated.

Fri Jan 16 02:53:30 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	*  unix/features.c(__get_program_name): A colum character can mark the
	start of a leafname as well.  Solves Bugzilla #169 (reported by John
	Kortink).

Sat Jan  3 21:03:34 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* ChangeLog: Updated John-Mark Bell's e-mail address.

Fri Jan  2 03:23:07 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* module/sul.s: Update module title with "(debug)" string when
	DEBUG_PROC_MATCHING has been defined.

-----------------------------------------------------------------------
[ UnixLib v5.0 ]

Fri Jan  2 03:09:47 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/msort.c: Fixed wrong __mempcpy emulation (when result gets
	written back to first __mempcpy argument).

Tue Dec 23 02:25:46 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* test/env/testenv.c: Added test for inheritance of environment
	variables from parent to child process and when changes from
	Unix environment variables need to result in updated RISC OS
	system variables.  Based on a test program written and posted
	in ML by Peter Naulls.

Sat Dec 20 14:34:20 CET 2008  Theo Markettos  <theo@markettos.org.uk>

	* grp/getgrouplist.c(getgrouplist): Added.
	* test/grp/getgrouplist.c,test/grp/test.group: Added test application
	for getgrouplist code.
	* include/grp.h(getgrouplist): Added prototype.

Thu Dec 18 22:57:28 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/syslog.c(vsyslog): More sensible mapping between Unix and
	RISC OS syslog priorities.

Thu Dec 18 22:23:52 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/msort.c: Copy from glibc 2.9 which has a much better qsort
	implementation.  Number of compares done in testsort2.c dropped from
	1849086/1534480/834012928/627343953 to 1536347/815024/853904/1209216.
	* stdlib/memcopy.h: Added, also from glibc 2.9.
	* stdlib/qsort.c: Removed.
	* test/stdlib/testsort2.c: Added.

Mon Dec 15 05:08:52 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/features.c(features): Implement coredump feature.
	* signal/post.c(__write_backtrace): Mark as pthread unsafe.
	(post_signal): Move FPE reg dump code to __write_backtrace; call
	__unixlib_write_coredump when action is 'core'.
	* include/unixlib/local.h(__unixlib_write_coredump,__write_backtrack):
	Make public.
	* vscript(__backtrace_getfp): Remove, this routine no longer exists.
	* README: Document 'coredump' feature.
	* incl-local/internal/sigstate.h(__init_coredump): Add prototype.
	* incl-local/internal/swiparams.h(OSFILE_SAVEBLOCK_LOADNEXEC,
	OSFILE_SAVEBLOCK_FILETYPE): Define.
	* sys/_os.s(__os_file): Don't change a3 when it was 0 on entry.
	* sys/mman.c(__init_coredump): Define coredump directory.
	(__unixlib_write_coredump): Write coredump files (application space
	and all DAs).

Tue Dec  2 02:36:59 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* test/pthread/fork.c(__UNIXLIB_INTERNALS): Remove usage as it is no
	longer needed.
	* include/complex.h: Likewise.
	* include/features.h: Likewise.
	* include/math.h: Likewise.
	* include/sys/cdefs.h: Likewise.
	* incl-local/internal/fd.h: Likewise.
	* incl-local/internal/os.h: Likewise.
	* incl-local/internal/unix.h: Likewise.
	* incl-local/internal/swiparams.h: Likewise.
	* gen-auto.pl(AM_CFLAGS): Remove __UNIXLIB_INTERNALS definition and
	add __GNU_LIBRARY__ and __NO_LONG_DOUBLE_MATH definitions.

Fri Oct 24 02:07:18 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* string/strdup.c(strdup): renamed strdup to __strdup and
	provided weak alias strdup instead.

Mon Oct 13 02:34:22 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* pthread/_exit.s(__pthread_exit): Simplify code.

Mon Oct 13 02:19:00 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: Fix typo.

Tue Sep  9 19:29:39 PDT 2008  Peter Naulls  <peter@chocky.org>

	* pthread/cond.c(pthread_cond_timedwait): Fix divisor.
	Timeout is in centiseconds, not milliseconds.

Tue Sep  9 20:49:05 2008  Lee Noar  <leenoar@sky.com>

	* signal/post.c(sigsetup): Don't use the address range of the
	application to validate the location of the signal handler when
	compiling for the shared library.

Thu Aug 28 20:27:45 2008  Lee Noar  <leenoar@sky.com>

	* pthread/_yields.s(pthread_yield): The current implementation
	uses a single STMDB instruction to store all relevant registers
	to __cbreg including two banked registers. Under certain
	circumstances, this can trigger a bug in revision K StrongARM
	CPUs whereby the banked register r14 is not saved. To overcome
	the bug, split the instruction into two STMs so that the banked
	registers are saved independently of the others.

Mon Aug 11 20:38:14 2008  Lee Noar  <leenoar@sky.com>

	* signal/_signal.s(__h_cback): Make sure __pthread_callback
	is called with r7 containing the UnixLib GOT pointer as it
	expects.

Wed Aug  6 20:34:09 2008  Lee Noar  <leenoar@sky.com>

	* pthread/cancel.c: Add dummy function that is never called or
	referenced. Its only purpose is to ensure that several pthread
	functions that are made weak in libstdc++ are pulled in by the
	static linker which otherwise would resolve to NULL. This only
	effects statically linked C++ binaries.

Sun Jul  6 17:12:39 PDT 2008  Peter Naulls  <peter@chocky.org>

	* common/riscosify.c: Add defines for a cut-down version of
	__riscosify for the benefit libdl, which only needs to handle a single
	case.  This doesn't change the behaviour of the code for UnixLib or
	SCL.

Fri Jun 13 01:33:48 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/bits/netdb.h(_sclose,_sread,_swrite,_sioctl): Move internal
	swi veneers to...
	* incl-local/bits/netdb.h: ...here.
	* include/sys/stat.h(__stat): Move to...
	* incl-local/sys/stat.h: ...here.
	* include/sys/select.h(_select): Move to...
	* incl-local/sys/select.h: ...here.
	* include/sys/cdefs.h(_strong_alias,weak_function,weak_const_function,
	weak_alias,_weak_alias,hidden_def,libm_hidden_def,INTDEF,
	internal_function): Move to...
	* incl-local/sys/cdefs.h: ...here.
	* include/sys/debug.h: Moved file to...
	* incl-local/sys/debug.h: ...here.
	(debug_printf): Added printf attribute for better type checking.
	* include/sys/socket.h(_socket,_bind,_listen,_accept,_connect,_recv,
	_recvfrom,_recvmsg,_send,_sendto,_sendmsg,_shutdown,_setsockopt,
	_getsockopt,_getsockname,_getpeername,__opensock): Move to...
	* incl-local/sys/socket.h: ...here.
	Upgraded to glibc 2.7 version.
	* string/strchr.c(index): Make index strong alias of strchr.
	* string/strrchr.c(rindex): Make rindex strong alias of strrchr.
	* string/index.c(index,rindex): Removed.
	* string/stricmp.c(strcasecmp): Make strcasecmp strong alias of
	stricmp.
	* string/strnicmp.c(strncasecmp): Make strncasecmp strong alias of
	strnicmp.
	* string/memcmp.c(bcmp): Make bcmp strong alias of memcmp.
	* string/memrchr.c: Go for original glibc 2.7 version.
	* string/strchrnul.c: Likewise.

Fri May 16 01:43:59 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* common/symlinks.c(__resolve_symlinks): avoid writing to NULL.

Tue May 13 21:07:51 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c(__fsopen): Call __riscosify only once as the result of
	__resolve_symlinks is guaranteed to be already a RISC OS filename.
	* common/symlinks.c(__resolve_symlinks): avoid malloc/free sequence
	unless it is really necessary and reuse previously claimed buffer when
	possible; Made code a little bit more compact; Added comments.

Thu May  1 20:08:23 PDT 2008  Peter Naulls  <peter@chocky.org>

	* pthread/lock.c: Fix logic from earlier tidy.

Wed Apr 23 22:23:03 PDT 2008  Peter Naulls  <peter@chocky.org>

	* unix/custom.c, include/unixlib/local.h: New function to
	  allow opaque setting of custom select() function.

Sun Apr  6 01:47:47 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/pthread.h(struct __pthread_thread,
	__pthread_running_thread): Move to...
	* incl-local/pthread.h: ...here.
	* string/strsignal.c: Added include pthread.h.

Sat Apr  5 22:01:57 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fopen.c(fopen): Added comment.
	* unix/dev.c(__fsopen): When opening a directory, make sure we're
	using the original filename and not the riscosified one.  Solves
	bug #163 logged by Duncan Moore <duncan.m00re@btinternet.com>.

Sat Apr  5 17:58:01 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* time/_clock.s: Use NAME/DECLARE_FUNCTION macros.
	* string/_strcpy.s: Likewise.
	* string/_memcpy.s: Likewise.
	* string/_strlen.s: Likewise.
	* string/_memset.s: Likewise.

Sat Apr  5 17:07:58 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/features.h: Move UnixLib internal definitions to...
	* incl-local/features.h: ...here.
	* include/dirent.h,incl-local/dirent.h: Likewise.
	* include/time.h,incl-local/time.h: Likewise.
	* include/locale.h,incl-local/locale.h: Likewise.
	* include/setjmp.h,incl-local/setjmp.h: Likewise.
	* include/pwd.h,incl-local/pwd.h: Likewise.
	* include/stdlib.h,incl-local/stdlib.h: Likewise.
	* include/stdio.h,incl-local/stdio.h: Likewise.
	* include/pthread.h,incl-local/pthread.h: Likewise.
	* include/grp.h,incl-local/grp.h: Likewise.
	* include/unistd.h,incl-local/unistd.h: Likewise.
	* include/signal.h,incl-local/signal.h: Likewise.
	* include/errno.h,incl-local/errno.h: Likewise.
	* incl-local/internal/unix.h( __addenv_to_os): Add prototype.

Wed Apr  2 00:36:38 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* common/riscosify.c(riscosify): Avoid discname when specified gets
	changed and when no discname is specified, make sure we output a '$'.
	* test/filename/testriscosify.c: Added new cases.

Tue Apr  1 00:23:32 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/unixlib/asm_dec.s: Moved to...
	* incl-local/internal/asm_dec.s: ...here.
	* include/unixlib/dev.h: Moved to...
	* incl-local/internal/dev.h: ...here.
	* include/unixlib/fd.h: Moved to...
	* incl-local/internal/fd.h: ...here.
	* include/unixlib/os.h: Moved to...
	* incl-local/internal/os.h: ...here.
	* include/unixlib/types.h: Moved to...
	* incl-local/internal/types.h: ...here.
	* include/unixlib/unix.h: Moved to...
	* incl-local/internal/unix.h: ...here.
	* include/unixlib/local.h: Moved __UNIXLIB_INTERNALS marked
	declarations to...
	* incl-local/internal/local.h: ...here.
	* Updated lots and lots of c/h/s files to follow above changes.

Sun Mar 30 15:59:15 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c: Added a bit more debug info and did some
	microoptimisation.
	* unix/tty.c(__ttyicanon): 0 -> NULL
	* debug/debug.c(__debug): Added a bit more debug info.

Sun Mar 30 15:33:22 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* test/process-redirect/{child.c,Makefile,parent.c,RunTestQueue,feb}:
	Added test suite used to test the recent redirection/pipe/dup fixes.

Sat Mar 29 18:48:49 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/fcntl.c(fcntl): Case F_DUPFD needs file descriptors to be
	copied too otherwise we would be closing OS_ChangeRedirection acquired
	RISC OS handles (FILE_HANDLE_FROM_OS).  And FILE_ISDIR bit also needs
	to be copied.
	* include/unixlib/unix.h(struct ul_global): Renamed __unused1,
	__unused4 and __unused2 to rewindpipeoffset, changeredir0 and
	changeredir1.
	* sys/_syslib.s: Likewise.
	* sys/vfork.c(__fork_pre): initialise rewindpipeoffset, changeredir0
	and changeredir1; (__fork_post): restore read pipe file offset and
	RISC OS redirection.
	* sys/exec.c(execve): when in a fork context set RISC OS redirection
	based on file descriptors 0 and 1 when those are real files or a pipe.
	Also record the read pipe offset for file descriptor 1 as
	rewindpipeoffset and move file offset to the end. Any non-UL process
	(e.g. libscl, OS command) can now read/write data using file handles
	managed by parent.

Thu Mar 27 02:24:59 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* vscript(_Exit,__exit,__exit_no_code,__exit_with_error_block):
	Deleted (_Exit is a valid C99 symbol and the others were not defined)

Fri Mar 21 19:37:54 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/time.h(__tz): Remove declaration.
	* time/tzset.c(tzset): One maximum byte less copied.
	(__tz): Moved to...
	* time/calendconv.c: ...here.
	(__calendar_convert): Use static __tz data when parameter tz is NULL.
	* time/localtime.c(localtime): Use tz = NULL for __calendar_convert;
	call tzset() to initialise timezone and daylight.
	* time/localtime_r.c(localtime_r): Call tzset() to initialise timezone
	and daylight.
	* time/gmtime.c(gmtime): Use tz = NULL for __calendar_convert.
	* time/asctime.c(asctime): One byte trimming.
	* time/gettod.c(gettimeofday): Simplified code for tz != NULL.
	* time/mktime.c(mktime): calculated tm_wday and tm_yday fields were
	one off.
	* time/clk_gettime.c(clock_gettime): case CLOCK_REALTIME: use uint64_t
	based calculation which now gives correct result; case
	CLOCK_MONOTONIC: calculated tv_nsec field was 100 times too big.

Fri Mar 21 13:26:13 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* serial/common.c(__get_file_ino): combining directory and filename
	should be done with a Unix directory separator, not RISC OS one;
	some variable shuffling resulting in dropping a nasty cast.

Fri Mar 21 05:34:43 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/printf.c: Cosmetic reformat.
	* stdio/asprintf.c: Likewise.
	* include/stdio.h(clearerr_unlocked): Declare.
	* stdio/clearerr.c(clearerr_unlocked): Implement as alias to clearerr.
	* include/dirent.h(DIR): Add fd entry.
	(dirfd): Declare.
	* unix/dirfd.c(dirfd): Implemention based on lazy fd allocation.
	* unix/dirent.c(newstream): Initialize fd to -1.
	(closedir): close fd when allocated.

Mon Mar 17 03:31:08 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/stdio_ext.h: Moved to...
	* include/stdio_ext.h: ...here and changed contents with a glibc
	version with everything disabled except the __fpurge prototype.

Thu Feb 28 00:58:23 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* README: Added comment on Wimp_StartTask usage in threaded programs.
	Updated description on build options.

Sat Feb 16 07:05:37 PST 2008  Peter Naulls  <peter@chocky.org>

	* include/stdio.h, stdio/putc.c: Change putc_unlocked to a
	declaration. This works better with some code that gets confused when
	it's a #define.
	* unix/setenv.c, unix/putenv.c: Make putenv works as advertised for
	setenv when handling RISC OS native variables as documented in the
	README.

Tue Jan 29 22:46:43 PST 2008  Peter Naulls  <peter@chocky.org>

	* unix/statfs.c, include/sys/vfs.h, include/statfs.h: Dummy
	statfs implementation.

Sun Jan 27 19:29:25 PST 2008  Peter Naulls  <peter@chocky.org>

	* stdio/fpurge.c, include/stdio.h: Added hopefully correct fpurge
	implementation.

Mon Dec 31 17:10:15 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s: Force word alignment of bss area. If we don't and
	a bss section whose size is not a multiple of 4 is merged before this one,
	then it will be misaligned.
	* sys/_vfork.s: Likewise.

Thu Dec 27 04:47:04 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* sys/_jmp.s (setjmp): Previous change introduced wrong GOT handling
	for shared library support.

Sun Dec 23 17:36:16 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* string/basename.c: Added version from glibc 2.7.
	* include/string.h (basename): Added prototype.

Sat Dec  1 05:51:17 CET 2007  Peter Naulls  <peter@chocky.org>

	* unix/unix.c: Fixed typo.

Sun Nov 25 11:36:06 PST 2007  Peter Naulls  <peter@chocky.org>

	* include/swis.h: Massive number of missing SWIs. Thanks to Rob F. Johnson.
	* unix/stat.c: Add missing stat64 function - just call stat.

Sun Nov 18 02:40:16 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* debug/dvsprintf.c: Synced with the latest Linux version.
	* stdio/freopen.c, stdio/newstream.c, stdio/flsbuf.c, stdio/fwrite.c,
	stdio/fopen.c, stdio/fpos.c, stdio/fclose.c, stdio/popen.c,
	unix/open.c, unix/close.c, unix/stat.c, unix/features.c,
	unix/select.c, unix/unix.c, unix/dirent.c, unix/dev.c,
	unix/putenv.c, unix/getenv.c, unix/write.c, pthread/create.c,
	pthread/exit.c, pthread/pthinit.c, pthread/newnode.c,
	pthread/context.c, signal/sleep.c, signal/sigprocmsk.c,
	signal/sigsuspend.c, signal/post.c, common/riscosify.c,
	common/funcallerr.c, sys/brk.c, sys/stackalloc.c, sys/exec.c,
	sys/execvp.c: Make use of debug_printf.

Sat Nov 10 18:06:26 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* common/riscosify.c: Use GNU code style
	(__sfixfind): Changed while() into for()
	(riscosify): Do the test on non-__RISCOSIFY_MASK bits only when
	configured for __UNIXLIB_PARANOID and use assert() for this.

Thu Oct 25 16:49:23 2007  Lee Noar  <leenoar@sky.com>

	* gcccompat/_b_return.s: Poke function name to aid debugging.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/_b_frame.s: Likewise.
	* sys/_syslib.s: In the DSO, call Dynamic Loader function
	_dl_call_ctors() to call all shared library _init functions.

Tue Oct 16 01:55:08 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* module/sul.s(sul_exec): finetune previous change by canonicalising
	given exec parameter using Run$Path and verifying if result is an
	existing file.  If not, fall back on original given parameter.

Sat Oct  6 22:24:36 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	Due to the large number of files where following changes were made, we
	won't mention them all explicitly.
	* __set_errno: use it more consistently to set errno value and return
	-1.
	* __ul_seterr: likewise.
	* IGNORE(): removed.
	* Include unixlib/unix.h to get access to private UnixLib variables.
	* Reduction of the export of private variables by referencing them
	via __ul_global.
	* Updated comments.
	* dsp_exit: renamed to __dsp_exit.
	* scl/_ksetenv.s(_kernel_setenv): declare as function.
	* scl/_kswi_c.s(_kernel_swi_c): likewise.
	* scl/_kernel.s(_kernel_swi): likewise.
	* scl/_kosbyte.s(_kernel_osbyte): likewise.
	* scl/_koscli.s(_kernel_oscli): likewise.
	* scl/_kosbput.s(_kernel_osbput): likewise; call __ul_set_err in case
	of a RISC OS error.
	* scl/_kosgbpb.s(_kernel_osgbpb): likewise.
	* scl/_kosfile.s(_kernel_osfile): likewise.
	* scl/_kosfind.s(_kernel_osfind): likewise.
	* scl/_kosrdch.s(_kernel_osrdch): likewise.
	* scl/_kosbget.s(_kernel_osbget): likewise.
	* scl/_kgetenv.s(_kernel_getenv): likewise.
	* scl/_kosargs.s(_kernel_osargs): likewise.
	* scl/_kcurskch.s(_kernel_current_stack_chunk): likewise.
	* include/assert.h(assert): removed noreturn attribute.
	* module/sul.s(DEBUG_PROC_MATCHING): added debug output during
	sul_exec and sul_fork;
	(PROC_FORK_STORAGE): reserved 10*4 + 4*12 instead of 11*4 + 4*12
	bytes.
	(swi_handler): turned into branch table.
	(swi_value): reduced the number of different registers used.
	(swi_count): likewise.
	(sul_wimpslot): likewise.
	(swi_initialise): strip off the FS of OS_GetEnv argv[0] as well the
	executable given to sul_exec().
	(sul_fork): FP register f4-f7 were not restored.
	(sul_exec): canonicalise exec filename so that we can inherit process
	structures more reliably at swi_initialise; FP registers f4-f7 were
	wrongly restored when returning to a parent process.
	* common/_taskhandle.s(__get_task_handle): used to request taskhandle
	from OS and result is stored as __ul_global.taskhandle.
	* sys/_syslib.s:
	Removed X bit from SWI calls made before setting up our UnixLib OS
	environment handlers so that an error will call the default error
	handler automatically.
	(__get_cpu_arch): wasn't called when ___dynamic_no_da was set.
	(__unixlib_get_fpstatus): prefix with function name.
	(__unixlib_set_fpstatus): likewise.
	(__valid_address): likewise.
	(__unixlib_cli): dropped and its contents is now __ul_global.cli.
	(__time): dropped and its contents is now __ul_global.time.
	(__notused1):): dropped and its contents is now __ul_global.unused1.
	(__taskwindow): dropped and its contents is now
	__ul_global.taskwindow.
	(__taskhandle): dropped and its contents is now
	__ul_global.taskhandle.
	(__dynamic_num): dropped and its contents is now
	__ul_global.dynamic_num.
	(__old_u): dropped and its contents is now __ul_global.unused4.
	(__32bit): removed, this can easily and cheaply found out at run-time.
	(__panic_mode): dropped and its contents is now
	__ul_global.panic_mode.
	(__proc): dropped and its contents is now __ul_global.sulproc.
	(__ul_pagesize): dropped and its contents is now
	__ul_global.pagesize.
	(__upcall_handler_addr): dropped and its contents is now
	__ul_global.upcall_handler_addr.
	(__upcall_handler_r12): dropped and its contents is now
	__ul_global.upcall_handler_r12.
	(__pthread_return_address): dropped and its contents is now
	__ul_global.pthread_return_address.
	(__pthread_worksemaphore): dropped and its contents is now
	__ul_global.pthread_worksemaphore.
	(__pthread_system_running): dropped and its contents is now
	__ul_global.pthread_system_running.
	(__pthread_callback_semaphore): dropped and its contents is now
	__ul_global.pthread_callback_semaphore.
	(__pthread_callback_missed): dropped and its contents is now
	__ul_global.pthread_callback_missed.
	(__pthread_num_running_threads): dropped and its contents is now
	__ul_global.pthread_num_running_threads.
	(__executing_signalhandler): dropped and its contents is now
	__ul_global.executing_signalhandler.
	(__signalhandler_sl): dropped and its contents is now
	__ul_global.signalhandler_sl.
	(__signalhandler_sp): dropped and its contents is now
	__ul_global.signalhandler_sp.
	(__escape_disabled): dropped and its contents is now
	__ul_global.escape_disabled.

Sat Oct  6 17:32:59 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* sys/_vfork.s (fork,vfork): Prevent register corruption v4 and v5.

Sun Sep  2 02:19:59 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gcccompat/_b_return.s: Made code usable for libscl.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/galloca.c: Likewise.
	(__gcc_alloca_return_address): strip off the PC flags of return value
	when running in 26-bit mode.
	* gcccompat/_b_frame.s: Likewise.

Thu Aug 30 01:36:41 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl(sul): Reverted previous (unwanted and undocumented)
	change as it required libscl to be present; use STRIP iso OBJCOPY
	to extract binary blob out of ELF file which has the advantage that
	this is already defined in GCC build system.

Fri Aug 24 01:38:30 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/system.c(system): whitespace changes; use EXIT_FAILURE for
	_exit.
	* common/objattr.c: Whitespace changes.
	* common/symlinks.c: Likewise.
	* common/exist.c: Likewise.
	* sys/_syslib.s: Likewise.
	* unix/dev.c: Likewise.
	* unix/unix.c: Likewise.
	* stdlib/qsort.c(__UNIXLIB_PARANOID): use non-0 testing iso a strict
	positive test.
	* unix/dev.c(__UNIXLIB_SYMLINKS): Likewise.
	* common/objattr.c(__UNIXLIB_SYMLINKS): Likewise.
	* common/exist.c(__UNIXLIB_SYMLINKS): Likewise.
	* include/unixlib/unix.h(__UNIXLIB_PARANOID,__UNIXLIB_SYMLINKS):
	Likewise.
	* unix/getenv.c(__getenv_from_os): Updated comment on its API.
	* scl/_kcurskch.s(_kernel_current_stack_chunk): _kernel_chunk_stack
	was wrongly located and always returned NULL.
	* test/scl/test-kernel_current_stack_chunk.c: Added.
	* include/unixlib/asm_dec.s: Updated comment on CHUNK_* values.
	* include/kernel.h(__rt_allocauto): removed prototypes as it is no
	longer implemented.
	(__rt_freeauto): Likewise.
	* contrib/Help: Updated pointer to other documents.
	* sys/execlp.c: Updated comments.
	* sys/execvp.c: Likewise.

Mon Aug 20 22:41:11 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: forgot to escape special chararacters in previous
	change.

Fri Aug 17 23:49:29 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* sys/exec.c(execve): support __UNIXLIB_SYMLINKS.

Thu Aug 16 23:40:21 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: Define tooldir in produced Makefile.am so that partial
	build (or out-of-tree) of UnixLib works.

Wed Aug 8 19:03:03 2007  Lee Noar  <leenoar@sky.com>

	* common/symlinks.c: Don't use C based file access functions,
	because we may be called from one. Instead use low level OS
	functions.

Sat Aug 4 18:53:54 2007  Lee Noar  <leenoar@sky.com>

	* unix/dev.c: Add support for symlink files.
	* include/unixlib/buildoptions.h: Likewise.
	* include/unixlib/unix.h: Likewise.
	* common/objattr.c: Likewise.
	* common/exist.c: Likewise.
	* common/symlinks.c: New file. Implement symlink file processing.
	Primarily for use by GCC so that, eg, -lstdc++ will find symlink
	libstdc++.so which in turn points to libstdc++.6.0.8.so.

Sat Aug 4 17:39:01 2007  Lee Noar  <leenoar@sky.com>

	* vscript: Remove __pthread_cleanup_pop & __pthread_cleanup_push to
	make them visible from outside the DSO, as they could be called from
	a user program.

Sat Aug 4 14:40:20 2007  Lee Noar  <leenoar@sky.com>

	* vscript: Remove __pthread_start_ticker & __pthread_stop_ticker to
	make them visible from outside the DSO. Add __gcc_alloca_free_1 as
	it's only called by __gcc_alloca_free. Hiding it means a direct call
	instead of via the PLT and __gcc_alloca_free doesn't need to load
	the PIC register.

Tue Jul 10 00:53:25 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* include/sys/cdefs.h(__REDIRECT, __REDIRECT_NTH): Define.
	* include/sys/stat.h(struct stat): Define struct stat equal to the
	already existing struct stat64 and avoid the #define stat stat64 hack.
	Update function declaration of fstat64 and lstat64.
	* unix/lstat.c(lstat64): Use struct stat64 iso struct stat.
	* unix/fstat.c(fstat64): Likewise.
	* unix/stat.c(stat64): Likewise.
	* common/riscosify.c(translate_or_null): Avoid cast.

Fri Jul 6 14:16:12 2007  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s: Change PIC code to load PIC register from
	16 byte array instead of 4 byte array.
	* pthread/_yield.s: Likewise.
	* pthread/_ints.s: Likewise.
	* signal/_demangle.s: Likewise.
	* signal/_signal.s: Likewise.
	* common/_exist.s: Likewise.
	* common/_riscosify.s: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* sys/_jmp.s: Likewise.
	* sys/_vfork.s: Likewise.
	* sys/_syslib.s: Likewise.

Sat Jun 30 11:55:12 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s(__main): Using registers to receive data from
	crt1-riscos is not very elegant and we can't use the stack as it
	may not exist, so use a block of memory defined in crt1-riscos
	instead.

Tue Jun 19 20:00:43 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s(__main): Change below (r2667) did not solve
	anything as it still uses the stack. Abandon using the stack
	altogether and use only registers to receive data from crt1-riscos.

Tue Jun 19 19:18:29 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s(__main): Receive the _init/_fini function ptrs
	via registers as statically linked binaries may not have a
	valid stack pointer.

Sun Jun 17 16:23:01 2007  Lee Noar  <leenoar@sky.com>

	* include/unixlib/asm_dec.s: Remove XSOM_GOTFromAddr from the
	list of SWIs. The new PIC scheme makes it redundant.
	* include/swis.h: Change SWI number for SOM_DeregisterClient
	to account for the removal of SOM_Prologue and SOM_Resolver.

Sun Jun 17 14:30:21 2007  Lee Noar  <leenoar@sky.com>

	* gen-auto.pl: Remove -lpic from linker flags as it is no
	longer required.

Fri Jun 15 17:41:54 2007  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s: Use new PIC register loading scheme.
	* pthread/_yields.s: Likewise.
	* pthread/_ints.s: Likewise.
	* common/_exist.s: Likewise.
	* common/_riscosify.s: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* sys/_jmp.s: Likewise.
	* sys/_vfork.s: Likewise.
	* signal/_demangle.s: Likewise.
	* signal/_signal.s: Use new PIC register loading scheme.
	(__h_cback_common): Fix bug in DSO; when copying registers, start
	from the correct position in __cbreg.
	* sys/_syslib.s: Use new PIC register loading scheme.
	(__main): Retrieve values passed by crt1-riscos.o from the stack
	rather than from registers and store them as required. Register
	the program's _fini function with atexit() and call its _init
	function after library initialisation, but before main() is
	called. This replaces the call to __gccmain(). This is necessary
	as eventually, we'll also want to call the _init functions of all
	the shared libraries here too. Where the PIC register (v4) is used
	for non-PIC code, replace with v6.

Wed May 16 21:34:47 2007  Lee Noar  <leenoar@sky.com>

	* signal/_signal.s(__h_sigint): Fixed bug in DSO where r12 was assumed
	to be GOT pointer, but was actually reused for something else.

Wed Apr 11 03:21:40 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* string/{_ffs.s,_ffsll.s}: the armv5 implemenation didn't work at
	all; replaced the non-armv5 implementation by a faster algorithm from
	David Seal.
	* pthread/_ints.s: DCB -> .asciz
	* gen-auto: moved from GCCSDK recipe/files/scripts/reconf-libunixlib-01
	to here; updated it so that the configure.ac is generated from
	configure.template filling in the AC_OUTPUT parameters; updated it
	to create TESTS for each test subdirectories.
	* test: reorganised the test files.
	* gcccompat/galloca.c: fixed wrong test on __UNIXLIB_PARANOID to
	determine if asserts need to be enabled or not.

Tue Apr 10 19:10:01 2007  Lee Noar  <leenoar@ntlworld.com>

	* libtool.m4: Remove occurrences of -fcall-used-v5 as it's now implied
	by -fPIC.

Mon Apr  9 21:16:29 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	Removed the last pre-UnixLib 5 only alloca implementation remains:
	* include/pthread.h(struct __pthread_thread): reduced alloca entry
	array of 3 pointers to just one pointer. The other array entries
	were not used.
	* pthread/newnode.c: following above change in struct
	__pthread_thread.
	* include/unixlib/asm_dec.s: likewise.
	* gcccompat/galloca.c: likewise.
	Enabled asserts for __UNIXLIB_PARANOID enabled builds.  Listen to
	__UNIXLIB_ALLOCA_FATAL to determine what to do if alloca() fails due
	to memory failure.
	(__gcc_alloca_longjmp_free): added, restores the alloca chunk list
	at longjmp() time.
	* sys/_jmp.s(setjmp,longjmp): alloca_list no longer exists so no
	longer (re)storing this weak value. longjmp() calls
	__gcc_alloca_longjmp_free() when the alloca chunk list is different
	than that setjmp() time. Soft-float builds are no longer storing
	the floating point registers.
	* include/setjmp.h(jmp_buf): following above change in struct
	jmp_buf.
	* gcccompat/_b_frame.s: fixed comments which got incorrectly changed
	by the aof2elf assembler conversion.
	* pthread/_ints.s(__pthread_protect_unsafe): don't resore pc flags in
	__pthread_unprotect_unsafe value when running on 26 bit systems (not
	needed for APCS-32).
	* sys/_syslib.s(use_existing_chunk): don't restore pc flags in
	__free_stack_chunk value when running on 26 bit systems (not needed
	for APCS-32).

Mon Apr  9 01:57:11 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* signal/_signal.s(unrecoverable_error): don't test for FPU exception
	in soft-float build.
	* module/sul.s: explicit fpu specification as "fpa" as we're using
	FP instructions even in a soft-float build.
	* string/_memcpy.s: explicit arch specification as "armv6" to allow
	PLD instructions even if we're building with another -march compiler
	option.
	* README(<program name>$HeapMax): clarified it a little bit more.

Sat Apr  7 16:06:43 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/alloc.c(calloc): Detect size_t overflow for total size
	calculation as this might result in a non-NULL return value letting
	the caller believe it has a memory block that big.

Fri Apr  6 18:37:14 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* include/stdio.h(__STDIOLIB__): Removed static __stdiolib function
	pointer to __stdioinit (). It wasn't needed anymore for quite some
	time.
	* stdio/{freopen.c,fputs.c,fgets.c,perror.c,putc.c,flsbuf.c,getc.c
	stdio.c,ungetc.c,setbuf.c,puts.c,putw.c,fwrite.c,tmpfile.c,gets.c
	getw.c,filbuf.c,fopen.c,fpos.c,fclose.c,popen.c,fread.c,fflush.c}:
	Removed __STDIOLIB__.

Fri Mar 30 19:16:19 2007  Lee Noar  <leenoar@ntlworld.com>

	* vscript: New file. A linker file containing a list of symbols that
	are global within the DSO, but should not be visible outside the library
	as they are not part of its API. This has the same effect as declaring
	each symbol as hidden. The file is actually a version script, hence the
	name, but version information is not used in this case.

	There are a number of advantages to hiding such symbols:
	a) The API/public interface of the library is cleaner and hides the
	   internal workings.
	b) Library initialisation is quicker as there are fewer relocations at
	   runtime (the static linker is able to resolve more symbols at build
	   time).
	c) Functions that are only ever called from within the library and are
	   hidden are called directly and not via the PLT making the library
	   more efficient.

	More symbols may be added to the list in the future as it becomes clearer
	which qualify for inclusion.

Tue Mar 27 02:11:36 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* include/unixlib/asm_dec.s: include internal/defines.h; removed define
	TRUE/FALSE as it was not used.
	* include/unixlib/buildoptions.h(__UNIXLIB_CLZ_SUPPORTED): Removed,
	using __ARM_ARCH__ #define value instead.
	* string/_ffsll.s: Likewise.
	* string/_ffs.s: Likewise.
	* incl-local/internal/defines.h(__ARM_ARCH__,__ARM_ARCH_STR__): New
	file.
	* sys/_syslib.s: Reenabled runtime minimal ARM architecture check, was
	previously on XSCALE only, now based on __ARM_ARCH__ build and
	__get_cpu_arch runtime result.
	* README: updated with GCCSDK 4 build info.

Sat Mar 24 16:51:41 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/elf-macros.s (NetSWI0): Fixed odd typo.

Tue Mar 20 20:03:46 2007  Lee Noar  <leenoar@ntlworld.com>

	* sys/_syslib.s: Change visibility of main function pointer to hidden.
	This prevents the dynamic linker from linking against main() in the
	executable.

Sun Mar 11 18:34:50 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/elf-macros.s(UL_MEMORY_LAYOUT): Moving back to...
	* sys/_syslib.s: ...here.  Restored our stack ASCII art.
	* include/unixlib/asm_dec.s: Updated comments.

Sun Mar 11 16:54:44 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/aof-macros.s: Removed, no longer used.
	* incl-local/internal/elf-macros.s(__UNIXLIB_ERRNO_THREADED): changed
	from assembler test to preprocessor test; (__SOFTFP__) no longer
	defined as 0 when it is not defined.
	* include/unixlib/buildoptions.h(__UNIXLIB_ELF): Removed, no longer
	used.
	* unix/features.c : Removed tests on __ELF__, this is always 'true'
	from now on.
	* unix/unix.c: Likewise.
	* pthread/_exit.s: Likewise.
	* signal/_signal.s: Likewise.
	* include/features.h: Likewise.
	* include/unixlib/unix.h: Likewise.
	* include/sys/cdefs.h: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/galloca.c: Likewise.
	* gcccompat/_b_frame.s: Likewise.
	* string/_memcpy.s: Likewise.
	* string/_memset.s: Likewise.
	* sys/_syslib.s: Likewise.
	* sys/mman.c: Likewise.
	* include: Removed svn:ignore property.  No longer relevant.
	* include/unixlib: Updated svn:ignore property, buildoptions.s is no
	longer used nor exists.
	* include/endian.h: Typo fix.
	* pthread/_context.s (__SOFTFP__): Test on existance and not on its
	value.
	* sys/_jmp.s: Likewise.
	* sys/_syslib.s: Likewise.
	* README: Documented __program_name.
	* sys/_alloca.s: Removed, no longer needed.

Sat Mar 10 21:21:23 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* Used convert-unixlib.pl for the last time and stored its ELF
	result in SVN as trunk/gcc4/recipe/files/libunixlib.

Tue Mar 06 21:03:02 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/unixlib/unix.h: When not compiling for the
	shared library, use padding in place of the main function
	pointer to maintain structure offsets.
	* source/sys/_syslib.s: Always define the word that stores
	the main function pointer to maintain structure offsets,
	but only name it in the shared library.

Sun Mar 04 14:55:23 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/unix/unix.c: Remove the dependency on the main symbol
	from the shared library by declaring and accessing it as a
	function pointer.
	* source/clib/unixlib/unix.h: Add main function pointer to
	__ul_global structure (shared library only).
	* source/clib/unixlib/asm_dec.s: Add main function pointer to
	GBL_* structure (shared library only).
	* source/sys/_syslib.s: In the shared library, initialise the
	main function pointer from the arguments passed to it in
	crti-riscos.asm and add main function pointer to the
	__ul_global structure.

Sun Jan 21 15:21:56 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/features.h, source/common/_exist.s: Change default
	value of __feature_imagefs_is_file to 1.

Fri Jan 19 15:56:39 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s: Undo changes made Thu Jan 18.
	* source/unix/unix.c: Change comment about _main.

Thu Jan 18 19:39:06 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s: For the ELF build, convert __main into
	an initialisation function called __unixlib_main that returns
	to its caller. This allows the call to _main (and ultimately
	main()) to be moved to the executable.
	* source/unix/unix.c: Don't compile _main() for the ELF build.
	It is moved to crti-riscos.asm so that it can call main() in the
	executable.

Sat Jan 13 19:06:23 2007  Lee Noar  <leenoar@ntlworld.com>

	* elf/libtool.m4: Change names of shared library and symlinks to
	something that is recognised by GCC (effects libunixlib and libm
	only). In the dlopen test, look for riscos at the end of the
	string rather than the beginning.

Fri Jan 12 21:29:54 2007  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl: Link libunixlib.so with shared libgcc.

Sat Jan 06 01:25:35 2007  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/pthread/_exit.s: Use v1 for function table pointer;
	a2 need not be preserved by callees under APCS

Fri Jan 05 17:13:54 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s (__main):
	Use correct PIC register which is v6 in this case, not v4.
	Make sure v6 (PIC register) is not used for anything else so that
	it is valid throughout the routine (anticipating future changes).

Thu Jan 04 18:17:23 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/string/rawmemchr.c: Declare rawmemchr as alias for __rawmemchr
	otherwise rawmemchr is undefined.

Wed Dec 27 12:22:23 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/sys/elf.h: Correct spelling of R_ARM_JUMP_SLOT.

Wed Dec 27 03:08:02 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/{stdarg.h,stddef.h,varargs.h}: Restored as clean build
	of GCC 3.4.6 did not work anymore (got obfuscated by a copy in
	$GCCSDK_INSTALL_ENV/include/unixlib).
	* source/gcccompat/_b_frame.s: Previous change broke the ELF shared
	build.

Tue Dec 26 21:12:06 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/gcccompat/{_b_return.s,_b_frame.s,_galloca.s,galloca.c}:
	finished and reworked the alloca, __builtin_return_address and
	__builtin_frame_address implementations for GCC 4
	This improves the gcc/g++ testsuite results.

Tue Dec 26 16:26:23 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/pthread/_exit.s: Fix FIXMEs, ie, don't use
	__alloca_thread_free_all or ___arm_alloca_thread_free_all in
	ELF build.

Tue Dec 26 14:59:48 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s: Move DECLARE_FUNCTION of __trim_stack to the
	end of __free_stack_chain as technically they are part of the same
	function and also there's a possibility that the compiler may
	separate them in the resulting object file.

Mon Dec 25 17:03:19 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl: Link libpic.a into libunixlib.so and add
	version info to libunixlib.so and libm.so.

Wed Dec 20 20:47:17 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	Small bit of code reshuffling and cleanup before addressing the
	remaining source/gcccompat alloca work.
	* source/stdlib/random.c: GCC has inline.
	* source/stdlib/div.c: Remove __GNUC__ check.
	* source/unix/unix.c: Uppercase start char of __unixlib_fatal() calls.
	* source/pthread/_exit.s(___arm_alloca_thread_free_all,
	__alloca_thread_free_all): disabled for ELF builds.  These should go
	for good when UnixLib build is ELF only.
	* source/signal/post.c: No longer make use of __backtrace_getfp() by
	using inline assembler.
	* source/clib/unixlib/sigstate.h(__backtrace_getfp): Removed
	declaration.
	* source/signal/_coredump.s(__backtrace_getfp()): Removed file.
	* source/clib/unixlib/asm_dec.s(GBL_,MEM_): Updated comments.
	* source/clib/unixlib/asm_dec.s(CHUNK_): Added CHUNK_ definitions from
	_syslib.s.
	* source/clib/bits/byteswap.h(__bswap_16,__bswap_32): Removed
	declaration.
	* source/netlib/{_bswap_16.s,_bswap_32.s}(__bswap_32,htonl,ntohl,
	__bswap_16,htons,ntohs): Removed files.
	* source/clib/stdio.h: Removed Norcroft specific pragmas.
	* source/scl/_kfpavailable.s(_kernel_fpavailable): Code moved from
	_syslib.s.
	* source/gcccompat/{_moddi3.s,_divdi3.s,_umoddi3.s,_udivdi3.s}
	(__moddi3.s,__divdi3.s,__umoddi3.s,__udivdi3.s): Removed (we've enabled
	those routines in gcc/libgcc/Makefile).
	* source/sys/_alloca.s(alloca,__alloca,__alloca_thread_free_all):
	Disabled code for ELF builds as it is not used.  This file should go
	for good when UnixLib build is ELF only.
	* source/sys/_syslib.s: Moved CHUNK_ definitions to asm_dec.s; Don't
	check for FPEmulator in soft-float builds; Don't export
	__stackchunk_magic_number; Changed termination CR/NL + NUL to NUL for
	fatal error messages; Renamed free_stack_chunk to __free_stack_chunk
	and exported it; Moved __builtin_return_address implementation to
	gcccompat/_b_return.s.; Moved _kernel_fpavailable implementation to
	scl/_kfpavailable.s.; Added important FIXME for __trim_stack; Added
	suggestion for __unixlib_fatal_got_msg improvement.
	* source/gcccompat/_b_return.s(__builtin_return_address): Code moved
	from _syslib.s and added some comments on necessary improvements.
	* source/gcccompat/_galloca.s: Added a couple of FIXMEs.
	* source/gcccompat/galloca.c: Removed __backtrace_getfp() call; Added
	FIXMEs and a couple of small changes (like do not access data from a
	free'd memory block).

Mon Dec 18 03:28:56 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/stdlib/alloc(malloc,free,realloc,memalign,valloc,pvalloc,
	calloc,cfree,malloc_trim): prefixed routine names with '__' and made
	weak aliases for the original routine names to those implementations.
	* source/clib/limits.h(SHRT_MIN,INT_MIN,LONG_MIN,LONG_LONG_MIN): don't
	use C casting as these values should be evaluatable by the preprocessor
	too.
	This improves the g++ testsuite results.

Sun Dec 17 15:31:56 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/{libm-dbl64/s_finite.c,libm-flt32/s_finitef.c}: enable
	call to (currently empty) hidden_def(). This will be needed when we're
	going to hide symbols from shared UnixLib version.
	* source/clib/{complex.h,math.h}: don't declare 'long double' math
	variants here when building UnixLib as they are	declared in the source
	code as aliases to the 'double' variants.
	* source/clib/mathdef.h(__NO_LONG_DOUBLE_MATH): no longer define it so
	this means we're supporting 'long double' math calls but they are in
	reality the same as 'double' ones.
	* source/clib/varargs.h: Removed (falling back on the gcc version).
	* source/clib/bits/mathcalls.h: Using an up-to-date version.
	* source/libm-complex/{creall.c,conjl.c,cabsl.c,cargl.c,cimagl.c}:
	Removed as they are elsewhere declared as aliases to their 'double'
	equivalents.
	* elf/convert-unixlib.pl(NO_LONG_DOUBLE): Defined, meaning we're going
	to alias the 'long double' math routines to the 'double' versions.
	This improves the gcc testsuite results.

Sat Dec 16 14:41:51 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stddef.h: Removed (falling back on the gcc version).
	* source/clib/bits/mathdef.h(INFINITY): Removed duplicate definition,
	was also defined in source/clib/bits/inf.h.
	This improves the gcc/g++ testsuite results.

Fri Dec 15 04:34:46 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stdlib.h(atof,atoi,atol,atoll): consistent declaration of
	exported and inline variants.
	This improves the g++ testsuite results.

Sun Dec 10 21:03:51 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stdarg.h: Removed (falling back on the gcc version).
	* source/string/_memcpy.s: Previous change got a build breaking typo.
	* source/string/_memset.s(memset,bzero): Made exported routines
	weakly defined.
	This improves the gcc/g++ testsuite results.

Sun Dec 10 15:29:31 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/stdio/_printf.s(_printf,_fprintf,_sprintf,_vfprintf,_vprintf,
	_snprintf,_vsprintf,_vsnprintf): Removed.
	* source/stdio/printf.c(vsnprintf,vsprintf,snprintf,sprintf,vprintf,
	fprintf,printf): Prefixed the exported routines with '__' and created
	weak symbols to those routines.
	* source/stdio/vasprintf.c(vasprintf): Likewise.
	* source/stdio/asprintf.c(asprintf): Likewise.
	* source/crypt/crypt_util.c(encrypt_r,setkey_r): Likewise.
	* source/crypt/crypt-entry.c(crypt_r,fcrypt): Likewise.
	* source/string/strndup.c(strndup): Cleanup, weak_alias is always
	defined (even for AOF case).
	* source/string/strnlen.c(strnlen): Likewise.
	* source/resolv/inet_addr.c(inet_aton): Likewise.
	* source/string/_memcpy.s(memcpy,memmove,bcopy): Made exported routines
	weakly defined.
	This all improves the gcc/g++ testsuite results.

Sat Dec 09 14:47:59 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s(__rt_stkovf_split_big): Make sure that the frame size
	calculation takes into account the PIC register.

Sat Dec 09 14:26:02 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_jmp.s: Add PIC instructions and declare functions
	for ELF DSO.
	* source/sys/_alloca.s: Likewise.
	* source/sys/_vfork.s: Add PIC instructions and declare functions
	and objects for ELF DSO.
	* source/sys/_syslib.s: As above, also use a macro to define the layout of
	__ul_memory to support AOF/static ELF/shared ELF at the same time without
	unsightly nested conditional assembler.
	* source/sys/_syslib.s(__env_unixlib): Pass GOT pointer to exception
	handlers where possible.

Thur Dec 07 19:42:15 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/errno.h: Ensure C linkage when used with C++
	compiler, otherwise there's a linkage disagreement with
	sys_errlist and sys_nerr in stdio.h.

Wed Dec 06 20:19:15 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_os.s: Declare functions for ELF DSO.
	* source/sys/_mman.s: Likewise.
	* source/sys/_sigjmp.s: Likewise.
	* source/sys/_swi.s: Likewise.

Wed Dec 06 19:50:16 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/signal/_demangle.s: Add PIC instructions and declare
	function for ELF DSO.
	* source/signal/_signal.s: Add PIC instructions and declare
	functions and objects for ELF DSO.
	* source/signal/_coredump.s: Declare function for ELF DSO.

Wed Dec 06 19:35:42 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/unixlib/asm_dec.s: Add XSOM_GOTFromAddr to list of SWIs.

Wed Dec 06 19:19:42 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/aof-macros.s: Define macro UL_MEMORY_LAYOUT
	to make it easier to specify _ul_memory for {AOF/ELF static/ELF shared} in
	sys/_syslib.s.
	* source/incl-local/internal/elf-macros.s: As above, also add PIC instructions
	to __set_errno and __get_errno macros for ELF DSO.

Sun Dec 03 16:36:08 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/pthread/_context.s: Add PIC instructions and declare
	objects and functions for ELF DSO.
	* source/pthread/_yield.s: Likewise.
	* source/pthread/_ints.s: Likewise.
	* source/pthread/_exit.s: Likewise.

Wed Nov 29 22:58:55 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/buildoptions.h: Removed __UNIXLIB_MULL_SUPPORTED
	as it isn't used anymore.

Wed Nov 29 22:43:05 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/buildoptions.h,
	source/incl-local/internal/swiparams.h: Removed
	__UNIXLIB_USEFILEPATH build support and made FILEPATH default instead
	of using Run$Path.

Wed Nov 29 22:10:40 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/{unixlib/buildoptions.h,bits/sockaddr.h,sys/ioctl.h},
	source/netlib/{_sendmsg.s,_recvmsg.s,_getpeerna.s,_recvfrom.s,
	_accept.s,_getsockna.s}: Removed Internet 4 support
	(__UNIXLIB_COMPAT_INET4, which was equivalent to COMPAT_INET4 in
	Acorn's TCPIPLibs headers).

Wed Nov 29 20:36:22 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* Removed build support for Norcroft and LCC compilers (preprocessor
	tests on __UNIXLIB_NORCROFT_BUILD, __CC_NORCROFT,
	__CC_NORCROFT_VERSION, __LCC__).
	* source/{scl/_memchk.s,sys/_profile.s,sys/_longlong.s,sys/_divtest.s,
	sys/_smod.s,sys/_umod.s,sys/_sdiv.s,sys/_sdiv10.s,sys/_udiv.s,
	sys/_udiv10.s}: Removed private Norcroft routines.
	* source/sys/_alloca.s(__rt_freealloc,__rt_allocauto): Likewise.
	* source/sys/_syslib.s(x$stack_overflow,x$stack_overflow_1): Likewise.
	* source/sys/{_udivsi3.s,_modsi3.s,_umodsi3.s,_divsi3.s}: Removed
	unnecessary duplication of GCC private routines (already available in
	libgcc.a).
	* __UNIXLIB_NO_COMPLEX: Removed.
	* Docs/ReadMe,!Help: Updated that we're only support GCC compiler now.

Tue Nov 28 22:48:49 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/stdlib/qsort.c, source/unix/unix.c,
	source/clib/{unixlib/buildoptions.h,bits/libc-lock.h,pthread.h,
	errno.h},source/gcccompat/galloca.c,source/string/strsignal.c,
	source/signal/_signal.s, source/sys/{stackalloc.c,errlist.c,exec.c,
	_jmp.s,_syslib.s}: Remove compile test on __UNIXLIB_FEATURE_PTHREADS.
	pthread support is standard now.
	* source/clib/unixlib/unix.h(struct ul_global): made
	__pthread_worksemaphore and __pthread_callback_semaphore volatile
	as they are (can) be modified under interrupts.

Sat Nov 25 12:36:08 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/elf-macros.s: Remove warning notes as
	GAS no longer faults resulting instructions when a tab is included.
	* source/incl-local/internal/aof-macros.s: Always assemble a non-PIC
	instruction in AOF.

Wed Nov 22 19:33:04 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/common/_atomic.s: Declare function for ELF DSO.
	* source/common/_exist.s: Add PIC instructions and declare
	functions and objects for ELF DSO.
	* source/common/_riscosify.s: Likewise.

Tue Nov 21 20:34:20 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl: Only handle labels that begin
	with a '.' if they are delimited by '|' to prevent
	clashes with assembler directives.

Mon Nov 20 20:26:46 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/configure.ac: Enable libtool support to build both
	static and shared versions of libunixlib.

Mon Nov 20 19:57:46 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl:
	Alter label handling to allow them to start with a '.'.
	Add include/unixlib/stubs.h to list of install headers.
	Change *_SOURCES and *_LIBRARIES variables to libtool
	versions.
	Make sure libtool doesn't try to link libunixlib against
	itself by passing -nostdlib to compiler.
	Change nostackfiles dependencies to work with libtool.
	Add elf/libtool.m4 to list of files to copy.
	Add include path to aclocal-1.9 command to ensure it picks
	up the elf/libtool.m4 file.

Mon Nov 20 19:00:46 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/dlfcn.h: New file. Provide defines, etc for
	dynamic linker.

Sun Nov 19 19:37:30 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/libtool.m4: New file to provide alternative versions
	of autoconf macros AC_LIBTOOL_SYS_DYNAMIC_LINKER,
	AC_LIBTOOL_PROG_COMPILER_PIC and AC_LIBTOOL_DLOPEN_SELF.
	These override the standard macros to allow RISC OS target
	to be detected during configuring of Unixlib.

Sun Nov 19 17:01:30 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/netlib/getnameinfo.c: Only compile for static library to
	prevent multiple definition of getnameinfo() (also defined in
	netlib/getaddrinfo.c) when linking shared library.

Sun Nov 19 16:05:12 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/aof-macros.s:
	Add macro to define word of data to mirror same
	macro in elf-macros.s.
	Add NOP macros to mirror those in elf-macros.s that
	are used for the ELF shared library.

Sun Nov 19 14:58:12 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/elf-macros.s:
	Disable macro extension to allow quoted macro arguments.
	Change label names in NAME macro to allow multiple use.
	Add macros to declare type and size of functions and objects
	defined in assembler.
	Add macros to conditionally assemble PIC instructions for shared
	library.
	Add macro to define word of data with or without GOT relocation
	depending on library being built.

Tue Nov  7 19:44:12 2006  Lee Noar  <leenoar@ntlworld.com>

	* unixlib/elf/convert-unixlib.pl: Added code to generate stubs header
	for ELF version (adapted from gen-makefiles.pl).

Sun Oct  8 19:38:58 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/sys/elf.h: Added (copy of Lee Noar's GCCSDK 3.4.6 patch
	of his ELF work).

Wed Oct  4 22:22:30 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* Removed all CVS identifiers, updated Copyright statements and years
	based on SVN history (but UnixLib history starts before CVS/SVN so
	start dates are not always correct).

Sun Oct 01 01:02:06 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	Start of UnixLib 5.0 as RISC OS RunTime lib in ELF format.
	* source/debug/dvsprintf.c: renamed isxdigit()/isdigit()/tolower()/
	toupper()/strnlen() to local_* as this gave warnings and an error
	with GCC 4.1.1.
	* source/common/riscosify.c: temporary disabled RO_ENV support as
	GCC 4 ELF build does not have support for this.
	* source/sys/_syslib.s: temporary disabled the XScale test as it
	not supported by the convert-unixlib.pl right now.
	(__builtin_return_address): Added (code from Nick Burrett).
	* elf/convert-unixlib.pl: updated so it works with the current
	UnixLib code base and the build system we've now setup for GCC 4.1.
	* !Help: Update version to 5.0.
	* source/clib/features.h (__ULIBC__, __ULIBC_MINOR__): Updated it to
	5.0.

[ ^^^ Here starts UnixLib 5.0 ^^^ ]
-----------------------------------------------------------------------
Sun Jul 29 20:17:09 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: update section on pthread & Wimp behaviour after recent
	progress in this area.

Sun Jul 29 15:00:17 CET 2007  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/sys/__getcpuarch.s(__get_cpu_arch): wrong result for ARM
	architecture 3 processors.

-----------------------------------------------------------------------
[ vvv Here ends UnixLib 4.6 vvv ]

Sun Jul 15 13:52:59 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.6.
	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 6.

Sun Jul  8 19:14:58 CET 2007  John-Mark Bell  <jmb@netsurf-browser.org>
                              John Tytgat  <John.Tytgat@aaug.net>

	* source/pthread/_context.s: enabled pthread Wimp filter code after
	fixing following:
	(start_call_every,stop_call_every) full register + processor flag
	preserve.
	(__pthread_start_ticker, __pthread_stop_ticker) post filter mask was
	inverted.
	(__pthread_start_ticker) recheck if we're not yet a task since last
	check.
	* source/sys/_syslib.s: don't write bogus GBL_TASKHANDLE when
	Wimp_ReadSysInfo fails.
	* source/test/pthread/create-join.c: new pthread test case.

Wed May 23 20:31:26 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/include/unixlib/types.h: Fix typo in typedef.

Sun Apr 29 17:55:43 CET 2007  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/unix/unix.c(find_redirection_type): don't go beyond start of
	cmdline when it starts with the redirection_type character or one or
	more digits followed by the redirection_type character.

Tue Mar 27 01:48:55 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/unix.h(__get_cpu_arch): Declare.  Gives rough
	indication which ARM architecture we're running on.
	* source/sys/_getcpuarch.s(__get_cpu_arch): New file.
	* unix/uname.c(uname): changed utsname.sysname from "riscos" into
	"RISC OS" and utsname.machine from "arm-acorn" into "armvxl" with 'x'
	the major ARM architecture digit.

Thu Jan 18 21:59:26 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/errno.h: Change EDEADLK value for TCPIPLibs
	compatibility and add ENOTSUP.

Sun Jan 14 16:38:22 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/errno.h: Change EAGAIN value to the same as
	EWOULDBLOCK, to match TCPIPLibs and Linux.

Thu Jan 11 21:48:46 CET 2007  Martin Wuerthner  <martin@mw-software.com>

	* source/common/riscosify.c (__riscosify_scl): Incorrect program name
	  determination for programs run as "*Run MyLibrary:myprog".

Sun Dec 24 15:01:25 PST 2006  Peter Naulls <peter@chocky.org>

	* source/sys/exec.c: Add to the hack that checks whether we use
	 argv[0] or not - canonicalise RISC OS versions of the filenames before
	 comparing.

Mon Dec 04 01:59:39 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/string/strnicmp.c: Compare lowercased versions of strings
	rather than uppercase. This matches the manpage (and what stricmp
	does).

Tue Nov 21 21:45:22 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/sync.c (fsync): Don't error on files open with
	  O_RDWR

Sat Oct 21 22:38:13 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/regex.h: Made it usable for C++ programs.

Wed Oct  4 23:13:35 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/sys/exec.c (execve): Made code slightly less obfuscated.

Tue Sep 26 23:14:57 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/time/mktime.c: Fix corruption of input structure (bug #152)

[ ^^^ Here starts UnixLib 4.x ^^^ ]
-----------------------------------------------------------------------
[ vvv Here ends UnixLib 4.5 vvv ]

Thu Sep 14 01:25:05 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.5.
	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 5.
	* Docs/ReadMe: reformated last change.

Wed Sep 13 22:13:35 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/common/riscosify.c (riscosify_scl): Add support for
	  UnixEnv$foo$sfix.

Sat Sep  9 12:24:32 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/dirent.c (readdir_r): Fix suffix swapping code.
	  Fix the result value (POSIX states it should be the value of
	  entry, or NULL).

Fri Sep  8 16:42:35 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/common/unixify.c: Fix unixify early exits to return pointer to
	  buffer rather than pointer to NULL terminator.
	* source/test/testunixify.c: Add test for "..".

Mon Sep  4 06:43:03 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/Makefile.in, source/common/riscosify.c: Avoid using hard-wired
	  "/home/riscos/env/" path.
	* source/clib/bits/posix_opt.h: Refine further.

Sat Aug 26 16:59:31 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/pthread/{*.c,*.s}: Removed CVS keywords and made Copyright
	  statements conforming.
	* source/pthread/_context.s: Fixed comment.
	* source/pthread/_yield.s: Renamed callback_return to
	  __pthread_yield_return and gave it an APCS function name so we see
	  the thread waiting in the backtrace.
	* source/pthread/_ints.s: Use SWP instead off swp_arm2 macro.
	* source/pthread/_exit.s: Small optimisation.
	* source/signal.post.c(__write_backtrace,__write_backtrace_thead):
	  output backtrace per created thread.
	* source/signal/_signal.s: Updated comments.
	  (__h_exit) Setup signal stackhandler as the USR26/USR32 registers
	  can not be trusted (e.g. TaskManager calling OS_Exit when <Alt><Break>
	  gets pressed).
	* source/clib/unixlib/buildoptions.h: Removed __UNIXLIB_SWP_SUPPORTED. No
	  longer supporting or pretending to support ARM2.
	* source/incl-local/internal/aof-macros.s: Removed swp_arm2 macro.
	* source/incl-local/internal/elf-macros.s: Likewise.
	* source/sys/_syslib.s: Likewise.  Tabbified.

Sun Aug 13 11:45:32 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/sys/_syslib.s: Improve XScale check (from John-Mark Bell /
	  Adrian Lees).
	* source/wchar/mbsrtowcs.c: Add alias.

Sat Aug 12 07:15:40 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/unix/sync.c: More robust handling of file handles.

Thu Aug 10 20:48:03 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/clib/bits/posix_opt.h: Revise further
	* Docs/ReadMe: Update with notes about POSIX compatibility

Thu Aug 10 13:53:58 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/sys/_syslib.s: Check for RISC OS 5 when built for XScale.

Sun Aug  6 12:47:09 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/Makefile.in: Mark generated clib/unixlib/buildoptions.s file
	  clearly as a derived file.
	* debug/dvsprintf.c: don't make use of routines which have stack
	  checking enabled.  Write all info via __os_print() and not via stderr.
	* source/clib/unixlib/buildoptions.s: Removed (it will be generated
	  in the build).
	* source/clib/unixlib/asm_dec.s: Added SIGSTAK as alias for SIGEMT.
	* source/clib/bits/signum.h: Made SIGSTAK an alias for SIGEMT instead
	  of allocating an unique signal number (which is already beyound
	  the currently 32 supported signal set).
	* source/signal/signame.c: Reformated.
	* source/clib/unixlib/sigstate.h,source/signal/post.c,
	  source/signal/_demangle.s: respect the __cxa_demangle() API, i.e. all
	  its buffers are heap buffers.
	* sys/stackalloc.c: Include sys/debug.h when #define DEBUG is done.
	  (incr_downards): add check if downwards stack increasing doesn't mean
	  going lower than zero page.

Sat Aug  5 16:33:17 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/clib/bits/posix_opt.h: Be less optimistic about what
	  we support.
	* source/clib/bits/signum.h: Declare SIGSTAK for compatibility
	  with Acorn C.

Wed Aug  2 08:41:59 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/clib/unistd.h, source/clib/bits/posix_opt.h: Add
	  posix_opt header and set RISC OS features.  In particular,
	  set flags indicating UnixLib supports POSIX threads, required
	  by X libraries.

Sun Jul 30 19:12:17 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/sigstate.h,source/signal/_demangle.s
	  (__unixlib_cxa_demangle): via WEAK symbol, make libstdc++'s
	  __cxa_demangle routine available internally when it's possible.
	* source/signal/post.c(extract_name): make use of
	  __unixlib_cxa_demangle during __write_backtrace.
	* source/signal/post.c(__write_backtrace): don't output registers
	  when __ul_callbackfp is NULL as then they don't make any sense.
	* source/stdlib/_rand48.c: Removed bogus CVS tags.
	* source/signal/_signal.s,source_sys/_syslib.s: Minor comment
	  improvement.
	* Docs/Changelog: char 0xA0 -> 0x20.

Sat Jul 15 21:35:32 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/tty.c,source/clib/unixlib/fd.h: minor src code cleanup.
	* source/clib/unixlib/unix.h,source/common/funcallerr.c: made
	  __UNIXLIB_PARANOID build working again and added extra test on
	  function pointers be lower than __ul_memory.appspace_himem value.

Sun Jul  9 13:52:36 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c: Remove part of previous change so that
	  names such as foo/bar.c get translated correctly.

Fri Jun 16 12:03:17 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/stdio/scanf.c: Fix handling of width-limited character classes.
	  Previously re-read the last character that matched the format string.
	* source/test/stdio/tsscanf.c: Testcase for the above.

Thu Jun  8 00:17:00 2006  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.4
	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 4.
	* source/signal/post.c (__write_backtrace): show explicitly the
	  processor mode and flags when in 26bit mode; show memory contents of
	  disassembled part as words and ASCII interpretation of its bytes.

Wed Jun  7 22:52:47 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/sys/_syslib.s: Search for SUL in UnixLib:Modules
	  as well as System:Modules.

Sun May 21 20:36:42 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c: Don't do suffix swapping if the leafname
	  has a / in it.
	* source/test/testriscosify.c: Add extra testcase.

Tue Apr 11 17:40:56 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Allocate some memory to store the head of the
	  linked list so user mode code does not need to access the module
	  private word.
	  Fixed R4 corruption of SWI SharedUnixLibrary_RegisterUpCall.

Fri Mar 10 21:25:47 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/unix.c: Prevent canonicalising program name if it is
	  just a leafname.

Thu Mar  9 19:33:31 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/unistd.h: Add lchown().
	* source/unistd/lchown.c: New file.

Sun Feb 26 23:51:25 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/netlib/getaddrinfo.c(gai_strerror): Always wrongly returned
	  "Unknown error".
	* source/resolv/gethnameaddr.c(gethostbyname2): Use hosts file as
	  fallback when resolv query failed.

Tue Feb 14 23:31:18 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 3.

Mon Feb 14 00:39:17 2006  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.3
	* Docs.ReadMe: Current iconv module version is 0.07.  Also using more
	  stable URL.

Sun Feb 12 17:31:43 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/common/unixify.c: Obey __RISCOSIFY_NO_REVERSE_SUFFIX.

Sun Feb 12 13:29:24 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stdio.h (__io_mode): Changed struct into union so that
	  all bits can be set to zero in __getmode() in a more clean way.
	* source/stdio/fclose.c (fclose): Following stdio.h(__io_mode) change.
	* source/stdio/fflush.c (fflush): Likewise.
	* source/stdio/filbuf.c (check_stream): Likewise.
	* source/stdio/fopen.c (fopen, fdopen): Likewise.
	* source/stdio/fpos.c (fseek, ftell): Likewise.
	* source/stdio/fread.c (fread): Likewise.
	* source/stdio/freopen.c (freopen): Likewise.
	* source/stdio/fwrite.c (fwrite): Likewise.
	* source/stdio/getc.c (fgetc): Likewise.
	* source/stdio/newstream.c (__stream_init, __getmode): Likewise.
	* source/stdio/popen.c (pclose): Likewise.
	* source/stdio/printf.c (vsnprintf): Likewise.
	* source/stdio/putc.c (fputc): Likewise.
	* source/stdio/scanf.c (vsscanf): Likewise.
	* source/stdio/setbuf.c (setvbuf): Likewise.
	* source/stdio/ungetc.c (ungetc): Likewise.
	* source/stdio/vfprintf.c (__vfprintf): Likewise.
	* source/gcccompat/_galloca.s: Added missing END.
	* source/unix/dirent.c: Reduced compiler warnings.
	* source/unix/open.c: Likewise.
	* source/unix/select.c: Likewise.
	* source/unix/unix.c: Likewise.

Sun Jan 29 00:29:13 2006  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: DRenderer is now part of GCCSDK where further development
	  can take place.

Wed Dec 14 21:07:03 2005  Peter Naulls  <peter@chocky.org>

	* !Help: Update version to 4.2
	* source/sound/dsp.c: Buffer calculation improvements
	  from Alan Buckley.
	* source/clib/local.h, source/common/unixify.c:
          New __unixify_ext function.

Sun Dec  4 17:11:31 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c: Don't convert absolute filenames that
	  are already in Unix format.

Wed Nov 16 03:38:56 2005  John Tytgat  <John.Tytgat@aaug.net>

	* Removed EMBED_RCSID.
	* Removed 'register' keyword in all non-imported source files.

Sun Nov 13 15:44:22 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Cope with command lines where RISC OS has
	  stripped the temporary FS from the start.

Sat Nov 12 17:43:11 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/sys/exec.c: Strip any spaces before the command.
	* source/unix/dev.c (__pipeselect): Don't block on EOF.
	* source/unix/fcntl.c: Search for next free file descriptor rather
	  than assuming the one given is unused.
	* source/unix/unix.c (__alloc_file_descriptor): Allow starting
	  descriptor to be specified.
	  (check_fd_redirection): Use dup2 rather than fcntl so old
	  descriptor gets closed.
	* source/clib/unixlib/fd.h (__alloc_file_descriptor): Add parameter.
	* source/netlib/accept.c: Likewise.
	* source/netlib/socket.c: Likewise.
	* source/unix/open.c: Likewise.
	* source/unix/pipe.c: Likewise.

Sun Nov  6 14:38:12 2005  Alex Waugh  <alex@alexwaugh.com>

	* gen-makefiles.pl: Attempt to strip out incorrect dependencies added
	  by gcc -M.

Mon Oct 10 14:20:00 2005  Peter Naulls  <peter@chocky.org>

	* Docs/ReadMe: Misc corrections and updates.
	* source/sys/_swi.s: Correct _swix() output arguments.
	  Fix from Bob Brand.
	* source/unix/mkdir.c: Spot more directory creation
	  failure variants.

Sat Sep 24 22:24:47 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Add an additional check of the command line
	  when searching for a process struct to use (Bug#142).

Sat Sep 24 20:39:23 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/fcntl.c: Close-on-exec flag should be cleared on
	  duplicated file descriptors (Bug#146).

Fri Aug 26 00:12:33 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* regexp/{COPYRIGHT,regcomp.c,regcustom.h,regc_color.h,regc_cvec.h,
	          regc_lex.h,regc_locale.h,regc_nfa.h,regerror.c,regerrs.h,
	          regexec.c,rege_dfa.h,regfree.c,regguts.h}, clib/regex.h:
	  Import regex implementation from PostgreSQL - this is significantly
	  faster than the existing implementation.
	* regexp/{cclass.h,cname.h,engine.h,regex2.h,utils.h}: Remove redundant
	  files.
	* Docs/Copyright: Add details of regex implementation licencing.

Sun Jul 31 16:17:49 2005  John Tytgat  <John.Tytgat@aaug.net>

	* clib/unixlib/{asm_dec.s,unix.h}, sys/_syslib.s: For some time UnixLib
	  required the FPEmulator so __fpflag is not really needed.  Renamed to
	  __notused1 (and not longer exported) so that we can reuse the space for
	  something else in the future. Renamed GBL_FPFLAG to GBL_NOTUSED1.

Sat Jul 23 13:45:59 2005  Peter Naulls  <peter@chocky.org>

	* common/unixify.c: Fully fix earlier fix.
	* clib/unixlib/os.h, signal/_signal.s: Make __ul_seterr
	  return -1 on error.
	* stdlib/alloc.c: Allow debug version to compile.
	* debug/dvsprintf.c: Use stderr for output once initialised.
	* unix/fcntl.c: Dummy file locking functionality.
	* unix/mkdir.c: Set ENOENT when the RISC OS error is "Not found".

Wed Jul 20 19:27:41 2005  Peter Naulls  <peter@chocky.org>

	* source/common/unixify.c: Correct conversion case when
	  file is in root directory.
	* elf/convert-unixlib.pl: Correct install location for GCC 4.1.

Thu Jul 14 23:29:00 2005  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c (__unixinit): Terminating NULL in environment list
	  could sometimes be written outside allocated buffer.

Fri Jul  8 15:34:42 2005  Peter Naulls  <peter@chocky.org>

	* UnixLib 4.2 release.

Fri Jul  8 14:23:04 2005  Peter Naulls  <peter@chocky.org>

	* pthread/keydest.c: Use free_unlocked instead of free to
	  match allocation.
	* sys/brk.c: Fix spelling mistake.
	* unix/unix.c: Convert process filename to Unix format;
	  patch from John Tytgat.

Fri Jun 17 11:05:25 2005  Nick Burrett  <nick@sqrt.co.uk>

	* libm-support/libm.c: New file.

Thu Jun 16 20:44:38 2005  Alex Waugh  <alex@alexwaugh.com>

	* time/utimes.c: Fix time convertion.

Thu Jun 16 14:51:14 2005  Alex Waugh  <alex@alexwaugh.com>

	* pthreads/context.c: Ensure the first thread in the list can
	  be freed when it is idle.

Thu Jun 16 14:24:59 2005  Theo Markettos  <theo@markettos.org.uk>

	* common/riscosify.c: Add support for mapping /home/riscos/env/foo
	  to foo:
	* test/testriscosify.c: Add more tests.

Mon Jun 13 14:55:30 2005  Peter Naulls  <peter@chocky.org>

	* clib/netdb.h: Remove bogus extra AI_PASSIVE.
	* clib/bits/sched.h, clib/pthread.h, clib/sched.h: Arrange
	  things a bit more like glibc (Allows problems with files named
	  sched.h to build).
	* gcccompat/_galloc.s, libm-dbl64/s_isnan.c,
	  incl-local/internal/math.h: Norcroft compatibility.
	* module/sul.s: Increase file handles to 256 as per UnixLib.
	  Bump version to 1.07.
	* source/sys/_syslib.s: Required SharedUnixLibrary 1.07.

Sat May 28 21:52:15 2005  Peter Naulls  <peter@chocky.org>

	* common/unixify.c: Ensure we don't run off the end of the input
	  buffer.
	* clib/errno.h: #define errno as itself, to allow for checks
	  that errno exists to work.
	* clib/sys/ioctl.h: Some TCPIPLibs compatibility (not implemented).

Mon May 16 22:30:29 2005  Peter Naulls  <peter@chocky.org>

	* stdio/fwrite.c (fwrite): Make (v)snprintf with null parameters
	  work properly.  Correct byte count.

Fri May 13 22:17:31 2005  Peter Naulls  <peter@chocky.org>

	* test/pthread/fork.c: Correct spelling.
	* Makefile.in: Stronger warning flags.
	* clib/features.h, libm-dbl64/s_finite.c, libm-flt32/s_finitef.c,
	  search/hsearch.c, search/hsearch_r.c, search/lsearch.c,
	  vfprintf.c: Make code work with new flags
	* stdio/fwrite.c (fwrite): Tidy and correctly return number of
	  items written.
	* stdio/printf (vsnprintf): Correctly terminate buffer.
	* stdio/putc.c (putc_unlocked): Implement new function.

Sat May  7 16:35:02 2005  Nick Burrett  <nick@sqrt.co.uk>

	* features.h (__ULIBC_MINOR__): Bump version to 1.

Sat May  7 16:08:52 2005  Stefan Bellon  <sbellon@sbellon.de>

	* signal/post.c (sigsetup): Casting fixes for Norcroft compatibility
	* sys/exec.c (execve): Likewise.

Sat May  7 10:14:36 2005  Nick Burrett  <nick@sqrt.co.uk>

	Software-floating point support.
	* source/Makefile.in (LIBM_FLAGS): Remove.
	* incl-local/math_private.h (LITTLE_ENDI): Define flags here according
	to value of __FLOAT_WORD_ORDER.
	(HIGH_HALF): Define.
	(LOW_HALF): Define.
	(BIG_ENDI): Define
	* endian.h (__FLOAT_BIT_ORDER): Define.
	(__FLOAT_WORD_ORDER): Define.
	* ieee754.h: Redefine unions according to values of __FLOAT_BIT_ORDER
	and __FLOAT_WORD_ORDER.
	* gdtoa/fpmath.h: Likewise.
	* gdtoa/arith.h: Include endian.h.
	* incl-local/internal/elf-macros.s (__SOFTFP__): Define to zero,
	if not defined.
	* incl-local/internal/math.h: Include endian.h.  Add structures
	to cope with little-endian __FLOAT_WORD_ORDER.
	* libm-dbl64/branred.c: Include <math_private.h> first, drop
	inclusion of endian.h.
	* libm-dbl64/{dosincos.c, e_asin, e_atan2.c, e_exp.c}: Likewise.
	* libm-dbl64/{e_log.c, e_pow.c, e_remainder.c, mpa.c}: Likewise.
	* libm-dbl64/{mpatan.c, mpatan2.c, mpexp.c, mplog.c}: Likewise.
	* libm-dbl64/{mpsqrt.c, mptan.c, s_atan.c, s_sin.c}: Likewise.
	* libm-dbl64/{sincos32.c, slowexp.c, slowpow.c}: Likewise.
	* libm-dbl64/upow.h: Swap ordering of 'static' and 'const'.

	* fenv/fclrexcpt.c: Use __SOFTFP__ rather than __SOFT_FLOAT__.
	* fenv/fedisblxcpt.c: Likewise.
	* fenv/fegetexcept.c: Likewise.
	* fenv/feholdexcpt.c: Likewise.
	* fenv/fesetenv.c: Likewise.
	* fenv/fraiseexcpt.c: Likewise.
	* fenv/fsetexcptflg.c: Likewise.
	* fenv/ftestexcept.c: Likewise.

	* stdlib/alloc.c (malloc): Check for __pthread_system_running
	before enabling/disabling interrupts.
	(free, realloc, memalign, valloc, pvalloc, calloc): Likewise.
	(cfree, malloc_trim): Likewise.

	* bits/signum.h: New file.
	* signal.h: Move all signal number definitions e.g. SIGHUP into
	bits/signum.h.
	(SIG_ERR, SIG_DFL, SIG_IGN, NSIG): Likewise.

Fri May  6 11:54:07 2005  Peter Naulls  <peter@chocky.org>

	* UnixLib 4.1 release.

Fri May  6 10:10:16 2005  Peter Naulls  <peter@chocky.org>

	* clib/sys/select.h: Add NFDBITS constant.
	* sys/_syslib.s: Require SharedUnixLibrary 1.06

Tue May  3 15:56:47 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* clib/sys/queue.h: Update to more recent version including more
	  queue types.

Mon May  2 14:51:58 2005  Nick Burrett  <nick@sqrt.co.uk>

	* module/sul.s (sul_fork): For consistency, shrink parent pid to
	30-bits.
	* gcccompat/galloca.c: New file for GCC 4 alloca implementation.
	* gcccompat/_galloca.s: New file for GCC 4 alloca implementation.
	* pthread/_exit.s (__pthread_exit): Call __gcc_alloca_thread_free_all.

Mon May  2 14:24:06 2005  Peter Naulls  <peter@chocky.org>

	* fenv/fclrexcpt.c, fenv/fedisblxcpt.c, fenv/egetexcept.c,
	  fenv/feholdexcpt.c, fenv/fesetenv.c, fenv/fraiseexcpt.c,
	  fenv/setexcptflg.c, fenv/testexcept.c: Do nothing interesting
	  when using soft-float.
	* pthread/_context.s: Don't save FP regs when using soft-float
	* sys/_jmp.s: Similarly.
	* sys/_syslib.s: Leave FP status register alone when using soft-float
	* incl-local/internal/aof-macros.s: Add missing END.

Mon May  2 13:45:54 2005  Nick Burrett  <nick@sqrt.co.uk>

	* module/sul.s (alloc_proc): Shrink the stored pid to 30-bits
	to work around applications that test for fork failure by testing
	(pid < 0).
	(sul_fork): Expand/shrink pid to/from 32-bits where necessary.
	(sul_exec): Likewise.
	(sul_exit): Likewise.

Sun May  1 15:54:36 2005  Nick Burrett  <nick@sqrt.co.uk>

	* module/sul.s (help): Move tab char onto seperate line to aid
	ELF conversion script.

Sun May  1 13:17:47 2005  Nick Burrett  <nick@sqrt.co.uk>

	* string/strtok_r.c (strtok_r): Check for a NULL save_ptr.
	* string/stricmp.c (stricmp): Corner case fix.

Sun May  1 11:22:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/strtol.c: Import from FreeBSD libc, includes bug fixes.
	* stdlib/strtoul.c: Likewise.
	* stdlib/atoi.c: New file, split from strtol.c.
	* stdlib/atol.c: New file, split from strtol.c.

Sat Apr 30 16:15:13 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unix/features.c (__get_program_name): For ELF, dereference weak
	symbol to verify whether it exists.
	* sys/mman.c (mmap): Likewise.

Sat Apr 30 14:55:04 2005  Nick Burrett  <nick@sqrt.co.uk>

	Ease the conversion from AOF to ELF.
	* gcccompat/_divdi3.s: Change local label names to support ELF syntax.
	* gcccompat/_udivdi3.s: Likewise.
	* gcccompat/_moddi3.s: Likewise.
	* gcccompat/_umoddi3.s: Likewise.
	* sys/_jmp.s (__longjmp_fatal_msg): Ease translation to ELF syntax.
	* incl-local/internal/elf-macros.s (macro NAME): Place quotes around
	name.  Move .altmacro directive out of macro.
	* common/_exist.s: Remove quotes from NAME statements.
	* common/_riscosify.s: Likewise.
	* signal/_signal.s: Likewise.
	* sys/_syslib.s: Likewise.

Sat Apr 30 13:32:23 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/asm_dec.s: Move MACRO definitions to aid ELF conversion ...
	* incl-local/internal/aof-macros.s: ... here.
	* incl-local/internal/elf-macros.s: New file, providing ELF versions
	of the AOF macros.

Sat Apr 30 12:36:51 2005  Nick Burrett  <nick@sqrt.co.uk>

	* common/__stat.c: Renamed from common/stat.c to avoid filename
	clash with unix/stat.c.

Sat Apr 30 11:14:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/exec.c (execve): Fix call usage of malloc_trim_unlocked.

Fri Apr 29 19:23:19 2005  Peter Naulls  <peter@chocky.org>

	* clib/assert.h: Make NDEBUG work under C++.
	* clib/netdb.h, netlib/getaddrinfo.c: getaddrinfo and friends
	  implementation.

Fri Apr 29 13:43:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.h (struct ul_memory): Remove double-underscore
	prefix from 'unixlib_stack', 'robase', 'rwlomem', 'rwbase',
	'unixlib_stack_limit' and 'old_himem'.
	Change types for those variables from void* to 'unsigned int'
	as they aren't pointers and it reduces the number of explicit
	casts.
	(__stackalloc_incr_wimpslot): Change parameter types.
	* resource/initialise.c (__resource_initialise): Fix accordingly.
	* resource/ulimit.c (ulimit): Likewise.
	* debug/debug.c (__debug): Likewise.
	* common/funcallerr.c (__funcall_error): Likewise.
	* signal/post.c (sigsetup): Likewise.  Change types for 'low' and
	'high' and 'handler_addr' to unsigned int to avoid a lot of
	unnecessary casts.
	* sys/exec.c (execve): Use new variable names.  Call unlocked
	variant of malloc_trim.
	* sys/stackalloc.c (__stackalloc_incr_wimpslot): Change return
	type to 'unsigned int'.
	(incr_upwards): Renamed from '__stackalloc_incr_upwards'.
	(incr_downards): Renamed from '__stackalloc_incr_downwards'.
	(__stackalloc): Use new function names.

	* math.h (struct exception): Add const qualifier to 'name' to clear up
	compile-time warnings.
	* resolv/resolv.h (struct res_sym): Likewise for 'name' and
	'humanname'.

	Norcroft fixes from Stefan Bellon.
	* pthread/atfork.c: Include malloc.h.
	* pthread/key.c: Include malloc.h.
	* stdlib/alloc.c (malloc_trim): Cast return type of
	malloc_trim_unlocked.

Fri Apr 29 11:02:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	Remove the dual-purpose use of 'rwlomem' and '__unixlib_break'
	for both read/write application memory and dynamic areas.
	* unixlib/asm_dec.s (MEM_RWBREAK, MWM_DABREAK): New constants,
	split from MEM_UNIXLIB_BREAK.
	* unixlib/unix.h (struct ul_memory): Add 'dalomem'
	Remove the ambiguity of '__unixlib_break' by replacing it with
	'rwbreak' and 'dabreak'.
	* debug/debug.c (__debug): Add code to show the dynamic area
	memory limits.
	* resource/initialise.c (__resource_initialise): Use new variables.
	* sys/_syslib.s (__main): Use new variables.  When creating a
	dynamic area, set 'dalomem' and 'dabreak', rather than 'rwlomem'
	and 'unixlib_break'
	(__ul_memory): Add new fields.
	* sys/brk.c (__internal_brk): Delete function, moving code into
	two new functions ...
	(brk_da): ... this one for dynamic areas.  Use new 'da' variables.
	(brk_rw): ... this one for read/write data area in application space.
	(brk): Use new worker functions.
	(sbrk): Likewise.

Thu Apr 28 20:49:34 2005  Alex Waugh  <alex@alexwaugh.com>

	* sys/_syslib.s: Add missing spaces.

Thu Apr 28 13:47:20 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.h (struct ul_memory): Rename '__image_rw_himem' to
	'appspace_himem'.
	* debug/debug.c: Use 'appspace_himem'.
	* sys/brk.c: Likewise.
	* sys/vfork.c (__fork_post): Likewise.
	* sys/stackalloc.c (__stackalloc_init): Likewise.
	(__stackalloc_incr_upwards): Likewise.
	(__stackalloc_incr_wimpslot): Likewise.
	* unixlib/asm_dec.s (MEM_APPSPACE_HIMEM): Renamed from
	MEM_IMAGE_RW_HIMEM.
	* sys/_syslib.s (__main): Use it.
	(__check_stack): Use it.

Thu Apr 28 12:14:15 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.h (struct ul_memory): Rename '__unixlib_real_break'
	to 'dalimit'.
	Rename '__unixlib_real_himem' to 'appspace_limit'.

	* sys/brk.c (__internal_brk): Use 'dalimit'.
	Remove 32K check hack as system resource limits are setup before
	the first call to 'brk'.  Add more explanatory comments.
	* unix/unix.c (__unixinit): Call '__resource_initialise' before
	setting up pthreads.
	* unixlib/asm_dec.s (MEM_DALIMIT): Renamed from MEM_UNIXLIB_REAL_BREAK.
	(MEM_APPSPACE_LIMIT): Renamed from MEM_UNIXLIB_REAL_HIMEM.
	* sys/_syslib.s (__main): Use it.  In the non-dynamic area case
	do not set MEM_DALIMIT as it will remain unused throughout the
	execution of the application.
	* sys/_signal.s (__h_cback): Use 'MEM_APPSPACE_LIMIT'.

	* sys/stackalloc.c (__stackalloc_incr_wimpslot): Use 'appspace_limit'.
	If the request for increasing the wimpslot fails, don't adjust
	value of 'appspace_limit'.
	* sys/vfork.c (__fork_pre): Reference globals through '__ul_global'.
	(__fork_post): Use 'appspace_limit'.

Thu Apr 28 10:25:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	* signal/post.c (sigsetup): Perform address validation for the
	user supplied signal handler function and the user supplied
	signal stack.
	(extract_name): New function.
	(sigsetup): In DEBUG mode, use 'extract_name' to provide the
	function name of the signal handler, where possible.  Improve
	general debugging information.
	(post_signal): Likewise.

Wed Apr 27 18:38:51 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/asm_dec.s (MEM_RWLOMEM): Renamed from MEM_UNIXLIB_RWLIMIT.
	(MEM_IMAGE_RW_LOMEM): Deleted.
	* unixlib/unix.h (struct ul_memory): Rename __unixlib_rwlimit
	to __rwlomem.
	Delete __image_rw_lomem.
	Constify __robase, __rwlomem and __rwbase as these values should
	never change during the execution of a program.
	* sys/_syslib.s (__main): Fixup accordingly.
	* debug/debug.c (__debug): Use __rwlomem instead of __image_rw_lomem.
	* resource/initialise.c (__resource_initialise): Likewise.
	* resource/ulimit.c (ulimit): Likewise.
	* sys/brk.c (__internal_brk): Likewise.
	(__unixlib_real_break): Delete extern reference.

	* string/_memcpy.s: AREA should be 'C$$code' as the 'C' defines
	the language type for the run-time environment, not the type
	of language used in the source unit.

Wed Apr 27 17:00:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.c (struct ul_global): Move fields __image_rw_himem,
	__unixlib_stack, __robase, __unixlib_rwlimit,
	__image_rw_lomem, __unixlib_break, __unixlib_stack_limit,
	__rwbase, __unixlib_real_break, __unixlib_real_himem and __old_himem
	into new structure 'ul_memory'.
	Delete 'extern' declarations of those variables and therefore
	make them non-exportable.
	Delete '__image_ro_base' and convert all references to use '__robase'.
	* sys/syslib.s (__ul_global): Delete those fields from here and
	remove EXPORT lines.
	(__ul_memory): Declare.
	* unixlib/asm_dec.s (GBL_*): Adjust accordingly.
	(MEM_*): New definitions for referencing fields of 'ul_memory'.
	* common/funcallerr.c: Fix all occurances to the above variables to
	use 'ul_memory' structure and change references of '__image_ro_base'
	to '__robase'.
	* debug/debug.c: Likewise.
	* resource/initialise.c: Likewise.
	* resource/ulimit.c: Likewise.
	* signal/_signal.s: Likewise.
	* sys/_alloca.s: Likewise.
	* sys/_syslib.s: Likewise.
	* sys/_vfork.s: Likewise.
	* sys/exec.c: Likewise.
	* sys/vfork.c: Likewise.
	* sys/brk.c: Likewise and comes with improved code efficiency.
	* sys/stackalloc.c: Likewise.
	(REMOVE_FROM_FREELIST): Convert from a macro to an inline
	function.
	(ADD_TO_FREELIST): Likewise.

Wed Apr 27 12:14:41 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/alloc.c: Cleanup code, remove WIN32 and non-STDC code.
	Re-write public facing functions to disable pthread context
	switching around internal malloc calls.
	Rename functions to be the correct C function names, rather than via
	some macro mangling.
	Drop strange-case in function names, renaming all to lower-case.
	Internal versions of malloc, free, realloc are renamed to an
	unlocked variant.
	(largebin_index): Delete i386 specific code.
	(malloc_init_state): Declare inline.
	(malloc_unlocked): Don't perform malloc initialisation check.
	(malloc_consolidate): Likewise.
	(iALLOc, iCALLOc, iCOMALLOc): Delete functions.
	(mUSABLe, mALLINFo, mSTATs, mALLOPt): Delete functions.
	(__ul_malloc_init): New function.

	* sys/_syslib.s (__main): Call __ul_malloc_init.
	(__ul_global): Add entries for '__mutex' and 'malloc_state'.

	* malloc.h (malloc_unlocked): Add prototype.
	(free_unlocked, realloc_unlocked): Add prototypes.
	(malloc_trim_unlocked): Add prototype.
	(__ul_malloc_init): Add prototype.
	* unixlib/asm_dec.s (GBL_OLD_HIMEM): Add.
	(GBL_MUTEX, GBL_MALLOC_GBL): Add.
	* unixlib/unix.h (struct ul_global): Add definition.
	(__ul_global): Declare.

	* pthread/atfork.c (pthread_atfork): Use __ul_global structure
	and use unlocked variants of malloc rather than SUL malloc.
	* pthread/context.c (__pthread_cleanup_idle): Likewise.
	* pthread/create.c (pthread_create): Likewise.
	* pthread/detach.c (pthread_detach): Likewise.
	* pthread/exit.c (pthread_exit): Likewise.
	* pthread/join.c (pthread_join): Likewise.
	* pthread/newnode.c (__pthread_new_node): Likewise.
	* pthread/pthinit.c (__pthread_prog_init: Likewise.

	* pthread/key.c (pthread_key_create): Use unlocked variants of
	malloc and ensure they are called with interrupts disabled.
	(pthread_key_delete): Likewise.
	(pthread_setspecific): Likewise.

	* debug/dvsprintf.c: Compile without stack-checking.
	* source/Makefile.in (debug/dvsprintf.o): New target.

	* unix/open.c (__open_fh): Type fixes for Norcroft [from Stefan
	Bellon].

Tue Apr 26 23:32:44 2005  John Tytgat  <John.Tytgat@aaug.net>

	* unixlib/dev.h (__getdevtype): Added explicit riscosify control
	parameter (not necessarily equal to the __get_riscosify_control()
	value).
	* unix/dev.c (__getdevtype): Likewise.
	* unix/stat.c: Likewise.
	(__fsclose): Don't close RISC OS filehandle when dflag
	FILE_HANDLE_FROM_OS bit is set.
	* unixlib/fd.h: Added comment.
	* unixlib/local.h (__open_fn): Renamed from __open().
	(__open_fh): Similar call to __open_fn() but instead of a filename,
	this gets a RISC OS file handle (from OS).
	* unix/open.c: Likewise.
	* unix/reopen.c: Likewise.
	* stdio/stdio.c: Capitalised first char of __unixlib_fatal() strings.
	* unix/unix.c: Likewise.
	(initialise_unix_io): Directly use the RISC OS filehandles in case of
	CLI redirection.  This results in a significant speed improvement.

Tue Apr 26 15:20:03 2005  Nick Burrett  <nick@sqrt.co.uk>

	Provide new internal debugging function.
	* sys/debug.h (debug_printf): Add prototype.
	* debug/dvsprintf.c: New file.
	* debug/debug.c: Moved here from sys/debug.c.  Re-written
	to use new 'debug_printf' function.
	* unix/unix.c: Use new debug_printf function.
	* sys/stackalloc.c: Likewise.

Mon Apr 25 19:28:15 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/_mem.s: Delete file.

Mon Apr 25 13:32:29 2005  Stefan Bellon  <sbellon@sbellon.de>

	Norcroft compatibility.
	* math.h (isinf, isnan): Provide Norcroft specific definitions.
	* sys/cdefs.h (strong_alias): Fix typo in definition.
	* libm-complex/cabs.c: When __UNIXLIB_NO_COMPLEX is defined,
	do not compile functions that use complex types.
	* libm-complex/{cabsf.c, cabsl.c, carg.c, cargf.c}: Likewise.
	* libm-complex/{cargl.c, cimag.c, cimagf.c, cimagl.c}: Likewise.
	* libm-complex/{conj.c, conjf.c, conjl.c, creal.c}: Likewise.
	* libm-complex/{crealf.c, creall.c}: Likewise.
	* libm-generic/{s_cacos.c, s_cacosf.c, s_cacosh.c}: Likewise.
	* libm-generic/{s_cacoshf.c, s_casin.c, s_casinf.c}: Likewise.
	* libm-generic/{s_casinh.c, s_casinhf.c, s_catan.c}: Likewise.
	* libm-generic/{s_catanf.c, s_catanh.c, s_catanhf.c}: Likewise.
	* libm-generic/{s_ccos.c, s_ccosf.c, s_ccosh.c, s_ccoshf.c}: Likewise.
	* libm-generic/{s_cexp.c, s_cexpf.c, s_clog.c, s_clog10.c}: Likewise.
	* libm-generic/{s_clog10f.c, s_clogf.c, s_cpow.c, s_cpowf.c}: Likewise.
	* libm-generic/{s_cproj.c, s_cprojf.c, s_csin.c, s_csinf.c}: Likewise.
	* libm-generic/{s_csinh.c, s_csinhf.c, s_csqrt.c}: Likewise.
	* libm-generic/{s_csqrtf.c, c_ctan.c, s_ctanf.c, s_ctanh.c}: Likewise.
	* libm-generic/{s_ctanhf.c}: Likewise.

	* libm-generic/s_nextafter.c (nexttoward): Disable aliasing hack
	for Norcroft.
	* libm-generic/w_dremf.c (__dremf): ANSIify function definition.

	* libm-dbl64/s_isinf.c: For Norcroft, #undef __isinf.
	* libm-dbl64/s_isnan.c: For Norcroft, #undef __isnan.

	* string/memrchr.c: For Norcroft and LCC, define the double-underscore
	variant of the function name to the variant without.
	* string/strchrnul.c: Likewise.
	* string/strndup.c: Likewise.
	* string/strnlen.c: Likewise.

Sun Apr 24 22:11:02 2005  Alex Waugh  <alex@alexwaugh.com>

	* unix/unix.c (convert_command_line): Prevent >> type redirections
	  getting added to argv.

Sun Apr 24 21:24:36 2005  John Tytgat  <John.Tytgat@aaug.net>

	* sys/resource.h (getpriority): Use id_t instead of int.
	(setpriority): Likewise.
	* resource/getprior.c (getpriority): Likewise.
	* resource/setprior.c (setpriority): Likewise.
	* unixlib/dev.h (__getdevtype): const non-ptr return value doesn't
	make much sense therefore removed const.
	* unix/dev.c: Likewise.
	* unixlib/os.h: Relaxed several prototypes concerning __nonnull.
	* unixlib/sigstate.h (__backtrace_getfp): Return type is now void*
	instead of int*.
	(__ul_callbackfp): Changed type from int* to unsigned int*.
	* unix.h (struct __sul_process): Changed types of maxfd, fdsize,
	fdhandlesize and environ_size from int to unsigned int.
	Removed __OS_ARTHUR & __OS_RISCOS_* defines.
	(__decstrtoui): Changed constify end parameter.
	(__intenv): Decorated prototype with __nonnull and/or __wur.
	(__runtime_features): Likewise.
	(__atomic_modify): Likewise.
	(__unixlib_signal_initialise): Likewise.
	(__resource_initialise): Likewise.
	(__stackalloc): Likewise.
	(__free_stack_chain): Likewise.
	(__stackalloc_incr_wimpslot): Likewise.
	(__free_process): Likewise.
	(__get_program_name): Likewise & also renamed from get_program_name.
	* unix/unix.c (__decstrtoui): Changed constify end parameter.
	* netlib/htons.s (htons): Removed.
	* netlib/htonl.s (ntonl): Removed.
	* netlib/_bswap_16.s: Exported __bswap_16 as htons and ntohs.
	* netlib/_bswap_32.s: Exported __bswap_32 as htonl and ntohl.
	* netlib/getnameinfo.c: Compiler warning fixing.
	* signal/post.c: Likewise.
	* sys/debug.c: Likewise.
	* time/strftime.c: Likewise.
	* unix/dirent.c: Likewise.
	* unix/select.c: Likewise.
	* unix/sync.c: Likewise.
	* unix/syslog.c: Likewise.
	* unix/tty.c: Likewise.
	* unix/unlink.c: Likewise.
	* signal/_coredump.s (__backtrace_fp): Add functionname in object code.
	* signal/_signal.s: "Unixlib" -> "UnixLib".
	* sys/_syslib.s: Likewise.
	* unix/custom.c: Likewise.
	* stdio/rename.c (rename): Failure to delete destination file is no
	longer ignored.
	* sys/_os.s: CMP -> TEQ for consistency reasons.
	* sys/mman.c: Rename get_program_name to __get_program_name.
	* unix/features.c: Likewise.
	* unix/getenv.c: 0 -> NULL.
	* unix/nice.c (nice): Added unistd.h include to get nice() prototype.

Sun Apr 24 21:04:12 2005  Alex Waugh  <alex@alexwaugh.com>

	* common/unixify.c: Fix buffer overflow.

Sun Apr 24 12:34:09 2005  Peter Naulls  <peter@chocky.org>

	* clib/dirent.h, clib/grp.h: Make types used visible by including
	  sys/types.h instead.

Sun Apr 24 11:08:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/atoll.c: New file.

Sun Apr 24 10:54:22 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/strtoll.c: Import from FreeBSD, includes bug fixes.
	* stdlib/strtoull.c: Likewise.
	* limits.h: Add namespace visibility for _POSIX and _POSIX2 limits.
	(LLONG_MIN, LLONG_MAX, ULLONG_MAX): New ISO C99 limits.
	(WORD_BIT, LONG_BIT): New limits, defined for XOPEN.

Sat Apr 23 13:14:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* libm-generic/w_lgammal_r.c: Delete file.
	* libm-generic/e_lgammal_r.c: Delete file.
	* complex.h: No implementation for Norcroft or LCC compilers.
	* sys/cdefs.h (__UNIXLIB_NO_COMPLEX): Define for Norcroft and LCC
	compilers.

Sat Apr 23 11:51:31 2005  Stefan Bellon  <sbellon@sbellon.de>

	Norcroft compatibility.
	* time/setitmr.c (__inline): Renamed from __inline__.
	(__inline__): Delete macro as it is provided in sys/cdefs.h.
	* stdlib/alloc.c (mUSABLe): Compile out prototype.
	(mSTATs, mALLOPt, mALLINFo): Likewise.
	* search/lsearch.c (lfind): Casting fixes.
	(lsearch): Casting fixes.

	* libm-dbl64/s_nexttoward.c: Delete empty file.
	* libm-dbl64/{k_cos.c, k_sin.c, s_cos.c, e_acos.c}: Likewise.

Sat Apr 23 11:42:48 2005  Nick Burrett  <nick@sqrt.co.uk>

	Initial work on accessing internal UnixLib variables through
	one structure -- __ul_global.  Apply small optimisations
	based on a common symbol address.
	* unixlib/asm_dec.s (GBL_*): New definitions.
	* pthread/_context.s (__pthread_start_ticker): Use new __ul_global
	structure.
	(pthread_call_every): Likewise; improve code density.
	(__pthread_callback): Likewise.
	(__pthread_callback_semaphore): Delete.
	(__pthread_system_running): Delete.
	(__pthread_callback_missed): Delete.
	* pthread/_ints.s (__pthread_return_address): Delete.
	(__pthread_worksemaphore): Delete.
	* pthread/_yield.s (pthread_yield): Use __ul_global structure.
	* signal/_signal.s (raise): Use __ul_global structure.
	(__h_cback): Likewise.
	(__h_cback_common): Likewise.
	(__setup_signalhandler_stack): Likewise.
	(__executing_signalhandler): Delete.
	(__signalhandler_sl): Delete.
	(__signalhandler_sp): Delete.
	* pthread/context.c (__pthread_num_running_threads): Delete.
	* sys/_syslib.s (__main): Use 'GBL_' definitions for referencing
	__ul_global.
	(signalhandler_overflow): Likewise.
	(__unixlib_fatal): Likewise.
	(_kernel_fpavailable): Likewise.
	(__upcall_handler_addr): Move into __ul_global structure.
	(__upcall_handler_r12): Likewise.
	(__ul_global): Defined.  Renamed from 'struct_base'.
	(__upcall_handler_addr, __upcall_handler_r12): Define.
	(__pthread_return_address, __pthread_worksemaphore): Define.
	(__pthread_callback_semaphore, __pthread_system_running): Define.
	(__pthread_callback_missed): Define.
	(__pthread_num_running_threads): Define.
	(__executing_signalhandler): Define.
	(__signalhandler_sl, __signalhandler_sp): Define.

	* pthread/atfork.c (pthread_atfork): If called, set
	__pthread_system_running.

Fri Apr 22 15:33:14 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* unixlib/asm_dec.s (__get_errno): Change PTHREADS check to
	__UNIXLIB_ERRNO_THREADED.  Import 'errno' symbol only
	when ERRNO_THREADED is 0.
	(__set_errno): Likewise.
	* sys/_syslib.s (errno): Delete definition as it breaks Norcroft
	assembler.
	* stdlib/errno.c: New file.

	* sys/cdefs.h: Provide Norcroft and LCC specific macro definitions.
	(__SYS_CDEFS_H): Renamed from _SYS_CDEFS_H.
	* features.h: Use __SYS_CDEFS_H.

	* signal/_signal.s (__seterr): Check __pthread_running_thread
	is valid and exit fatally if not.

	* signal/post.c (__valid_address): Delete function.  To preserve
	stack space during signal handling, re-write in assembler.
	* sys/_syslib.s (__valid_address): New function.

	Fix pthread race conditions and improve commentary.
	* pthread/_context.s (__pthread_callback): Check that we are
	actually going to perform a context switch before setting up
	an otherwise unnecessary signal handler stack.  Turn IRQs off
	earlier, therefore setting more internal state without the chance
	of interruption.
	(skip_contextswitch): Fall through rather than using common code
	of the old callback_return.
	* pthread/newnode.c (__pthread_new_node): Use SUL memory functions
	for allocating space for pthread structure to prevent a race
	condition between 'free' and __pthread_cleanup_idle.
	* pthread/contex.c (__pthread_cleanup_idle): Use the SUL memory
	functions.
	* pthread/create.c (pthread_create): Don't call __pthread_init.
	Set __pthread_system_running directly.  Use SUL memory functions.
	* pthread/detach.c (pthread_detach): Use SUL memory functions.
	* pthread/exit.c (pthread_exit): Enable interrupts around call
	to __pthread_exit to prevent possible assertion failure when
	freeing 'alloca' chains.
	* pthread/join.c (pthread_join): Use SUL memory functions.
	* pthread/pthinit.c (__pthread_prog_init): Allocate 'saved_context'
	memory here.
	(__pthread_init): Delete function and move useful functionality
	into __pthread_prog_init.
	* pthread.h (__pthread_init): Delete prototype.

	Compilation fixes.
	* common/fdname.c (__fd_to_name): Add explicit cast for malloc.
	* common/riscosify.c (__sfixinit): Likewise.
	* common/unixify.c (__unixify): Likewise.
	* crypt/crypt-entry.c: Convert function definitions to ISO-C form.
	* crypt/crypt_util.c: Likewise.
	(_ufc_clearmem, _ufc_copymem): Ensure we use 'memset' and 'memcpy'
	rather than slow internal versions.
	* crypt/md5-crypt.c: Convert function definitions to ISO-C form.
	(b64t): Fix array size.
	* crypt/md5.c: Convert function definitions to ISO-C form.
	* gdtoa/dmisc.c (nrv_alloc): Constify 's'.
	* gdtoa/gdtoaimp.h (nrv_alloc): Fix prototype accordingly.

Fri Apr 22 09:32:50 2005  Nick Burrett  <nick@sqrt.co.uk>

	* dirent.h (alphasort): Change to BSD and MISC visibility.

Thu Apr 21 16:53:32 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* libm-dbl64/tbl_asincos.h: Renamed from asincos.tbl.
	* libm-dbl64/tbl_powtwo.h: Renamed from powtwo.tbl
	* libm-dbl64/tbl_root.h: Renamed from root.tbl
	* libm-dbl64/tbl_sincos.h: Renamed from sincos.tbl
	* libm-dbl64/tbl_uatan.h: Renamed from uatan.tbl
	* libm-dbl64/tbl_uexp.h: Renamed from uexp.tbl
	* libm-dbl64/tbl_ulog.h: Renamed from ulog.tbl
	* libm-dbl64/tbl_upow.h: Renamed from upow.tbl
	* libm-dbl64/tbl_utan.h: Renamed from utan.tbl
	* libm-dbl64/dosincos.c: Use new filenames.
	* libm-dbl64/{e_asin.c, e_atan2.c, e_exp.c, e_log.c}: Likewise.
	* libm-dbl64/{e_pow.c, e_sqrt.c, s_atan.c, s_sin.c}: Likewise.
	* libm-dbl64/s_tan.c: Likewise.

	* unixlib/buildoptions.s: Commit auto-generated file.

Thu Apr 21 16:02:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* pthread/sem.c (sem_check_validity): New function.
	(sem_alloc): Delete function; incorporate into sem_init.
	(sem_init): 'sem' is already allocated memory; use it rather than
	making our own internal allocation with malloc.
	(sem_free): No need to free sem structure here.  Make inline.
	(sem_destroy): Always check for errors using sem_check_validity.
	(sem_trywait): Likewise.
	(sem_post): Likewise.
	(sem_getvalue): Likewise.
	(sem_wait): Likewise.  Cope with an empty usem_waiters queue.
	Add PTHREAD_SAFE_CANCELLATION.

Wed Apr 20 18:10:04 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stpcpy.c: Move into string subdirectory.
	* stpncpy.c, strcat.c, strchr.c, strcmp.c, strcspn.c: Likewise.
	* strdup.c, strichr.c, stricmp.c, strncat.c: Likewise.
	* strncmp.c, strncpy.c, strnicmp.c, strpbrk.c: Likewise.
	* strrchr.c, strrichr.c, strsep.c, strsignal.c: Likewise.
	* strspn.c, strstr.c, strtok.c, strtok_r.c: Likewise.
	* strtol.c, strtoll.c, index.c, memccpy.c: Likewise.
	* memchr.c, memcmp.c: Likewise.

	* strtoumax.c: Move into inttypes subdirectory.
	* strtoimax.c: Likewise.

	* strtol.c: Move into stdlib subdirectory.
	* strtoll.c, strtoul.c, strtoull.c: Likewise.
	* abort.c, atexit.c, bsearch.c, div.c, qsort.c: Likewise.
	* alloc.c, system.c: Likewise.

	* assert.c: Move into assert subdirectory.

	* ctype.c: Move into ctype subdirectory.
	* ctypeproc.c: Likewise.

	* opensock.c: Move into resolv subdirectory.

	* psignal.c: Move into signal subdirectory.

	* termcap.c: Move into termios subdirectory.

Wed Apr 20 17:54:40 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdio/vfprintf.c (__vfprintf): Output of printf("%#.0o", 0)
	should print 0.
	* stdio/fwrite.c (fwrite): When handling fd of -1, return early
	if we have no space in the output buffer.
	* signal/post.c (__write_backtrace): Account for 26-bit mode
	when disassembling.

Wed Apr 20 14:15:44 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* stdio.h (__vfprintf): Add prototype.
	* stdio/vfprintf.c (__find_arguments [TP_SIZET]): Use 'size_t'
	[from Stefan Bellon].
	* stdio/printf.c (vsnprintf): Remove '__' from function name.
	(vsprintf, snprintf, sprintf): Likewise.
	(vprintf, fprintf, printf): Likewise.
	* internal/math.h: Add macros to remove the double-underscores
	from function.
	* libm-generic/s_fma.c: Include math_private.h to pick up this change.
	* libm-generic/s_fmaf.c: Likewise.
	* libm-generic/s_fdim.c: Likewise.
	* libm-generic/s_fdimf.c: Likewise.
	* libm-generic/s_fmax.c: Likewise.
	* libm-generic/s_fmaxf.c: Likewise.
	* libm-generic/s_fmin.c: Likewise.
	* libm-generic/s_fminf.c: Likewise.
	* libm-generic/s_cacos.c: Likewise.
	* libm-generic/s_cacosf.c: Likewise.
	* libm-generic/s_casin.c: Likewise.
	* libm-generic/s_casinf.c: Likewise.
	* libm-generic/s_casinh.c: Likewise.
	* libm-generic/s_casinhf.c: Likewise.
	* libm-generic/s_ccos.c: Likewise.
	* libm-generic/s_ccosf.c: Likewise.
	* libm-generic/s_cpow.c: Likewise.
	* libm-generic/s_cpowf.c: Likewise.
	* libm-generic/s_cproj.c: Likewise.
	* libm-generic/s_cprojf.c: Likewise.
	* libm-generic/s_nan.c: Likewise.
	* libm-generic/s_nanf.c: Likewise.
	* libm-generic/w_drem.c: Likewise.

	* sys/types.h (ino_t): Define.
	* dirent.h (ino_t): Only define if __USE_XOPEN.

	* unixlib/buildoptions.h: Add comment to remind us why defining
	__UNIXLIB_ERRNO_THREADED is a bad idea.

Tue Apr 19 19:52:29 2005  Nick Burrett  <nick@sqrt.co.uk>

	* iconv.h (EILSEQ): Kill definition.

Tue Apr 19 19:28:59 2005  Nick Burrett  <nick@sqrt.co.uk>

	Make threaded 'errno' a compile time option.
	* unixlib/buildoptions.h (__UNIXLIB_ERRNO_THREADED): Define as zero.
	* pthread/context.c (__pthread_context_switch): When above
	macro is zero, save the global errno between context switches.
	* errno.h (errno): Only use the threaded version if
	__UNIXLIB_FEATURE_PTHREADS and __UNIXLIB_ERRNO_THREADED are
	non-zero.
	* sys/_syslib.s (errno): Define if __UNIXLIB_ERRNO_THEADED is
	non-zero.

Tue Apr 19 09:48:33 2005  Stefan Bellon  <sbellon@sbellon.de>

	Norcroft compatibility.
	* unixlib/asm_dec.s (__set_errno): IMPORT __pthread_running_thread.
	(__get_errno): Likewise.
	* signal.h (sigpause): Fix comment termination typo.
	* common/riscosify.c (sfix_hash): Use __inline for Norcroft
	compatibility.
	* locale/iconv.c: Change ordering of includes.
	(iconv_open): Add explicit cast to return value.
	* stdio/asprintf.c: Include stdio.h
	(asprintf): Renamed from __asprintf.
	* stdio/vasprintf.c (vasprintf): Renamed from __vasprintf.
	* sys/_syslib.s (errno): Fix __UNIXLIB_FEATURE_PTHREADS check.
	* stdlib/atof.c: New file.

Mon Apr 18 22:25:46 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/stdcmac.h: Delete file.
	* unixlib/stdsmac.s: Delete file.
	* unixlib/buildoptions.h: Reformat and remove 'COMMENT' and 'END'.
	* source/Makefile.in (clib/unixlib/buildoptions.s): New target.
	* unixlib/asm_dec.s: Use it rather than buildoptions.h
	* gen-makefiles.pl: For assembler files, depend on buildoptions.s.

	* pthread/context.c (__pthread_context_switch): Don't save/restore
	global errno between contexts.

Mon Apr 18 20:40:46 2005  Nick Burrett  <nick@sqrt.co.uk>

	* errno.h: Use correct path to features.h.
	* features.h: Move the inclusion of unixlib/stdcmac.h and
	unixlib/buildoptions.h outside of __UNIXLIB_INTERNALS.

Mon Apr 18 20:27:21 2005  Nick Burrett  <nick@sqrt.co.uk>

	* errno.h: Change #ifdef to #if for __UNIXLIB_FEATURE_PTHREADS.

Mon Apr 18 18:03:56 2005  Nick Burrett  <nick@sqrt.co.uk>

	Make 'errno' thread local.
	Add option to __seterr to prevent the setting of 'errno',
	rename to __ul_seterr and update all callers.
	* signal/_signal.s (__ul_seterr): Renamed from '__seterr'.
	If 'a2' is non-zero, then do not set errno.
	Perform NULL-check on __pthread_running_thread.
	* unixlib/os.h (__ul_seterr): Add seterrno parameter to prototype.
	* unixlib/asm_dec.s (__set_errno): For thread support, use the
	local thread errno rather than the global errno.
	(__get_errno): Likewise.
	* errno.h (__set_errno): Likewise.
	* errno.c: Delete file.
	* sys/_syslib.s (errno): Define when not compiling with thread
	support.

	* pthread/pthinit.c (__pthread_prog_init): Die if __pthread_new_node
	fails.

	* gdtoa/gdtoaimp.h (ACQUIRE_DTOA_LOCK): Check __pthread_system_running
	rather than __pthread_running_thread.
	(FREE_DTOA_LOCK): Likewise.

	* common/fdname.c (__fd_to_name): Don't set errno.
	* common/objattr.c (__object_get_attrs): Likewise.
	(__object_set_attrs): Likewise.
	* locale/iconv.c (iconv_error): Likewise.
	* netlib/_net_error.s (__net_error): Likewise.
	* unix/chmod.c (chmod): Likewise.
	* unix/dev.c (__fsfsstat): Likewise.
	* unix/dirent.c (readdir_r): Likewise.
	* unix/fchmod.c (fchmod): Likewise.
	* unix/rmdir.c (rmdir): Likewise.

	* locale/iconv.c (iconv_open): Set errno.
	* sound/dsp.c (__dspopen): Likewise.
	(__dspwrite): Likewise.
	* sys/mman.c (munmap): Likewise.
	(mremap): Likewise.
	* time/clk_gettime.c (clock_gettime): Likewise.
	* time/gettod.c (gettimeofday): Likewise.
	* time/time.c (time): Likewise.
	* unix/chdir.c (chdir): Likewise.
	* unix/dev.c (__fsopen): Likewise.
	(__fsclose, __fsread, __fswrite, __fslseek): Likewise.
	(__randomopen, __randomread): Likewise.
	* unix/dirent.c (newstream): Likewise.
	* unix/getcwd.c (getcwd): Likewise.
	* unix/getenv.c (__getenv_from_os): Likewise.
	* unix/gethostnam.c (fakehostname): Likewise.
	* unix/mkdir.c (mkdir): Likewise.
	* unix/setenv.c (__addenv_to_os): Likewise.
	* unix/sync.c (fsync): Likewise.
	* unix/truncate.c (ftruncate): Likewise.
	(truncate): Likewise.
	* unix/unlink.c (unlink): Likewise.
	* unix/utime.c (utime): Likewise.
	* scl/_kswi.s: Likewise.
	* scl/_ksetenv.s: Likewise.
	* scl/_kosrdch.s: Likewise.
	* scl/_kosgbpb.s: Likewise.
	* scl/_kosfind.s: Likewise.
	* scl/_kosfile.s: Likewise.
	* scl/_koscli.s: Likewise.
	* scl/_kosbyte.s: Likewise.
	* scl/_kosargs.s: Likewise.
	* scl/_kgetenv.s: Likewise.
	* scl/_kernel.s: Likewise.

	* unix/unix.c (__unixinit): Drop call to '__seterr'.
	* scl/_kosbput.s: Likewise.
	* scl/_kosbyte.s: Likewise.

	* unix/rename.c (rename): Set 'errno'.  Don't need to preserve 'errno'
	across function.

	* sys/mman.c (__munmap_all): Remove PTHREAD_UNSAFE as the thread
	system should not be running at this time.

	* scl/_koswrch.s: Delete file.
	* scl/_kosword.s: Delete file.
	* sys/_os.s (__os_vdu): Define _kernel_oswrch to the same function.
	Set return value to zero on success.
	(__os_word): Simarly for _kernel_osword.

Mon Apr 18 14:44:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unix/getpagesiz.s: Delete file.
	* unistd/getpagesiz.c: New file.
	* sys/_syslib.s (__main): Call XOS_ReadMemMapInfo and store the
	system page size.
	(__ul_pagesize): Define.
	* unixlib/unix.h (__ul_pagesize): Declare.
	* sys/mman.c (page_size): Delete.
	(page_align): Define in terms of __ul_pagesize.
	(mmap): Don't call 'getpagesize', use the internal variable directly.
	* unix/sysconf.c (sysconf): Likewise.
	* alloc.c (malloc_getpagesize): Use __ul_pagesize.

	Make the malloc functions thread safe.
	* alloc.c (USE_MALLOC_LOCK): Define.
	(MALLOC_PREACTION): Check pthread system is running first.
	(MALLOC_POSTACTION): Likewise.
	(mALLOc): Delete PTHREAD_UNSAFE.
	(fREe): Likewise.
	(rEALLOc): Likewise.
	(mEMALIGn): Likewise.
	(cALLOc): Likewise.
	(iALLOc): Likewise.
	(vALLOc): Likewise.
	(pVALLOc): Likewise.
	(mTRIm): Likewise.

Mon Apr 18 12:26:48 2005  Peter Naulls  <peter@chocky.org>

	* source/unix/rmdir.c, clib/unixlib/unix.h: Improve language.
	* clib/unixlib/dev.h, source/unix/custom.c: Add a function to
	  hide some internal structures from programs trying to override
	  file descriptor handling.

Thu Apr 14 23:59:26 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* endian.h: Update missed file

Thu Apr 14 17:01:30 2005  Nick Burrett  <nick@sqrt.co.uk>

	* search.h: New file.
	* search/insremque.c: New file.
	* search/lsearch.c: New file.
	* search/hsearch.c: New file.
	* search/hsearch_r.c: New file.
	* search/tsearch.c: New file.

	* signal.h: Improve namespace and type conformance.
	Add GCC's 'nonnull' attribute to prototypes.
	Remove __THROW for any functions that are cancellation points.
	* time.h: Likewise.
	* pthread/pthsignal.c (sigwait): Mark as a safe cancellation point.

Thu Apr 14 16:15:32 2005  Nick Burrett  <nick@sqrt.co.uk>

	* clib/unixlib/swiparams.h: Move file ...
	* incl-local/internal/swiparams.h: ... here.

	* clib/unixlib/tty.h: Move file ...
	* incl-local/internal/tty.h: ... here.

	* common/objattr.c: Use new swiparams.h location.
	* common/riscosify.c: Likewise.
	* common/unixify.c: Likewise.
	* sound/dsp.c: Likewise.
	* stdio/rename.c: Likewise.
	* unix/chmod.c: Likewise.
	* unix/custom.c: Likewise.
	* unix/dev.c: Likewise.
	* unix/dirent.c: Likewise.
	* unix/fchmod.c: Likewise.
	* unix/fstat.c: Likewise.
	* unix/mkdir.c: Likewise.
	* unix/rmdir.c: Likewise.
	* unix/stat.c: Likewise.
	* unix/unix.c: Likewise.
	* unix/unlink.c: Likewise.
	* unix/utime.c: Likewise.

	* unixlib/unix.h: Use new tty.h location.
	* unix/tty.c: Likewise.

Thu Apr 14 15:26:01 2005  Nick Burrett  <nick@sqrt.co.uk>

	Import an accurate IEEE math library
	* bits/fenv.h: New file.
	* bits/huge_valf.h: New file.
	* bits/huge_vall.h: New file.
	* bits/huge_val.h: Split into its constituent parts.
	* bits/inf.h: New file.
	* bits/nan.h: Use builtin for GCC 3.3 and later.
	* bits/cmathcalls.h: Bring in line with new math library.
	* bits/mathcalls.h: Likewise.
	* bits/mathdef.h: Likewise.
	* bits/mathinline.h: Likewise.
	* fenv.h: Likewise.
	* math.h: Likewise.
	* complex.h: Likewise.
	* fpu_control.h: New file.
	* ieee754.h: Moved here from machine/ieee754.h.
	* endian.h: Moved here from machine/endian.h.

	* complex: Delete directory.
	* math: Delete directory.
	* math-asm: Delete directory.

	* fenv: New directory.
	* libm-complex: New directory.
	* libm-dbl64: New directory.
	* libm-flt32: New directory.
	* libm-generic: New directory.
	* libm-support: New directory.

	* fpu_control.h (__unixlib_get_fpstatus): Moved here from
	unixlib/unix.h.
	(__unixlib_set_fpstatus): Likewise.
	* unixlib/unix.h: Delete above prototypes.

	* incl-local: New directory.  Container for all UnixLib build
	specific header files.
	* incl-local/README: New file.
	* incl-local/math_private.h: New file, for source code compatibility
	with main libm library.
	* incl-local/internal/math.h: Renamed from unixlib/math.h
	and updated for new IEEE math library.

	* Makefile.in (INCLUDES): Use 'incl-local'.
	(LIBM_FLAGS): Define.
	(CROSS_CFLAGS): Include LIBM_FLAGS.
	(WARNINGS): Drop -Wno-long-long.
	* gen-makefiles.pl (find_headers): Support multiple include dirs.
	Search 'incl-local' for headers.

	* clib/stdio_ext.h: Delete file.
	* incl-local/stdio_ext.h: New blank file.
	* clib/stdio-common/stdio_ext.h: Delete file.

	* unixlib/os.h (__os_swi): Remove __wur.
	(__os_byte): Remove __nonnull and __wur.

Thu Apr 14 13:12:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	* grp.h: Improve namespace and type conformance.
	Add GCC's 'nonnull' attribute to prototypes.
	Remove __THROW for any functions that are cancellation points.
	* kernel.h: Likewise.
	* locale.h: Likewise.
	* nl_types.h: Likewise.
	* pwd.h: Likewise.
	* unixlib/os.h: Likewise.
	* semaphore.h: Likewise.

	* locale/iconv.c (iconv_open): Add PTHREAD_SAFE_CANCELLATION.
	Use __os_swi rather than _swix.  Specify a minimum module version
	of 0.04.
	(iconv): Likewise.
	(iconv_close): Likewise.

	* grp/fgetgrent.c (fgetgrent): Add PTHREAD_UNSAFE_CANCELLATION.
	* grp/getgrgid.c (getgrgid): Likewise.
	* grp/getgrnam.c (getgrnam): Likewise.
	* grp/fgetgrentr.c (fgetgrentr): Add PTHREAD_SAFE_CANCELLATION.
	* grp/getgrgid_r.c (getgrgid_r): Likewise.
	* grp/getgrnam_r.c (getgrnam_r): Likewise.
	* grp/getgrent.c (getgrent): Add PTHREAD_UNSAFE_CANCELLATION.
	(setgrent): Likewise.
	(endgrent): Likewise.
	(getgrent_r): Mark as a safe cancellation point.
	* grp/getgroups.c (initgroups): Change to PTHREAD_UNSAFE_CANCELLATION.
	(getgroups): Likewise.
	* pwd/fgetpwent.c (fgetpwent): Mark as an unsafe cancellation point.
	* pwd/getlogin.c (getlogin): Likewise.
	* pwd/fgetpwentr.c (fgetpwentr): Mark as a safe cancellation point.
	* pwd/getpwnam_r.c (getpwnam_r): Likewise.
	* pwd/getpwuid_r.c (getpwuid_r): Likewise.
	* pwd/getpwent.c (getpwent_r): Likewise.
	(getpwent): Make as an unsafe cancellation point.
	(endpwent): Likewise.
	(setpwent): Likewise.
	* pwd/getpwnam.c (getpwnam): Likewise.
	* pwd/getpwuid.c (getpwuid): Likewise.
	* pwd/putpwent.c (putpwent): Likewise.

	* stdio.h (struct __iobuf): Add 'lock' as a placeholder for
	multithreaded I/O support.
	(fgets): Fix definition.
	* stdio/fgets.c (fgets): Fix function definition.

	* pthread.h (struct __pthread_thread): Rename 'param' to '__param'.
	Add '__policy'.
	(pthread_getschedparam): Fix prototype.
	* pthread/schedparam.c (pthread_getschedparam): Fix function
	definition and get thread policy.
	(pthread_setschedparam): Set thread policy.

	* ulimit.h (ulimit): Correct prototype.
	* resource/ulimit.c (ulimit): Function takes a variable number
	of args.  Adjust accordingly.

	* unistd.h (sync): Function never returns a result
	* unix/sync.c (sync): Don't bother with any errors returned
	by __os_args call.
	(fsync): Mark that this is a cancellation point.

	* dirent.h (ino_t): Define here.
	* sys/types.h (ino_t): Remove definition from here.

	* abs.c: Delete file.
	* stdlib/abs.c: New file.
	* stdlib/labs.c: New file.
	* stdlib/llabs.c: New file.

	* pthinit.c: Renamed from init.c for ELF compatibility.
	* pthsignal.c: Renamed from signal.c for ELF compatibility.

Wed Apr 13 20:17:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/cdefs.h (__NTH): Declare for non-GCC compilers.
	(__attribute_warn_unused_result__): Declare.
	(__wur): Declare (shorthand for above).

	* string.h: Improve namespace and type conformance.
	Add GCC's 'nonnull' attribute to prototypes.
	Remove __THROW for any functions that are cancellation points.
	* sys/stat.h: Likewise.
	* sys/select.h: Likewise.
	* sys/resource.h: Likewise.
	* netdb.h: Likewise.
	* crypt.h: Likewise.
	* dirent.h: Likewise.
	* fcntl.h: Likewise.
	* setjmp.h: Likewise.
	* stdio.h: Likewise.
	* stdlib.h: Likewise.
	* unistd.h: Likewise.

	* sys/resource.h (ulimit): Remove declaration.
	(nice): Likewise.
	* ulimit.h: New file.
	* unistd.h (nice): Add prototype.
	* resource/ulimit.c: Include ulimit.h.

	* alloca.h (alloca): Remove __THROW.  Add GCC variant.
	* assert.h (assert): Add noreturn attribute.
	(__ASSERT_CAST): Define with better C++ support.
	(assert): Use it.

	* ctype.h (isascii): Set visibility for SVID, MISC and XOPEN only.

	* iconv.h: Don't include errno.h.
	(iconv): Add 'restrict' to certain parameters.
	* locale/iconv.c: Include errno.h.

	* sys/select.h (__NFDBITS): Rename from NFDBITS.  Define sizeof
	in terms of variable name, rather than type.
	(__FDELT): Rename from FDELT.
	(__FDMASK): Rename from FDMASK.
	(__fd_set): Fix according to new macro names.
	(FD_SET): Likewise.
	(FD_CLR): Likewise.
	(FD_ISSET): Likewise.
	(fd_mask): Only define if __USE_MISC.
	(select): Add C99's 'restrict' qualifier.
	(pselect): Likewise.

	* sys/stat.h (struct stat): Change the types of 'st_blksize'
	and 'st_blocks'.

	* sys/time.h (timeradd): Define.
	(timersub): Define.

	* unix/dirent.c (opendir): Mark as an unsafe cancellation point.
	(readdir_r): Likewise.
	(readdir): Likewise.
	(closedir): Likewise.
	(scandir): Likewise.

	* features.h (BSD): Undefine.
	(__builtin_expect): Only undefine for non-GCC compilers.
	(__GLIBC_PREREQ): Delete macro.
	(__ULIBC_PREREQ): Define macro.
	* resolv/gethnamaddr.c (BSD): Define.

	* pthread.h: Make compatible with C++.
	(pthread_setschedparam): Add prototype.
	(pthread_getschedparam): Add prototype.
	(struct __pthread_thread): Add 'param'.
	* schedparam.c: New file.

	* time/time.c (time): Fix shadow parameter warning.
	* time/setitmr.c (add_ticker): Likewise.
	(check_ticker): Likewise.
	* resource/getrusage.c (getrusage): Likewise.
	* time/strftime.c (strftime): Likewise.
	(territory_convert): Adjust prototype to reduce warnings.
	(territory_standard): Likewise.
	* signal/post.c (__write_backtrack): Fix printf warnings.
	* crypt/crypt.c (_ufc_doit_r): Use ANSI-style declarations.
	* common/unixify.c (__unixify): Add parenthesis to resolve an
	ambiguity.
	* bsearch.c (bsearch): Fix warnings.

Fri Apr  8 23:31:14 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/unixlib/unix.h (__escape_disabled): Define variable.
	* source/unix/unix.c: Record if the escape key is disabled on
	  program initialisation.
